#include <stdio.h>
#include <string.h>
#include "define.h"
static int cond;
static int immd;
static int rs1;
static int rs2;
static int rs3;
static int rd;
static int rd2;
static int OP;
static int OP2;
static int msize;
static int msex;
static int mwback;
static int bit_pos;
static int post_index;

static int d_N;
static int d_S;
static int d_R;
static unsigned long long int tmask;
static unsigned long long int wmask;
static int nzcv;

static int inst_reg;
static PC;

static int v64;
static int opcode;
static int opcode2;
static int op;
static int op1;
static int op2;
static int op3;
static int op4;
static int op5;

static char* CondName[16]= {
  "eq",
  "ne",
  "cs",
  "cc",
  "mi",
  "pl",
  "vs",
  "vc",
  "hi",
  "ls",
  "ge",
  "lt",
  "gt",
  "le",
  "",
  ""
};

static char* RegName(int m, int sf)
{
  if(m==32){
    if(sf)
      return "sp";
    else
      return "wsp";
  }
  if(sf){
    switch(m){
    case 0:
      return "x0";
    case 1:
      return "x1";
    case 2:
      return "x2";
    case 3:
      return "x3";
    case 4:
      return "x4";
    case 5:
      return "x5";
    case 6:
      return "x6";
    case 7:
      return "x7";
    case 8:
      return "x8";
    case 9:
      return "x9";
    case 10:
      return "x10";
    case 11:
      return "x11";
    case 12:
      return "x12";
    case 13:
      return "x13";
    case 14:
      return "x14";
    case 15:
      return "x15";
    case 16:
      return "x16";
    case 17:
      return "x17";
    case 18:
      return "x18";
    case 19:
      return "x19";
    case 20:
      return "x20";
    case 21:
      return "x21";
    case 22:
      return "x22";
    case 23:
      return "x23";
    case 24:
      return "x24";
    case 25:
      return "x25";
    case 26:
      return "x26";
    case 27:
      return "x27";
    case 28:
      return "x28";
    case 29:
      return "x29";
    case 30:
      return "x30";
    case 31:
      return "xzr";
    }
  }
  else{
    switch(m){
    case 0:
      return "w0";
    case 1:
      return "w1";
    case 2:
      return "w2";
    case 3:
      return "w3";
    case 4:
      return "w4";
    case 5:
      return "w5";
    case 6:
      return "w6";
    case 7:
      return "w7";
    case 8:
      return "w8";
    case 9:
      return "w9";
    case 10:
      return "w10";
    case 11:
      return "w11";
    case 12:
      return "w12";
    case 13:
      return "w13";
    case 14:
      return "w14";
    case 15:
      return "w15";
    case 16:
      return "w16";
    case 17:
      return "w17";
    case 18:
      return "w18";
    case 19:
      return "w19";
    case 20:
      return "w20";
    case 21:
      return "w21";
    case 22:
      return "w22";
    case 23:
      return "w23";
    case 24:
      return "w24";
    case 25:
      return "w25";
    case 26:
      return "w26";
    case 27:
      return "w27";
    case 28:
      return "w28";
    case 29:
      return "w29";
    case 30:
      return "w30";
    case 31:
      return "wzr";
    }
  }
}

static char* DecodeRegExtend(int op)
{
  switch(op){
  case 0:
    return "uxtb";
  case 1:
    return "uxth";
  case 2:
    return "uxtw";
  case 3:
    return "uxtx";
  case 4:
    return "sxtb";
  case 5:
    return "sxth";
  case 6:
    return "sxtw";
  case 7:
    return "sxtx";
  }
  return "";
}

static char bufShiftReg[100];

static char* ShiftReg(int m, int ty, int sa)
{
  switch(ty){
  case 0:/* LSL */
    sprintf(bufShiftReg,"%s, lsl #0x%x\0",RegName(m,v64),sa);
    break;
  case 1:/* LSR */
    sprintf(bufShiftReg,"%s, lsr #0x%x\0",RegName(m,v64),sa);
    break;
  case 2:/* ASR */
    sprintf(bufShiftReg,"%s, asr #0x%x\0",RegName(m,v64),sa);
    break;
  case 3:/* ROR */
    sprintf(bufShiftReg,"%s, ror #0x%x\0",RegName(m,v64),sa);
    break;
  }
  return bufShiftReg;
}

static char bufLSLReg[100];
static char* LSLReg(int m, int siz, int sft)
{
  sprintf(bufLSLReg,"%s, lsl #%d\0",RegName(m,v64),(sft)? siz : 0);
  return bufLSLReg;
}

static char bufExtendReg[100];
static char* ExtendReg(int m, int ty, int sft)
{
  sprintf(bufExtendReg,"%s, %s #%d\0",RegName(m,v64),DecodeRegExtend(ty),sft);
  return bufExtendReg;
}

static void dis_undef(void)
{
  printf(".word\t0x%08x\n",inst_reg);
  //  exit(1);
}

static void dis_pc_rel(void)
{
  int addr;
  rd  = (inst_reg)&0x1f;
  immd = (long long int)((((inst_reg>>5)&0xfffffLL)<<2)|((inst_reg>>29)&3));
  immd = (immd & (1<<21))? 0xffffffffffc00000LL | immd : 0x3fffffLL & immd;
  v64 = 1;
  if((inst_reg>>31)&1){/* ADRP */
    addr = (int)(immd<<12)+(PC&0xfffff000);
    printf("adrp\tx%d, 0x%08x\n",rd,addr);
  }
  else{/* ADR */
    addr = PC + (int)immd;
    printf("adr\tx%d, 0x%08x\n",rd,addr);
  }
}


static void dis_add_sub_i(void)
{
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  rd  = inst_reg & 0x1f;
  rs1 = (inst_reg>>5)&0x1f;
  immd =(long long)((inst_reg>>10)&0xfff);
  if((inst_reg>>22)&1)
    immd = immd<<12;
  if(rs1==31)
    rs1 = 32;
  if((inst_reg>>29)&1){
    if(op)
      printf("subs\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    else
      printf("adds\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
  }
  else{
    if(rd==31)
      rd = 32;
    if(op)
      printf("sub\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    else
      printf("add\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
  }
}

static long long int DecodeBitMasks(int N, int imms, int immr)
{
  unsigned long long int telem;
  unsigned long long int welem;
  unsigned long long int ror;
  int len;
  int levels;
  int S;
  int R;
  int diff;
  int esize;
  int d;
  int i;
  if(N==1){
    len = 6;
    esize = 64;
    levels = 0x3f;
  }
  else if((imms&0x20)==0){
    len = 5;
    esize = 32;
    levels = 0x1f;
  }
  else if((imms&0x10)==0){
    len = 4;
    esize = 16;
    levels = 0x0f;
  }
  else if((imms&0x8)==0){
    len = 3;
    esize = 8;
    levels = 0x7;
  }
  else if((imms&0x4)==0){
    len = 2;
    esize = 4;
    levels = 0x3;
  }
  else if((imms&0x2)==0){
    len = 1;
    esize = 2;
    levels = 0x1;
  }
  else if((imms&0x1)==0){
    len = 0;
    esize = 1;
    levels = 0x0;
  }
  S = imms & levels;
  R = immr & levels;
  diff = (S-R)&0x3f;
  d = diff & levels;
  if(S==0x3f){
    welem = 0x7fffffffffffffffULL;
  }
  else if(S==0x3e){
    welem = 0x3fffffffffffffffULL;
  }
  else{
    welem = (1ULL<<(S+1))-1ULL;
  }
  if(d==0x3f){
    telem = 0x7fffffffffffffffULL;
  }
  else if(d==0x3e){
    telem = 0x3fffffffffffffffULL;
  }
  else{
    telem = (1ULL<<(d+1))-1ULL;
  }
  //  welem = (1ULL<<(S+1))-1ULL;
  //  telem = (1ULL<<(d+1))-1ULL;
  ror   = ((welem<<(esize-R))|(welem>>R));
  switch(len){
  case 6:
    ror &= 0xffffffffffffffffULL;
    break;
  case 5:
    ror &= 0x00000000ffffffffULL;
    break;
  case 4:
    ror &= 0x000000000000ffffULL;
    break;
  case 3:
    ror &= 0x00000000000000ffULL;
    break;
  case 2:
    ror &= 0x000000000000000fULL;
    break;
  case 1:
    ror &= 0x0000000000000003ULL;
    break;
  default:
    ror &= 0x0000000000000001ULL;
    break;
  }
  wmask = 0ULL;
  tmask = 0ULL;
  for(i=0;i<(64/esize);i++){
    wmask = (wmask<<esize)|ror;
    tmask = (tmask<<esize)|telem;
  }
  return (long long int)wmask;
}

static void dis_logic_i(void)
{
  v64 = (inst_reg>>31)&1;
  rd  = inst_reg & 0x1f;
  rs1 = (inst_reg>>5)&0x1f;
  immd =DecodeBitMasks((inst_reg>>22)&1,(inst_reg>>10)&0x3f,(inst_reg>>16)&0x3f);
  switch((inst_reg>>29)&3){
  case 0:
    if(rd==31)
      rd = 32;
    printf("and\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    break;
  case 1:
    if(rd==31)
      rd = 32;
    printf("orr\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    break;
  case 2:
    if(rd==31)
      rd = 32;
    printf("eor\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    break;
  case 3:
    printf("ands\t%s, %s, #0x%016llx\n",RegName(rd,v64),RegName(rs1,v64),immd);
    break;
  }
}

static void dis_movw(void)
{
  int pos;
  v64 = (inst_reg>>31)&1;
  pos = (inst_reg>>21)&3;
  rd  = inst_reg & 0x1f;
  immd =(long long int)((inst_reg>>5)&0xffff);
  op = (inst_reg>>29)&3;
  pos = pos<<4;
  switch(op){
  case 0:/* MOVN */
    immd = immd<<pos;
    immd = (~immd)&0xffffffffffffffffLL;
    printf("movn\t%s, #~0x%016llx\n",RegName(rd,v64),immd);
    break;
  case 2:/* MOVZ */
    immd = immd<<pos;
    printf("movz\t%s, #0x%016llx\n",RegName(rd,v64),immd);
    break;
  case 3:/* MOVK */
    immd = immd<<pos;
    // imask=(long long int)(0xffffLL<<pos);
    printf("movk\t%s, #0x%016llx\n",RegName(rd,v64),immd);
    break;
  default:
    dis_undef();
    break;
  }
}

static void dis_bitf(void)
{
  v64 = (inst_reg>>31)&1;
  rd  = inst_reg & 0x1f;
  rs1 = (inst_reg>>5)&0x1f;
  d_N = (inst_reg>>22)&1;
  d_S = (inst_reg>>10)&0x3f;
  d_R = (inst_reg>>16)&0x3f;
  immd =DecodeBitMasks(d_N,d_S,d_R);
  op  = (inst_reg>>29)&3;
  switch(op){
  case 0:/* SBFM */
    printf("sbfm\t%s, %s, #0x%02x, #0x%02x\n",RegName(rd,v64),RegName(rs1,v64),d_R,d_S);
    break;
  case 1:/* BFM */
    printf("bfm\t%s, %s, #0x%02x, #0x%02x\n",RegName(rd,v64),RegName(rs1,v64),d_R,d_S);
    break;
  case 2:/* UBFM */
    printf("ubfm\t%s, %s, #0x%02x, #0x%02x\n",RegName(rd,v64),RegName(rs1,v64),d_R,d_S);
    break;
  default:
    dis_undef();
    break;
  }
}

static void dis_extr(void)
{
  v64 = (inst_reg>>31)&1;
  rd  = inst_reg & 0x1f;
  rs1 = (inst_reg>>5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  d_N = (inst_reg>>22)&1;
  d_S = (inst_reg>>10)&0x3f;
  op  = (inst_reg>>29)&0x3;
  op2 = (inst_reg>>21)&1;
  if((op==0)&&(op2==0)){/* EXTR */
    printf("extr\t%s, %s, %s, #0x%02x\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),d_S);
  }
  else{
    dis_undef();
  }
}

static void dis_data_proc_i(void)
{
  op = (inst_reg>>23)&0x7;
  switch(op){
  case 0x0:
  case 0x1:
    dis_pc_rel();
    break;
  case 0x2:
  case 0x3:
    dis_add_sub_i();
    break;
  case 0x4:
    dis_logic_i();
    break;
  case 0x5:
    dis_movw();
    break;
  case 0x6:
    dis_bitf();
    break;
  case 0x7:
    dis_extr();
    break;
  }
}

static void dis_data_proc_2src(void)
{
  int S;
  v64 = (inst_reg>>31)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  op  = (inst_reg>>10)&0x3f;
  S   = (inst_reg>>29)&1;
  if((S==0)&&(op==0x02)){/* UDIV */
    printf("udiv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((S==0)&&(op==0x03)){/* SDIV */
    printf("sdiv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((S==0)&&(op==0x08)){/* LSLV */
    printf("lslv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((S==0)&&(op==0x09)){/* LSRV */
    printf("lsrv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((S==0)&&(op==0x09)){/* ASRV */
    printf("asrv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((S==0)&&(op==0x0b)){/* RORV */
    printf("rorv\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  dis_undef();
}

static void dis_data_proc_1src(void)
{
  int S;
  v64 = (inst_reg>>31)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  op  = (inst_reg>>10)&0x3f;
  op2 = (inst_reg>>16)&0x1f;
  S   = (inst_reg>>29)&1;
  if((S==0)&&(op2==0)&&(op==0)){/* RBIT */
    printf("rbit\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((S==0)&&(op2==0)&&(op==1)){/* REV16 */
    printf("rev16\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((v64==0)&&(S==0)&&(op2==0)&&(op==2)){/* REV */
    printf("rev\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((v64==1)&&(S==0)&&(op2==0)&&(op==2)){/* REV32 */
    printf("rev32\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((v64==1)&&(S==0)&&(op2==0)&&(op==3)){/* REV */
    printf("rev\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((S==0)&&(op2==0)&&(op==4)){/* CLZ  */
    printf("clz\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  if((S==0)&&(op2==0)&&(op==5)){/* CLS  */
    printf("cls\t%s, %s\n",RegName(rd,v64),RegName(rs1,v64));
    return;
  }
  dis_undef();
}

static void dis_logical_shift(void)
{
  int N;
  int sa;
  int st;
  char *sn;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>29)&3;
  st  = (inst_reg>>22)&3;
  N   = (inst_reg>>21)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  sa  = (inst_reg>>10)&0x3f;
  //  immd = ShiftReg(rs2, st, sa);
  switch(st){
  case 0:
    sn = "lsl";
    break;
  case 1:
    sn = "lsr";
    break;
  case 2:
    sn = "asr";
    break;
  case 3:
    sn = "ror";
    break;
  }
  switch((op<<1)|N){
  case 0:
    printf("and\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 1:
    printf("bic\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 2:
    printf("orr\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 3:
    printf("orn\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 4:
    printf("eor\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 5:
    printf("eon\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 6:
    printf("ands\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  case 7:
    printf("bics\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    break;
  }
}

static void dis_addsub_shift(void)
{
  int S;
  int st;
  int sa;
  char *sn;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  S   = (inst_reg>>29)&1;
  st  = (inst_reg>>22)&3;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  sa  = (inst_reg>>10)&0x3f;
  //immd = ShiftReg(rs2, st, sa);
  switch(st){
  case 0:
    sn = "lsl";
    break;
  case 1:
    sn = "lsr";
    break;
  case 2:
    sn = "asr";
    break;
  case 3:
    sn = "ror";
    break;
  }
  if(op){
    if(S)
      printf("subs\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    else
      printf("sub\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
  }
  else{
    if(S)
      printf("adds\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
    else
      printf("add\t%s, %s, %s, %s #%d\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),sn,sa);
  }
}

static void dis_addsub_extend(void)
{
  int S;
  int ty;
  int opt;
  int imm3;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  S   = (inst_reg>>29)&1;
  ty  = (inst_reg>>22)&3;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  imm3 = (inst_reg>>10)&0x7;
  opt = (inst_reg>>13)&0x7;
  if(rs1==31)
    rs1 = 32;
  if(op){
    if(S){
      printf("subs\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64), ExtendReg(rs2, opt, imm3));
    }
    else{
      if(rd==31)
	rd = 32;
      printf("sub\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64), ExtendReg(rs2, opt, imm3));
    }
  }
  else{
    if(S){
      printf("adds\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64), ExtendReg(rs2, opt, imm3));
    }
    else{
      if(rd==31)
	rd = 32;
      printf("add\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64), ExtendReg(rs2, opt, imm3));
    }
  }
}

static void dis_addsub_carry(void)
{
  int S;
  int opt;
  int imm3;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  S   = (inst_reg>>29)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  op2 = (inst_reg>>10)&0x3f;
  if(op2==0){
    if(op){
      if(S)
	printf("sbcs\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
      else
	printf("sbc\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    }
    else{
      if(S)
	printf("adcs\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
      else
	printf("adc\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    }
  }
  else{
    dis_undef();
  }
}

static void dis_cond_comp_r(void)
{
  int S;
  int opt;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  op2 = (inst_reg>>10)&1;
  op3 = (inst_reg>> 4)&1;
  S   = (inst_reg>>29)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  nzcv = (inst_reg>> 0)&0xf;
  cond = (inst_reg>>12)&0xf;
  rd  = NONE;
  if((S==0)||(op2==1)||(op3==1)){
    dis_undef();
    return;
  }
  if(op){
    printf("ccmp\t%s, %s, #0b%d%d%d%d, %s\n",
	   RegName(rs1,v64),RegName(rs2,v64),
	   (nzcv & 8)!=0,(nzcv & 4)!=0,(nzcv & 2)!=0,(nzcv & 1)!=0, CondName[cond]);
  }
  else{
    printf("ccmn\t%s, %s, #0b%d%d%d%d, %s\n",
	   RegName(rs1,v64),RegName(rs2,v64),
	   (nzcv & 8)!=0,(nzcv & 4)!=0,(nzcv & 2)!=0,(nzcv & 1)!=0, CondName[cond]);
  }
}


static void dis_cond_comp_i(void)
{
  int S;
  int opt;
  int imm5;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  op2 = (inst_reg>>10)&1;
  op3 = (inst_reg>> 4)&1;
  S   = (inst_reg>>29)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  nzcv = (inst_reg>> 0)&0xf;
  cond = (inst_reg>>12)&0xf;
  imm5 = (inst_reg>>16)&0x1f;
  if((S==0)||(op2==1)||(op3==1)){
    dis_undef();
    return;
  }
  if(op){
    printf("ccmp\t%s, #0x%2x, #0b%d%d%d%d, %s\n",
	   RegName(rs1,v64),imm5,
	   (nzcv & 8)!=0,(nzcv & 4)!=0,(nzcv & 2)!=0,(nzcv & 1)!=0, CondName[cond]);
  }
  else{
    printf("ccmn\t%s, #0x%2x, #0b%d%d%d%d, %s\n",
	   RegName(rs1,v64),imm5,
	   (nzcv & 8)!=0,(nzcv & 4)!=0,(nzcv & 2)!=0,(nzcv & 1)!=0, CondName[cond]);
  }
  OP2 = FLAG;
}

static void dis_cond_select(void)
{
  int S;
  int opt;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>30)&1;
  op2 = (inst_reg>>10)&3;
  S   = (inst_reg>>29)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  cond = (inst_reg>>12)&0xf;
  if((S==1)||(op2==2)||(op2==3)){
    dis_undef();
    return;
  }
  switch((op<<1)|op2){
  case 0:
    printf("csel\t%s, %s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),CondName[cond]);
    break;
  case 1:
    printf("csinc\t%s, %s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),CondName[cond]);
    break;
  case 2:
    printf("csinv\t%s, %s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),CondName[cond]);
    break;
  case 3:
    printf("csneg\t%s, %s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),CondName[cond]);
    break;
  }
}

static void dis_data_proc_3src(void)
{
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>29)&3;
  op2 = (inst_reg>>21)&7;
  op3 = (inst_reg>>15)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>>16)&0x1f;
  rs3 = (inst_reg>>10)&0x1f;
  rd  = (inst_reg>> 0)&0x1f;
  if((op==0)&&(op2==0)&&(op3==0)){
    printf("madd\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((op==0)&&(op2==0)&&(op3==1)){
    printf("msub\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==1)&&(op3==0)){
    printf("smaddl\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==1)&&(op3==1)){
    printf("smsubl\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==2)&&(op3==0)){
    printf("smulh\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==5)&&(op3==0)){
    printf("umaddl\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==5)&&(op3==1)){
    printf("umsubl\t%s, %s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64),RegName(rs3,v64));
    return;
  }
  if((v64==1)&&(op==0)&&(op2==6)&&(op3==0)){
    printf("umulh\t%s, %s, %s\n",RegName(rd,v64),RegName(rs1,v64),RegName(rs2,v64));
    return;
  }
  dis_undef();
}

static void dis_data_proc_r(void)
{
  op  = (inst_reg>>30)&1;
  op1 = (inst_reg>>28)&1;
  op2 = (inst_reg>>21)&0xf;
  op3 = (inst_reg>>11)&1;
  if((op==0)&&(op1==1)&&(op2==6)){
    dis_data_proc_2src();
    return;
  }
  if((op==1)&&(op1==1)&&(op2==6)){
    dis_data_proc_1src();
    return;
  }
  if((op1==0)&&((op2&8)==0)){
    dis_logical_shift();
    return;
  }
  if((op1==0)&&((op2&9)==8)){
    dis_addsub_shift();
    return;
  }
  if((op1==0)&&((op2&9)==9)){
    dis_addsub_extend();
    return;
  }
  if((op1==1)&&(op2==0)){
    dis_addsub_carry();
    return;
  }
  if((op1==1)&&(op2==2)&&(op3==0)){
    dis_cond_comp_r();
    return;
  }
  if((op1==1)&&(op2==2)&&(op3==1)){
    dis_cond_comp_i();
    return;
  }
  if((op1==1)&&(op2==4)){
    dis_cond_select();
    return;
  }
  if((op1==1)&&((op2&8)==8)){
    dis_data_proc_3src();
    return;
  }
  dis_undef();
}

static void dis_cond_bra(ovid)
{
  int addr;
  v64 = 1;
  op  = (inst_reg>>24)&1;
  op2 = (inst_reg>>4)&1;
  if((op==0)&&(op2==0)){
    cond = inst_reg & 0xf;
    immd = (long long int)((inst_reg>>5)&0x7ffff);
    immd = (immd & (1LL<<18))? 0xfffffffffff80000LL|immd : 0x7ffffLL&immd;
    immd = immd<<2;
    addr = PC + (int)immd;
    printf("b.%s\t0x%08x\n",CondName[cond],addr);
  }
  else{
    dis_undef();
  }
}

static void dis_except(void)
{
  dis_undef();/* not supported */
}

static void dis_system(void)
{
  if(inst_reg==0xd503201f){
    printf("nop\n");
    return;
  }
  dis_undef();/* not supported */
}

static void dis_uncond_bra_r(void)
{
  int Z, M;
  op =  (inst_reg>>21)&0xf;
  op2 = (inst_reg>>16)&0x1f;
  op3 = (inst_reg>>10)&0x3f;
  op4 = (inst_reg>> 0)&0x1f;
  Z   = (inst_reg>>24)&1;
  M   = (inst_reg>>10)&1;
  rs1 = (inst_reg>> 5)&0x1f;
  rs2 = (inst_reg>> 0)&0x1f;
  //  use_key_a = (M==0);
  //  source_is_sp = ((Z==1)&&(rs2==31));
  if((op==0)&&(op2==31)&&(op3==0)&&(op4==0)){/* BR */
    printf("br\t%s\n",RegName(rs1,1));
  }
  else if((op==0)&&(op2==31)&&(op3==2)&&(op4==31)){/* BRA */
    dis_undef();/* not supported */    
  }
  else if((op==0)&&(op2==31)&&(op3==3)&&(op4==31)){/* BRB */
    dis_undef();/* not supported */
  }
  else if((op==1)&&(op2==31)&&(op3==0)&&(op4==0)){/* BLR */
    printf("blr\t%s\n",RegName(rs1,1));
  }
  else if((op==1)&&(op2==31)&&(op3==2)&&(op4==31)){/* BLRA */
    dis_undef();/* not supported */
  }
  else if((op==1)&&(op2==31)&&(op3==3)&&(op4==31)){/* BLRB */
    dis_undef();/* not supported */
  }
  else if((op==2)&&(op2==31)&&(op3==0)&&(op4==0)){/* RET */
    if(rs1==30)
      printf("ret\n");
    else
      printf("ret\t$s\n",RegName(rs1,1));
  }
  else if((op==2)&&(op2==31)&&(op3==2)&&(op4==31)&&(rs1==31)){/* RETA */
    dis_undef();/* not supported */
  }
  else if((op==2)&&(op2==31)&&(op3==3)&&(op4==31)&&(rs1==31)){/* RETB */
    dis_undef();/* not supported */
  }
  else{
    dis_undef();/* not supported */
  }
}

static void dis_uncond_bra_i(void)
{
  int addr;
  immd = (long long int)(inst_reg & 0x3ffffffLL);
  immd = (immd & (1LL<<25))? 0xfffffffffc000000LL|immd : 0x3ffffffLL&immd;
  immd = immd<<2;
  addr = PC + (int)immd;
  if((inst_reg>>31)&1){
    printf("bl\t0x%08x\n",addr);
  }
  else{
    printf("b\t0x%08x\n",addr);
  }
}

static void dis_cmp_bra(void)
{
  int addr;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>24)&1;
  immd = (long long int)((inst_reg>>5)&0x7ffff);
  immd = (immd & (1LL<<18))? 0xfffffffffff80000LL|immd : 0x7ffffLL&immd;
  immd = immd<<2;
  addr = PC + (int)immd;
  rs3 = inst_reg & 0x1f;
  if(op==0)
    printf("cbz\t%s, 0x%08x\n",RegName(rs3,v64), addr);
  else
    printf("cbnz\t%s, 0x%08x\n",RegName(rs3,v64), addr);
}

static void dis_tst_bra(void)
{
  int addr;
  v64 = (inst_reg>>31)&1;
  op  = (inst_reg>>24)&1;
  bit_pos = ((inst_reg>>19)&0x1f)|(v64<<5);
  immd = (long long int)((inst_reg>>5)&0x3fff);
  immd = (immd & (1LL<<13))? 0xffffffffffffc000LL|immd : 0x3fffLL&immd;
  immd = immd<<2;
  addr = PC +  (int)immd;
  rs3 = inst_reg & 0x1f;
  if(op==0)
    printf("tbz\t%s, 0x%08x\n",RegName(rs3,v64), addr);
  else
    printf("tbnz\t%s, 0x%08x\n",RegName(rs3,v64), addr);
}

static void dis_branch_sys(void)
{
  op  = (inst_reg>>29)&0x7;
  op1 = (inst_reg>>22)&0xf;
  if((op==2)&&((op1&8)==0)){
    dis_cond_bra();
  }
  else if((op==2)&&((op1&8)==8)){
    dis_undef();
  }
  else if((op==6)&&((op1&12)==0)){
    dis_except();
  }
  else if((op==6)&&(op1==4)){
    dis_system();
  }
  else if((op==6)&&(op1==5)){
    dis_undef();
  }
  else if((op==6)&&((op1&14)==6)){
    dis_undef();
  }
  else if((op==6)&&((op1&8)==8)){
    dis_uncond_bra_r();
  }
  else if((op&3)==0){
    dis_uncond_bra_i();
  }
  else if(((op&3)==1)&&((op2&8)==0)){
    dis_cmp_bra();
  }
  else if(((op&3)==1)&&((op2&8)==8)){
    dis_tst_bra();
  }
  else{
    dis_undef();
  }
}

static void dis_ldst(void)
{
  int V,L,S;
  int addr;
  op  = (inst_reg>>31)&0x1;
  op1 = (inst_reg>>28)&3;
  op2 = (inst_reg>>26)&1;
  op3 = (inst_reg>>23)&3;
  op4 = (inst_reg>>16)&0x3f;
  op5 = (inst_reg>>10)&3;
  V   = (inst_reg>>26)&1;
  L   = (inst_reg>>22)&1;
  post_index = 0;
  mwback = 0;
  if((op1==0)&&(op2==0)&&((op3&2)==0)){/* LDREX/STREX */
    dis_undef();/* not supported */
    return;
  }
  if((op1==1)&&((op3&2)==0)){/* LDRPC */
    op  = (inst_reg>>30)&3;
    rd  = inst_reg & 0x1f;
    immd = (long long int)((inst_reg>>5)&0x7ffff);
    immd = (immd & (1LL<<18))? 0xfffffffffff80000LL|immd : 0x7ffffLL&immd;
    immd = immd << 2;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      addr = PC + (int)immd;
      switch(op){
      case 0:
	printf("ldr\t%s, 0x%08x\n",RegName(rd,0),addr);
	break;
      case 1:
	printf("ldr\t%s, 0x%08x\n",RegName(rd,1),addr);
	break;
      case 2:
	printf("ldrsw\t%s, 0x%08x\n",RegName(rd,1),addr);
	break;
      case 3:/* prefetch */
	break;
      }
    }
    return;
  }
  if((op1==2)&&(op3==0)){/* LDNP/STNP(offset) */
    op  = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rd2 = (inst_reg>>10)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      immd = (long long int)((inst_reg>>15)&0x7f);
      immd = (immd & (1LL<<6))? 0xffffffffffffff80LL|immd : 0x7fLL&immd;
      switch(op){
      case 0:
	immd = immd << 2;
	if(L)
	  printf("ldnp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	else
	  printf("stnp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	break;
      case 2:
	immd = immd << 3;
	if(L)
	  printf("ldnp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	else
	  printf("stnp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	break;
      case 1:
      case 3:
	dis_undef();
	break;
      }
    }
    return;
  }
  if((op1==2)&&(op3==1)){/* LDRP/STRP(post-indexed) */
    op  = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rd2 = (inst_reg>>10)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      immd = (long long int)((inst_reg>>15)&0x7f);
      immd = (immd & (1LL<<6))? 0xffffffffffffff80LL|immd : 0x7fLL&immd;
      switch(op){
      case 0:
	immd = immd<<2;
	if(L)
	  printf("ldp\t%s, %s, [%s], #0x%llx\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s], #0x%llx\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	break;
      case 1:
	immd = immd<<2;
	if(L){
	  printf("ldpsw\t%s, %s, [%s], #0x%llx\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	}
	else{
	  dis_undef();
	}
	break;
      case 2:
	immd = immd<<3;
	if(L)
	  printf("ldp\t%s, %s, [%s], #0x%llx\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s], #0x%llx\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	break;
      case 3:
	dis_undef();
	break;
      }
    }
    return;
  }
  if((op1==2)&&(op3==2)){/* LDRP/STRP(offset) */
    op  = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rd2 = (inst_reg>>10)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      immd = (long long int)((inst_reg>>15)&0x7f);
      immd = (immd & (1LL<<6))? 0xffffffffffffff80LL|immd : 0x7fLL&immd;
      switch(op){
      case 0:
	immd = immd<<2;
	if(L)
	  printf("ldp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	break;
      case 1:
	immd = immd<<2;
	if(L){
	  printf("ldpsw\t%s, %s, [%s, #0x%llx]\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	  msize = WORD;
	  msex  = 1;
	}
	else{
	  dis_undef();
	}
	break;
      case 2:
	immd = immd<<3;
	if(L)
	  printf("ldp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s, #0x%llx]\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	break;
      case 3:
	dis_undef();
	break;
      }
    }
    return;
  }
  if((op1==2)&&(op3==3)){/* LDRP/STRP(pre-indexed) */
    op  = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rd2 = (inst_reg>>10)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      immd = (long long int)((inst_reg>>15)&0x7f);
      immd = (immd & (1LL<<6))? 0xffffffffffffff80LL|immd : 0x7fLL&immd;
      switch(op){
      case 0:
	immd = immd<<2;
	if(L)
	  printf("ldp\t%s, %s, [%s, #0x%llx]!\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s, #0x%llx]!\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	break;
      case 1:
	immd = immd<<2;
	if(L){
	  printf("ldpsw\t%s, %s, [%s, #0x%llx]!\n",RegName(rd,0),RegName(rd2,0),RegName(rs1,1),immd);
	}
	else{
	  dis_undef();
	}
	break;
      case 2:
	immd = immd<<3;
	if(L)
	  printf("ldp\t%s, %s, [%s, #0x%llx]!\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	else
	  printf("stp\t%s, %s, [%s, #0x%llx]!\n",RegName(rd,1),RegName(rd2,1),RegName(rs1,1),immd);
	break;
      case 3:
	dis_undef();
	break;
      }
    }
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0)&&(op5==0)){/* LDR/STR(imm) */
    op  = (inst_reg>>22)&3;
    op2 = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    immd = (long long int)((inst_reg>>12)&0x1ff);
    immd = (immd & (1LL<<8))? 0xfffffffffffffe00LL|immd : 0x1ffLL&immd;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      switch(op){
      case 0:
	switch(op2){
	case 0:
	  printf("sturb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("sturh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("stur\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("stur\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 1:
	switch(op2){
	case 0:
	  printf("ldurb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldurh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldur\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("ldur\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 2:
	switch(op2){
	case 0:
	  printf("ldursb\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldursh\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldursw\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("prfm\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 3:
	switch(op2){
	case 0:
	  printf("ldursb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldursh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	case 3:
	  dis_undef();
	  break;
	}
	break;
      }
    }
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0)&&(op5==1)){/* LDR/STR(imm,post-indexed) */
    op  = (inst_reg>>22)&3;
    op2 = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    immd = (long long int)((inst_reg>>12)&0x1ff);
    immd = (immd & (1LL<<8))? 0xfffffffffffffe00LL|immd : 0x1ffLL&immd;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      switch(op){
      case 0:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("strb\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("strh\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("str\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("str\t%s, [%s], #0x%x\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 1:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrb\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrh\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldr\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("ldr\t%s, [%s], #0x%x\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 2:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s], #0x%x\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s], #0x%x\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldrsw\t%s, [%s], #0x%x\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 3:
	  dis_undef();
	  break;
	}
	break;
      case 3:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s], #0x%x\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	case 3:
	  dis_undef();
	  break;
	}
	break;
      }
    }
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0)&&(op5==2)){/* LDR/STR(unpriv) */
    dis_undef();/* not supported */
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0)&&(op5==3)){/* LDR/STR(imm, pre-indexed) */
    op  = (inst_reg>>22)&3;
    op2 = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    immd = (long long int)((inst_reg>>12)&0x1ff);
    immd = (immd & (1LL<<8))? 0xfffffffffffffe00LL|immd : 0x1ffLL&immd;
    if(V){
      dis_undef();/* not supported */
    }
    else{
      switch(op){
      case 0:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("strb\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("strh\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("str\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("str\t%s, [%s, #0x%x]!\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 1:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrb\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrh\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldr\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("ldr\t%s, [%s, #0x%x]!\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 2:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s, #0x%x]!\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, #0x%x]!\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldrsw\t%s, [%s, #0x%x]!\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 3:
	  dis_undef();
	  break;
	}
	break;
      case 3:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, #0x%x]!\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	case 3:
	  dis_undef();
	  break;
	}
	break;
      }
    }
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0x20)&&(op5==0)){/* Atomic */
    dis_undef();/* not supported */
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0x20)&&(op5==2)){/* LDR/STR(reg offset) */
    int option;
    int ext_typ;
    char *ro;
    op  = (inst_reg>>22)&3;
    op2 = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    rs2 = (inst_reg>>16)&0x1f;
    S   = (inst_reg>>12)&1;
    option = (inst_reg>>13)&7;
    ext_typ = option;
    if(rs1==31)
      rs1 = 32;
    if(option==3)
      ro = LSLReg(rs2, op2, S);
    else
      ro = ExtendReg(rs2, ext_typ, 0);
    if(V){
      dis_undef();/* not supported */
    }
    else{
      switch(op){
      case 0:
	switch(op2){
	case 0:
	  v64 = (option==3)? 1 : 0;
	  printf("strb\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 1:
	  printf("strh\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 2:
	  printf("str\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 3:
	  printf("str\t%s, [%s, %s]\n",RegName(rd,1),RegName(rs1,1),ro);
	  break;
	}
	break;
      case 1:
	switch(op2){
	case 0:
	  v64 = (option==3)? 1 : 0;
	  printf("ldrb\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 1:
	  printf("ldrh\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 2:
	  printf("ldr\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 3:
	  printf("ldr\t%s, [%s, %s]\n",RegName(rd,1),RegName(rs1,1),ro);
	  break;
	}
	break;
      case 2:
	switch(op2){
	case 0:
	  v64 = (option==3)? 1 : 0;
	  printf("ldrsb\t%s, [%s, %s]\n",RegName(rd,1),RegName(rs1,1),ro);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, %s]\n",RegName(rd,1),RegName(rs1,1),ro);
	  break;
	case 2:
	  printf("ldrsw\t%s, [%s, %s]\n",RegName(rd,1),RegName(rs1,1),ro);
	  break;
	case 3:
	  dis_undef();
	  break;
	}
	break;
      case 3:
	v64 = 1;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, %s]\n",RegName(rd,0),RegName(rs1,1),ro);
	  break;
	case 2:
	case 3:
	  dis_undef();
	  break;
	}
	break;
      }
    }
    return;
  }
  if((op1==3)&&((op3&2)==0)&&((op4&0x20)==0x20)&&((op5&1)==1)){/* LDR/STR(pac) */
    dis_undef();/* not supported */
    return;
  }
  if((op1==3)&&((op3&2)==2)){/* LDR/STR(unsigned,imm) */
    op  = (inst_reg>>22)&3;
    op2 = (inst_reg>>30)&3;
    rd  = (inst_reg>> 0)&0x1f;
    rs1 = (inst_reg>> 5)&0x1f;
    if(rs1==31)
      rs1 = 32;
    immd = (long long int)((inst_reg>>10)&0xfff);
    if(V){
      dis_undef();/* not supported */
    }
    else{
      switch(op){
      case 0:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("strb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("strh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("str\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("str\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 1:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldr\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 3:
	  printf("ldr\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	}
	break;
      case 2:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 2:
	  printf("ldrsw\t%s, [%s, #0x%x]\n",RegName(rd,1),RegName(rs1,1),immd);
	  break;
	case 3:
	  dis_undef();
	  break;
	}
	break;
      case 3:
	immd = immd << op2;
	switch(op2){
	case 0:
	  printf("ldrsb\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 1:
	  printf("ldrsh\t%s, [%s, #0x%x]\n",RegName(rd,0),RegName(rs1,1),immd);
	  break;
	case 2:
	case 3:
	  dis_undef();
	  break;
	}
	break;
      }
    }
    return;
  }
  dis_undef();/* not supported */
}

static void dis_fpu_simd(void)
{
  dis_undef();/* not supported */
}

void dis(void)
{
  opcode  = (inst_reg>>25)&0xf;

  switch(opcode){
  case 0x8:
  case 0x9:
    dis_data_proc_i();
    break;
  case 0xa:
  case 0xb:
    dis_branch_sys();
    break;
  case 0x4:
  case 0x6:
  case 0xc:
  case 0xe:
    dis_ldst();
    break;
  case 0x5:
  case 0xd:
    dis_data_proc_r();
    break;
  case 0x7:
  case 0xf:
    dis_fpu_simd();
    break;
  default:
    dis_undef();
    break;
  }
}

void disasm(unsigned int addr1, unsigned int addr2)
{
  PC = (int)addr1;
  while(1){
    inst_reg = get_mem(PC,WORD);
    printf("%08x %08x ",PC, inst_reg);
    dis();
    PC = PC+4;
    if(((unsigned int)PC)>addr2)
      break;
  }
}
