#include "define.h"

static int tmp_N_flag=0;
static int tmp_Z_flag=0;
static int tmp_C_flag=0;
static int tmp_V_flag=0;
static int already_npc_set;

int N_flag=0;
int Z_flag=0;
int C_flag=0;
int V_flag=0;

extern int cond;
extern int immd;
extern int rs1;
extern int rs2;
extern int rs3;
extern int rs4;
extern int rd;
extern int rd2;
extern int OP;
extern int OP2;
extern int msize;
extern int msex;
extern int mwback;
extern int bit_pos;
extern int nzcv;
extern int post_index;
extern int imask;
extern int v64;

extern int d_N;
extern int d_S;
extern int d_R;
extern unsigned long long int tmask;
extern unsigned long long int wmask;

int PC;

extern int inst_reg;

static int IADD32(int src1, int src2, int carry, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)(src1 & 0xffffffffLL);
  s2 = (unsigned long long)(src2 & 0xffffffffLL);
  d  = s1 + s2 + carry;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==0)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==1)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}

static int ISUB32(int src1, int src2, int borrow, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)( src1 & 0xffffffffLL);
  s2 = (unsigned long long)(~src2 & 0xffffffffLL);
  d  = s1 + s2 + 1 - borrow;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==1)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==0)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}

static long long int IADD64(long long int src1, long long int src2, int carry, int* n, int* z, int* c, int* v)
{
  int src1L, src1H, src2L, src2H;
  int dstL, dstH;
  int n1, z1, c1, v1;
  int n2, z2, c2, v2;
  long long int val;

  src1L = (int)(src1 & 0xffffffffLL);
  src1H = (int)((src1>>32) & 0xffffffffLL);
  src2L = (int)(src2 & 0xffffffffLL);
  src2H = (int)((src2>>32) & 0xffffffffLL);

  dstL  = IADD32(src1L, src2L, carry, &n1, &z1, &c1, &v1);
  dstH  = IADD32(src1H, src2H, c1, &n2, &z2, &c2, &v2);

  *n = n2;
  *z = z1 && z2;
  *c = c2;
  *v = v2;

  val = (long long int)(dstH & 0xffffffffLL);
  val = (val<<32)|(long long int)(dstL & 0xffffffffLL);
  val = val & 0xffffffffffffffffLL;
  return val;
}

static long long int ISUB64(long long int src1, long long int src2, int borrow, int* n, int* z, int* c, int* v)
{
  int src1L, src1H, src2L, src2H;
  int dstL, dstH;
  int n1, z1, c1, v1;
  int n2, z2, c2, v2;
  long long int val;

  src1L = (int)(src1 & 0xffffffffLL);
  src1H = (int)((src1>>32) & 0xffffffffLL);
  src2L = (int)(src2 & 0xffffffffLL);
  src2H = (int)((src2>>32) & 0xffffffffLL);

  dstL  = ISUB32(src1L, src2L, borrow, &n1, &z1, &c1, &v1);
  dstH  = ISUB32(src1H, src2H, c1? 0 : 1, &n2, &z2, &c2, &v2);

  *n = n2;
  *z = z1 && z2;
  *c = c2;
  *v = v2;

  val = (long long int)(dstH & 0xffffffffLL);
  val = (val<<32)|(long long int)(dstL & 0xffffffffLL);
  val = val & 0xffffffffffffffffLL;
  return val;
}

static unsigned long long int UMUL32(unsigned int a, unsigned int b)
{
  unsigned long long int src1, src2, dst;

  src1 = (unsigned long long int)(a&0xffffffffLL);
  src2 = (unsigned long long int)(b&0xffffffffLL);
  dst  = src1 * src2;
  return dst;
}

void UMUL64(unsigned long long int a, unsigned long long int b, 
            unsigned long long int *hi, unsigned long long int *lo)

{
  unsigned long long int ah, al;
  unsigned long long int bh, bl;
  unsigned long long int m1, m2, l;
  unsigned long long int M2, M3;

  ah  = (unsigned long long int)((a>>32)&0xffffffffLL);
  al  = (unsigned long long int)((a>> 0)&0xffffffffLL);
  bh  = (unsigned long long int)((b>>32)&0xffffffffLL);
  bl  = (unsigned long long int)((b>> 0)&0xffffffffLL);
  l   = al*bl;
  m1  = ah*bl;
  m2  = al*bh;
  M3  = (m1&0xffffffffLL)+(m2&0xffffffffLL) +(l>>32) ;
  M2  = (M3>>32)+(m1>>32)+(m2>>32);
  *lo = ((m1+m2)<<32) +l ;
  *hi = M2+ah*bh;
}

void UMUL128(unsigned long long int ah, unsigned long long int al,
             unsigned long long int bh, unsigned long long int bl,
             unsigned long long int* hi, unsigned long long int* lo)
{
  unsigned long long int albl_hi, albl_lo;
  unsigned long long int albh_hi, albh_lo;
  unsigned long long int ahbl_hi, ahbl_lo;
  unsigned long long int temp_hi, temp_lo;

  UMUL64(al, bl, &albl_hi, &albl_lo);
  UMUL64(al, bh, &albh_hi, &albh_lo);
  UMUL64(ah, bl, &ahbl_hi, &ahbl_lo);

  temp_lo = albl_lo;
  temp_hi = albl_hi + albh_lo + ahbl_lo;

  temp_lo &= 0xffffffffffffffffULL;
  temp_hi &= 0xffffffffffffffffULL;

  *hi = temp_hi;
  *lo = temp_lo;
}

static long long int s_extend(long long int x)
{
   if(v64==0){
      x = (x & (1LL<<31))? 0xffffffff00000000LL|x : 0xffffffffLL&x;
    }
   return x;
}
 
static unsigned long long int u_extend(unsigned long long int x)
{
   if(v64==0){
      x &= 0xffffffffULL;
   }
   return x;
}

static long long int doEXTR(unsigned long long int s1, unsigned long long int s2, int sa)
{
  unsigned long long int a,b;
    /*  | Rn | Rm | */
    /*     ----|<-  */
    if(v64==0){
      a = (s1 << (32-sa))&0xffffffffULL;
      b = (s2 >> sa)     &0xffffffffULL;
    }
    else{
      a = (s1 << (64-sa))&0xffffffffffffffffULL;
      b = (s2 >> sa)     &0xffffffffffffffffULL;
    }
    return (long long int)(a | b);
}

static long long int v_dst;
static long long int v_src1;
static long long int v_src2;
static long long int v_src3;
static long long int v_src4;
static unsigned long long int v_udst;
static unsigned long long int v_udst2;
static unsigned long long int v_usrc1;
static unsigned long long int v_usrc2;
static unsigned long long int v_usrc3;
static unsigned long long int v_usrc4;

static long long int get_value(int n)
{
  if((n>=0)&&(n<=30))
    return get_reg(n);
  if(n==SP_VAL)
    return get_reg(n);
  if(n==PC_VAL)
    return (long long int)PC;
  if(n==PCP_VAL)
    return (long long int)(PC&0xfffff000);
  if(n==31)
    return 0LL;
  if(n==IMMD)
    return immd;
  if(n==NXT_PC)
    return (long long int)(PC+4);
  return 0LL;
}

static void put_value(int n, long long int v)
{
  if((n>=0)&&(n<=30)){
    put_reg(n,v);
    return;
  }
  if(n==SP_VAL){
    put_reg(n,v);
    return;
  }
  return;
}

static int cond_check()
{
  switch(cond){
  case 0x0:
    return (Z_flag==1);
  case 0x1:
    return (Z_flag==0);
  case 0x2:
    return (C_flag==1);
  case 0x3:
    return (C_flag==0);
  case 0x4:
    return (N_flag==1);
  case 0x5:
    return (N_flag==0);
  case 0x6:
    return (V_flag==1);
  case 0x7:
    return (V_flag==0);
  case 0x8:
    return ((C_flag==1)&&(Z_flag==0));
  case 0x9:
    return ((C_flag==0)||(Z_flag==1));
  case 0xa:
    return (N_flag==V_flag);
  case 0xb:
    return (N_flag!=V_flag);
  case 0xc:
    return ((Z_flag==0)&&(N_flag==V_flag));
  case 0xd:
    return ((Z_flag==1)||(N_flag!=V_flag));
  case 0xe:
  case 0xf:
    return 1;
  }
}

void execute(void)
{
  int i;
  int addr;
  unsigned long long int bot;
  unsigned long long int top;
  unsigned long long int ror;
  unsigned long long int bot2;
  unsigned long long int top2;

  v_src1 = get_value(rs1);
  v_src2 = get_value(rs2);
  v_src3 = get_value(rs3);
  v_src4 = get_value(rs4);

  v_usrc1 = (unsigned long long int)v_src1;
  v_usrc2 = (unsigned long long int)v_src2;
  v_usrc3 = (unsigned long long int)v_src3;
  v_usrc4 = (unsigned long long int)v_src4;

  already_npc_set = 0;

  switch(OP){
  case	EADD:
    v_dst = IADD64(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case	ADD:
    v_dst = IADD64(s_extend(v_src1), s_extend(v_src2), 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case	SUB:
    v_dst = ISUB64(s_extend(v_src1), s_extend(v_src2), 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case	ADC:
    v_dst = IADD64(s_extend(v_src1), s_extend(v_src2), C_flag, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case	SBC:
    v_dst = ISUB64(s_extend(v_src1), s_extend(v_src2), C_flag? 0 : 1, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case	UDIV:
    v_dst = (long long int)(u_extend(v_usrc1)/u_extend(v_usrc2));
    break;
  case	SDIV:
    v_dst = s_extend(v_src1)/s_extend(v_src2);
    break;
  case	MADD:
    v_dst = (long long int)(u_extend(v_usrc3)+u_extend(v_usrc1)*u_extend(v_usrc2));
    break;
  case	MSUB:
    v_dst = (long long int)(u_extend(v_usrc3)-u_extend(v_usrc1)*u_extend(v_usrc2));
    break;
  case	UMADDL:
    v64 = 1;
    v_usrc1 &= 0xffffffffULL;
    v_usrc2 &= 0xffffffffULL;
    v_dst = (long long int)(v_usrc3+v_usrc1*v_usrc2);
    break;
  case	UMSUBL:
    v64 = 1;
    v_usrc1 &= 0xffffffffULL;
    v_usrc2 &= 0xffffffffULL;
    v_dst = (long long int)(v_usrc3-v_usrc1*v_usrc2);
    break;
  case	SMADDL:
    v64 = 1;
    v_src1 = (v_src1 & (1LL<<31))? 0xffffffff00000000LL|v_src1 : 0xffffffffLL&v_src1;
    v_src2 = (v_src2 & (1LL<<31))? 0xffffffff00000000LL|v_src2 : 0xffffffffLL&v_src2;
    v_dst  = v_src3+v_src1*v_src2;
    break;
  case	SMSUBL:
    v64 = 1;
    v_src1 = (v_src1 & (1LL<<31))? 0xffffffff00000000LL|v_src1 : 0xffffffffLL&v_src1;
    v_src2 = (v_src2 & (1LL<<31))? 0xffffffff00000000LL|v_src2 : 0xffffffffLL&v_src2;
    v_dst  = v_src3-v_src1*v_src2;
    break;
  case	UMULH:
    v64 = 1;
    UMUL64(v_usrc1, v_usrc2, &v_udst, &v_udst2);
    v_dst = (long long int)v_udst;
    break;
  case	SMULH:
    v64 = 1;
    v_usrc3 = (v_usrc1 & (1ULL<<63))? 0xffffffffffffffffULL : 0ULL;
    v_usrc4 = (v_usrc2 & (1ULL<<63))? 0xffffffffffffffffULL : 0ULL;
    UMUL128(v_usrc3, v_usrc1, v_usrc4, v_usrc2, &v_udst, &v_udst2);
    v_dst = (long long int)v_udst;
    break;
  case	AND:
    v_dst = v_src1 & v_src2;
    tmp_V_flag = 0;
    tmp_C_flag = C_flag;
    if(v64==0){
      tmp_Z_flag = ((v_dst & 0xffffffffLL)==0LL);
      tmp_N_flag = ((v_dst & (1LL<<31))!=0LL);
    }
    else{
      tmp_Z_flag = ((v_dst & 0xffffffffffffffffLL)==0LL);
      tmp_N_flag = ((v_dst & (1LL<<63))!=0LL);
    }
    break;
  case	BIC:
    v_dst = v_src1 & ~v_src2;
    tmp_V_flag = 0;
    tmp_C_flag = C_flag;
    if(v64==0){
      tmp_Z_flag = ((v_dst & 0xffffffffLL)==0LL);
      tmp_N_flag = ((v_dst & (1LL<<31))!=0LL);
    }
    else{
      tmp_Z_flag = ((v_dst & 0xffffffffffffffffLL)==0LL);
      tmp_N_flag = ((v_dst & (1LL<<63))!=0LL);
    }
    break;
  case	OR:
    v_dst = v_src1 | v_src2;
    break;
  case	XOR:
    v_dst = v_src1 ^ v_src2;
    break;
  case	ORN:
    v_dst = v_src1 | ~v_src2;
    break;
  case	XORN: 
    v_dst = v_src1 ^ ~v_src2;
    break;
  case	MOV:
    v_dst = v_src2;
    break;
  case	MOVK:
    v_dst = get_reg(rd);
    v_dst = (v_dst & ~imask)|(v_src2 & imask);
    break;
  case	CLZ:
    if(v64==0){
      for(i=0;i<32;i++){
	if((v_src1 & (1LL<<(31-i)))==0LL)
	  break;
      }
      v_dst = (long long int)i;
    }
    else{
      for(i=0;i<64;i++){
	if((v_src1 & (1LL<<(63-i)))==0LL)
	  break;
      }
      v_dst = (long long int)i;
    }
    break;
  case	CLS:
    if(v64==0){
      for(i=0;i<32;i++){
	if((v_src1 & (1LL<<(31-i)))!=0LL)
	  break;
      }
      v_dst = (long long int)i;
    }
    else{
      for(i=0;i<64;i++){
	if((v_src1 & (1LL<<(63-i)))!=0LL)
	  break;
      }
      v_dst = (long long int)i;
    }
    break;
  case	EXTR:
    v_dst = doEXTR(v_usrc1, v_usrc2, d_S);
    break;
  case	BFM:
    v_udst = get_reg(rd);
    ror    = doEXTR(v_usrc1, v_usrc1, d_R);
    bot    = (v_udst & ~wmask)|(ror & wmask);
    v_dst  = (long long int)((v_udst & ~tmask)|(bot & tmask));
    break;
  case	SBFM:
    ror    = doEXTR(v_usrc1, v_usrc1, d_R);
    bot    = ror & wmask;
    if(v64==0){
      top = (v_usrc1 & (1ULL<<31))? 0xffffffffULL : 0ULL;
    }
    else{
      top = (v_usrc1 & (1ULL<<63))? 0xffffffffffffffffULL : 0ULL;
    }
    v_dst = (long long int)((top & ~tmask)|(bot & tmask));
    break;
  case	UBFM:
    ror    = doEXTR(v_usrc1, v_usrc1, d_R);
    bot    = ror & wmask;
    v_dst = (long long int)(bot & tmask);
    break;
  case	RBIT:
    bot = 0LL;
    if(v64==0){
      for(i=0;i<32;i++){
	if(v_src1 & (1LL<<i))
	  bot |= 1;
	bot <<= 1;
      }
    }
    else{
      for(i=0;i<64;i++){
	if(v_src1 & (1LL<<i))
	  bot |= 1;
	bot <<= 1;
      }
    }
    v_dst = (long long int)i;
    break;
  case	REV16:
    if(v64==0){
      v_udst =
	  (((v_usrc1>> 0)&0xffULL)<< 8)
	| (((v_usrc1>> 8)&0xffULL)<< 0)
	| (((v_usrc1>>16)&0xffULL)<<24)
    	| (((v_usrc1>>24)&0xffULL)<<16);
    }
    else{
      v_udst =
	  (((v_usrc1>> 0)&0xffULL)<< 8)
	| (((v_usrc1>> 8)&0xffULL)<< 0)
	| (((v_usrc1>>16)&0xffULL)<<24)
    	| (((v_usrc1>>24)&0xffULL)<<16)
    	| (((v_usrc1>>32)&0xffULL)<<40)
    	| (((v_usrc1>>40)&0xffULL)<<32)
    	| (((v_usrc1>>48)&0xffULL)<<58)
    	| (((v_usrc1>>56)&0xffULL)<<46);
    }
    v_dst = (long long int)v_udst;
    break;
  case	REV32:
    v64 = 1;
    v_udst =
        (((v_usrc1>> 0)&0xffULL)<<24)
      | (((v_usrc1>> 8)&0xffULL)<<16)
      | (((v_usrc1>>16)&0xffULL)<< 8)
      | (((v_usrc1>>24)&0xffULL)<< 0)
      | (((v_usrc1>>32)&0xffULL)<<56)
      | (((v_usrc1>>40)&0xffULL)<<48)
      | (((v_usrc1>>48)&0xffULL)<<40)
      | (((v_usrc1>>56)&0xffULL)<<32);
    v_dst = (long long int)v_udst;
    break;
  case	REV:
    if(v64==0){
      v_udst =
          (((v_usrc1>> 0)&0xffULL)<<24)
	| (((v_usrc1>> 8)&0xffULL)<<16)
	| (((v_usrc1>>16)&0xffULL)<< 8)
	| (((v_usrc1>>24)&0xffULL)<< 0);
    }
    else{
          (((v_usrc1>> 0)&0xffULL)<<56)
	| (((v_usrc1>> 8)&0xffULL)<<48)
	| (((v_usrc1>>16)&0xffULL)<<40)
	| (((v_usrc1>>24)&0xffULL)<<32)
	| (((v_usrc1>>32)&0xffULL)<<24)
	| (((v_usrc1>>40)&0xffULL)<<16)
	| (((v_usrc1>>48)&0xffULL)<< 8)
	| (((v_usrc1>>56)&0xffULL)<< 0);
    }
    v_dst = (long long int)v_udst;
    break;
  case	SLL:
    if(v64==0)
      v_src2 &= 0x1f;
    else
      v_src2 &= 0x3f;
    v_dst = v_src1 << v_src2;
    break;
  case	SRL:
    if(v64==0)
      v_src2 &= 0x1f;
    else
      v_src2 &= 0x3f;
    v_dst = (long long int)doEXTR(0ULL,v_usrc1,(int)v_src2);
    break;
  case	SRA:
    if(v64==0){
      v_src2 &= 0x1f;
      bot = (v_usrc1 & (1ULL<<31))? 0xffffffffffffffffULL : 0ULL;
    }
    else{
      v_src2 &= 0x3f;
      bot = (v_usrc1 & (1ULL<<63))? 0xffffffffffffffffULL : 0ULL;
    }
    v_dst = (long long int)doEXTR(bot,v_usrc1,(int)v_src2);
    break;
  case	ROR:
    if(v64==0)
      v_src2 &= 0x1f;
    else
      v_src2 &= 0x3f;
    v_dst = (long long int)doEXTR(v_usrc1,v_usrc1,(int)v_src2);
    break;
  case	CSEL:
    v_dst = (cond_check())? v_src1 : v_src2;
    break;
  case	CCMN:
    if(cond_check()){
      v_dst = IADD64(s_extend(v_src1), s_extend(v_src2), 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    }
    else{
      tmp_N_flag = (nzcv & 8)? 1 : 0;
      tmp_Z_flag = (nzcv & 4)? 1 : 0;
      tmp_C_flag = (nzcv & 2)? 1 : 0;
      tmp_V_flag = (nzcv & 1)? 1 : 0;
    }
    break;
  case	CCMP:
    if(cond_check()){
      v_dst = ISUB64(s_extend(v_src1), s_extend(v_src2), 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    }
    else{
      tmp_N_flag = (nzcv & 8)? 1 : 0;
      tmp_Z_flag = (nzcv & 4)? 1 : 0;
      tmp_C_flag = (nzcv & 2)? 1 : 0;
      tmp_V_flag = (nzcv & 1)? 1 : 0;
    }
    break;
  case	CSINC:
    v_dst = (cond_check())? v_src1 : v_src2+1;
    break;
  case	CSINV:
    v_dst = (cond_check())? v_src1 : ~v_src2;
    break;
  case	CSNEG:
    v_dst = (cond_check())? v_src1 : -v_src2;
    break;
  case	NOP:
    break;
  }
  if(v64==0)
    v_dst &= 0xffffffffLL;
  put_reg(rd, v_dst);

  switch(OP2){
  case	FLAG:
    N_flag = tmp_N_flag;
    Z_flag = tmp_Z_flag;
    C_flag = tmp_C_flag;
    V_flag = tmp_V_flag;
    break;
  case	JAL:
    put_reg(30,PC+4);
    PC = (int)v_dst;
    already_npc_set = 1;
    break;
  case	JCC:
    if(cond_check()){
      PC = (int)v_dst;
      already_npc_set = 1;
    }
    break;
  case	JMP:
    PC = (int)v_dst;
    already_npc_set = 1;
    break;
  case	JPR:
    PC = (int)v_src1;
    already_npc_set = 1;
    break;
  case	CBNZ:
    if(v64==0)
      v_src3 &= 0xffffffffLL;
    else
      v_src3 &= 0xffffffffffffffffLL;
    if(v_src3 != 0LL){
      PC = (int)v_dst;
      already_npc_set = 1;
    }
    break;
  case	CBZ:
    if(v64==0)
      v_src3 &= 0xffffffffLL;
    else
      v_src3 &= 0xffffffffffffffffLL;
    if(v_src3 == 0LL){
      PC = (int)v_dst;
      already_npc_set = 1;
    }
    break;
  case	TBNZ:
    if((v_src3 & (1LL<<bit_pos))!=0LL){
      PC = (int)v_dst;
      already_npc_set = 1;
    }
    break;
  case	TBZ:
    if((v_src3 & (1LL<<bit_pos))==0LL){
      PC = (int)v_dst;
      already_npc_set = 1;
    }
    break;
  case	LDPC:
    v_dst &= 0xffffffffLL;
    if(msize==WORD){
      bot = (unsigned long long int)get_mem((int)v_dst, WORD);
      if(msex)
	bot = (bot & (1ULL<<31))? 0xffffffff00000000ULL|bot : 0xffffffffULL&bot;
      else
	bot = 0xffffffffULL&bot;
    }
    else{
      bot = (unsigned long long int)get_mem(((int)v_dst)+0, WORD);
      top = (unsigned long long int)get_mem(((int)v_dst)+4, WORD);
      bot = (top<<32)|(bot & 0xffffffffULL);
    }
    put_reg(rd, (long long int)bot);
    break;
  case	LD:
  case	LDUR:
    v_dst &= 0xffffffffLL;
    if(post_index)
      addr = (int)(v_src1 & 0xffffffffLL);
    else
      addr = (int)v_dst;
    if(msize!=DWORD){
      bot = (unsigned long long int)get_mem(addr, WORD);
      switch(msize){
      case BYTE:
	if(msex)
	  bot = (bot & (1ULL<<7))? 0xffffffffffffff00ULL|bot : 0xffULL&bot;
	else
	  bot = 0xffULL&bot;
	break;
      case HWORD:
	if(msex)
	  bot = (bot & (1ULL<<15))? 0xffffffffffff0000ULL|bot : 0xffffULL&bot;
	else
	  bot = 0xffffULL&bot;
	break;
      case WORD:
	if(msex)
	  bot = (bot & (1ULL<<31))? 0xffffffff00000000ULL|bot : 0xffffffffULL&bot;
	else
	  bot = 0xffffffffULL&bot;
	break;
      }
    }
    else{
      bot = (unsigned long long int)get_mem(addr+0, WORD);
      top = (unsigned long long int)get_mem(addr+4, WORD);
      bot = (top<<32)|(bot & 0xffffffffULL);
    }
    put_reg(rd, (long long int)bot);
    if(mwback)
      put_reg(rs1, (int)v_dst);
    break;
  case	STUR:
  case	ST:
    v_dst &= 0xffffffffLL;
    if(post_index)
      addr = (int)(v_src1 & 0xffffffffLL);
    else
      addr = (int)v_dst;
    if(msize!=DWORD){
      v_src3 &= 0xffffffffLL;
      put_mem(addr, (int)v_src3, msize);
    }
    else{
      bot = v_usrc3 & 0xffffffffULL;
      top = (v_usrc3>>32) & 0xffffffffULL;
      put_mem(addr+0, (int)bot, WORD);
      put_mem(addr+4, (int)top, WORD);
    }
    if(mwback)
      put_reg(rs1, (int)v_dst);
    break;
  case	LDNP:
  case	LDP:
    v_dst &= 0xffffffffLL;
    if(post_index)
      addr = (int)(v_src1 & 0xffffffffLL);
    else
      addr = (int)v_dst;
    if(msize!=DWORD){
      bot = (unsigned long long int)get_mem(addr+0, WORD);
      top = (unsigned long long int)get_mem(addr+4, WORD);
      if(msex){
	bot = (bot & (1ULL<<31))? 0xffffffff00000000ULL|bot : 0xffffffffULL&bot;
	top = (top & (1ULL<<31))? 0xffffffff00000000ULL|top : 0xffffffffULL&top;
      }
      else{
	bot = 0xffffffffULL&bot;
	top = 0xffffffffULL&top;
      }
    }
    else{
      bot  = (unsigned long long int)get_mem(addr+0, WORD);
      bot2 = (unsigned long long int)get_mem(addr+4, WORD);
      top  = (unsigned long long int)get_mem(addr+8, WORD);
      top2 = (unsigned long long int)get_mem(addr+12, WORD);
      bot = (bot2<<32)|(bot & 0xffffffffULL);
      top = (top2<<32)|(top & 0xffffffffULL);
    }
    put_reg(rd,  (long long int)bot);
    put_reg(rd2, (long long int)top);
    if(mwback)
      put_reg(rs1, (int)v_dst);
    break;
  case	STNP:
  case	STP:
    v_dst &= 0xffffffffLL;
    if(post_index)
      addr = (int)(v_src1 & 0xffffffffLL);
    else
      addr = (int)v_dst;
    if(msize!=DWORD){
      put_mem(addr+0,(int)(v_src3&0xffffffffLL),WORD);
      put_mem(addr+4,(int)(v_src4&0xffffffffLL),WORD);
    }
    else{
      put_mem(addr+0,(int)((v_src3>> 0)&0xffffffffLL),WORD);
      put_mem(addr+4,(int)((v_src3>>32)&0xffffffffLL),WORD);
      put_mem(addr+8,(int)((v_src4>> 0)&0xffffffffLL),WORD);
      put_mem(addr+12,(int)((v_src4>>32)&0xffffffffLL),WORD);
    }
    if(mwback)
      put_reg(rs1, (int)v_dst);
    break;
  case	UDF:
    break;
  }

  if(already_npc_set==0){
    PC = PC+4;
  }
    
}
