#define EADDR	100
#define AND	101
#define XOR	102
#define SUB	103
#define RSB	104
#define ADD	105
#define ADC	106
#define SBC	107
#define RSC	108
#define TST	109
#define TEQ	110
#define CMP	111
#define CMN	112
#define OR	113
#define MOV	114
#define BIC	115
#define MVN	116
#define CLZ	117
#define LDM	118
#define MLA	119
#define MLS	120
#define MUL	121
#define ROR	123
#define RRX	124
#define SDIV	125
#define SLL	126
#define SMLA	127
#define SMLAL	128
#define SMLAW	129
#define SMUL	130
#define SMULL	131
#define SMULW	132
#define SRA	133
#define SRL	134
#define STM	135
#define UDIV	136
#define UMAAL	137
#define UMLAL	138
#define UMULL	139
#define SEX	140
#define ZEX	141
#define SBFX	142
#define UBFX	143
#define BFC     144
#define BFI     145

#define SMLAxy  160
#define SMLAWxy 161
#define SMULWxy 162
#define SMLALxy 163
#define SMULxy  164

#define FLAG	200
#define JMP	201
#define JPR	202
#define LD	203
#define LDREX	204
#define NOP	205
#define ST	206
#define STREX	207
#define SWP	208
#define UDF	209

#define	IMMD	300
#define NONE	301
#define	NEXT_PC	302

#define	BYTE	400
#define	HWORD	401
#define	WORD	402
#define	DWORD	403

#define	DA	500
#define	DB	501
#define	IA	502
#define	IB	503

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

