#define ADC  100
#define ADD  101
#define AND  102
#define BRK  103
#define CPS  104
#define DMB  105
#define DSB  106
#define FLAG  107
#define ISB  108
#define JAL  109
#define JCC  110
#define JPR  111
#define LD  112
#define LDM  113
#define MOV  114
#define MRS  115
#define MSR  116
#define MUL  117
#define NAND  118
#define NOP  119
#define NOT  121
#define NSUB  122
#define OR   123
#define POP  124
#define PUSH  125
#define REV  126
#define ROR  127
#define SBC  128
#define SEV  129
#define SEX  130
#define SLL  131
#define SRA  132
#define SRL  133
#define ST  134
#define STM  135
#define SUB  136
#define SVC  137
#define UDF  138
#define WFE  139
#define WFI  140
#define XOR  141
#define YIELD  142
#define ZEX  143

#define IMMD 200
#define NEXT_PC  201
#define NEXT2_PC 202
#define NEXT3_PC 203
#define NONE 999


#define WORD  0
#define HWORD 1
#define BYTE  2

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

