#include <stdio.h>
#include "define.h"
static int rs1;
static int rs2;
static int rs3;
static int rd;
static int immd;
static int OP;
static int OP2;
static int PC;
static int PC1;
static int PC2;
static int COND;

static int inst_reg;
static int inst_reg2;
static int inst_reg3;

static int opcode;

static int inst32(int inst)
{
  opcode = (inst>>11)&0x1f;
  if((opcode&0x1c)==0x1c){
    if(opcode==0x1c){/* 16bit-length */
      return 0;
    }
    else {/* 32bit-length */
      return 1;
    }
  }
  else{/* 16bit-length */
    return 0;
  }
  return 0;
}

static void dis_fetch(void)
{
  inst_reg  = get_mem(PC, HWORD);
  if(inst32(inst_reg)){
    inst_reg2 = get_mem(PC+2, HWORD);
    PC1 = PC+4;
  }
  else{
    inst_reg2 = 0;
    PC1 = PC+2;
  }
  //  inst_reg3  = get_mem(PC1, HWORD);
  //  if(inst32(inst_reg3)){
  //    PC2 = PC1+4;
  //  }
  //  else{
  //    PC2 = PC1+2;
  //  }
  PC2 = PC+4;
}

static void simple_dec(void)
{
	opcode = (inst_reg>>9)&0x1f;
	
	switch(opcode){
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:/* Logical Shift Left */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd = (inst_reg>>6)&0x1f;
			printf("lsls\tr%d,r%d,#0x%x\n",rd,rs1,immd);
			break;
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:/* Logical Shift Right */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd = (inst_reg>>6)&0x1f;
			printf("lsrs\tr%d,r%d,#0x%x\n",rd,rs1,immd);
			break;
		case 0x08:
		case 0x09:
		case 0x0a:
		case 0x0b:/* Arithmetic Shift Right */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd = (inst_reg>>6)&0x1f;
			printf("asrs\tr%d,r%d,#0x%x\n",rd,rs1,immd);
			break;
		case 0x0c:/* Add Register */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= (inst_reg>>6)&0x7;
			rd	= inst_reg&0x7;
			immd = 0;
			printf("adds\tr%d,r%d,r%d\n",rd,rs1,rs2);
			break;
		case 0x0d:/* Subtract Register */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= (inst_reg>>6)&0x7;
			rd	= inst_reg&0x7;
			immd = 0;
			printf("subs\tr%d,r%d,r%d\n",rd,rs1,rs2);
			break;
		case 0x0e:/* Add 3bit */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd = (inst_reg>>6)&0x7;
			printf("adds\tr%d,r%d,#0x%x\n",rd,rs1,immd);
			break;
		case 0x0f:/* Subtract 3bit */
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd = (inst_reg>>6)&0x7;
			printf("subs\tr%d,r%d,#0x%x\n",rd,rs1,immd);
			break;
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:/* Move */
			rs1	= 0;
			rs2	= 0;
			rd	= (inst_reg>>8)&0x7;
			immd    = inst_reg&0xff;
			printf("movs\tr%d,#0x%x\n",rd,immd);
			break;
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:/* Compare */
			rs1 = (inst_reg>>8)&0x7;
			rs2	= IMMD;
			rd      = NONE;
			immd    = inst_reg&0xff;
			printf("cmp\tr%d,#0x%x\n",rs1,immd);
			break;
		case 0x18:
		case 0x19:
		case 0x1a:
		case 0x1b:/* Add 8-bit */
			rs1 = (inst_reg>>8)&0x7;
			rs2	= IMMD;
			rd	= (inst_reg>>8)&0x7;
			immd    = inst_reg&0xff;
			printf("adds\tr%d,#0x%x\n",rs1,immd);
			break;
		default:/* Subtract 8-bit */
			rs1 = (inst_reg>>8)&0x7;
			rs2	= IMMD;
			rd	= (inst_reg>>8)&0x7;
			immd    = inst_reg&0xff;
			printf("subs\tr%d,#0x%x\n",rs1,immd);
			break;
	}
}

static void data_dec(void)
{
	opcode = (inst_reg>>6)&0xf;
	
	rs1	= inst_reg&0x7;
	rs2	= (inst_reg>>3)&0x7;
	rd	= inst_reg&0x7;
	immd = 0;
	
	switch(opcode){
		case 0x0:
		  printf("ands\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x1:
		  printf("eors\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x2:
		  printf("lsls\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x3:
		  printf("lsrs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x4:
		  printf("asrs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x5:
		  printf("adcs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x6:
		  printf("sbcs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x7:
		  printf("rors\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x8:
		  printf("tst\tr%d,r%d\n",rd,rs2);
		  break;
		case 0x9:
		  printf("rsbs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0xa:
		  printf("cmp\tr%d,r%d\n",rs1,rs2);
		  break;
		case 0xb:
		  printf("cmn\tr%d,r%d\n",rs1,rs2);
		  break;
		case 0xc:
		  printf("orrs\tr%d,r%d\n",rd,rs2);
		  break;
		case 0xd:
		  printf("muls\tr%d,r%d\n",rd,rs2);
		  break;
	        case 0xe:
		  printf("bics\tr%d,r%d\n",rd,rs2);
		  break;
		default:
		  printf("mvns\tr%d,r%d\n",rd,rs2);
		  break;
	}
}

static void special_dec(void)
{
	opcode = (inst_reg>>6)&0xf;
	
	switch(opcode){
		case 0x0:
		case 0x1:
		case 0x2:
		case 0x3:
			rs1	= (((inst_reg>>7)&0x1)<<3)|(inst_reg&0x7);
			rs2	= (inst_reg>>3)&0xf;
			rd	= rs1;
			printf("add\tr%d,r%d\n",rd,rs2);
			break;
		case 5:
		case 6:
		case 7:
			rs1	= (((inst_reg>>7)&0x1)<<3)|(inst_reg&0x7);
			rs2	= (inst_reg>>3)&0xf;
			printf("cmp\tr%d,r%d\n",rs1,rs2);
			break;
		case 8:
		case 9:
		case 0xa:
		case 0xb:
			rs1	= (inst_reg>>3)&0xf;
			rs2	= 0;
			rd	= (((inst_reg>>7)&0x1)<<3)|(inst_reg&0x7);
			printf("mov\tr%d,r%d\n",rd,rs1);
			break;
		case 0xc:
		case 0xd:
			rs1	= 0;
			rs2	= (inst_reg>>3)&0xf;
			rd	= 0;
			printf("bx\tr%d\n",rs2);
			break;
		case 0xe:
		case 0xf:
			rs1	= 0;
			rs2	= (inst_reg>>3)&0xf;
			rd	= 14;
			printf("blx\tr%d\n",rs2);
			break;
		default:
			printf(".hword\t0x%04x\n",inst_reg&0xffff);
			break;
	}
}

static void loadpc_dec(void)
{
	rs1	= 0;
	rs2	= 0;
	rd	= (inst_reg>>8)&0x7;
	immd = (inst_reg&0xff)<<2;
	printf("ldr\tr%d,[pc,#0x%x] -- 0x%08x\n",rd,immd,(PC2&0xfffffffc)+immd);
}

static void load_store_dec(void)
{
	int opA, opB;
	int OP2;
	int msize, msex;
	
	opA = (inst_reg>>12)&0xf;
	opB = (inst_reg>> 9)&0x7;
	
	switch(opA){
		case 5:
			switch(opB){
				case 0:
					OP2	= ST;
					msize	= WORD;
					msex	= 0;
					break;
				case 1:
					OP2	= ST;
					msize	= HWORD;
					msex	= 0;
					break;
				case 2:
					OP2	= ST;
					msize	= BYTE;
					msex	= 0;
					break;
				case 3:
					OP2	= LD;
					msize	= BYTE;
					msex	= 1;
					break;
				case 4:
					OP2	= LD;
					msize	= WORD;
					msex	= 0;
					break;
				case 5:
					OP2	= LD;
					msize	= HWORD;
					msex	= 0;
					break;
				case 6:
					OP2	= LD;
					msize	= BYTE;
					msex	= 0;
					break;
				default:
					OP2	= LD;
					msize	= HWORD;
					msex	= 1;
					break;
			}
			if(OP2==ST){
				rs1	= (inst_reg>>3)&0x7;
				rs2	= (inst_reg>>6)&0x7;
				rs3	= (inst_reg>>0)&0x7;
				rd	= 0;
				switch(msize){
				case WORD:
				  printf("str\tr%d,[r%d,r%d]\n",rs3,rs1,rs2);
				  break;
				case HWORD:
				  printf("strh\tr%d,[r%d,r%d]\n",rs3,rs1,rs2);
				  break;
				case BYTE:
				  printf("strb\tr%d,[r%d,r%d]\n",rs3,rs1,rs2);
				  break;
				}
			}
			else{
				rs1	= (inst_reg>>3)&0x7;
				rs2	= (inst_reg>>6)&0x7;
				rs3	= 0;
				rd	= (inst_reg>>0)&0x7;
				switch(msize){
				case WORD:
				  printf("ldr\tr%d,[r%d,r%d]\n",rd,rs1,rs2);
				  break;
				case HWORD:
				  if(msex){
				    printf("ldrsh\tr%d,[r%d,r%d]\n",rd,rs1,rs2);
				  }
				  else{
				    printf("ldrh\tr%d,[r%d,r%d]\n",rd,rs1,rs2);
				  }
				  break;
				case BYTE:
				  if(msex){
				    printf("ldrsb\tr%d,[r%d,r%d]\n",rd,rs1,rs2);
				  }
				  else{
				    printf("ldrb\tr%d,[r%d,r%d]\n",rd,rs1,rs2);
				  }
				  break;
				}
			}
			break;
		case 6:
			if(opB&0x4){
				OP2	= LD;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= 0;
				rd	= inst_reg&0x7;
				immd	= ((inst_reg>>6)&0x1f)<<2;
				printf("ldr\tr%d,[r%d,#0x%x]\n",rd,rs1,immd);
			}
			else{
				OP2	= ST;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= inst_reg&0x7;
				rd	= 0;
				immd	= ((inst_reg>>6)&0x1f)<<2;
				printf("str\tr%d,[r%d,#0x%x]\n",rs3,rs1,immd);
			}
			break;
		case 7:
			if(opB&0x4){
				OP2	= LD;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= 0;
				rd	= inst_reg&0x7;
				immd	= (inst_reg>>6)&0x1f;
				printf("ldrb\tr%d,[r%d,#0x%x]\n",rd,rs1,immd);
			}
			else{
				OP2	= ST;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= inst_reg&0x7;
				rd	= 0;
				immd	= (inst_reg>>6)&0x1f;
				printf("strb\tr%d,[r%d,#0x%x]\n",rs3,rs1,immd);
			}
			break;
		case 8:
			if(opB&0x4){
				OP2	= LD;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= 0;
				rd	= inst_reg&0x7;
				immd	= ((inst_reg>>6)&0x1f)<<1;
				printf("ldrh\tr%d,[r%d,#0x%x]\n",rd,rs1,immd);
			}
			else{
				OP2	= ST;
				rs1	= (inst_reg>>3)&0x7;
				rs2	= 0;
				rs3	= inst_reg&0x7;
				rd	= 0;
				immd	= ((inst_reg>>6)&0x1f)<<1;
				printf("strh\tr%d,[r%d,#0x%x]\n",rs3,rs1,immd);
			}
			break;
		case 9:
			if(opB&0x4){
				OP2	= LD;
				rs1	= 13;
				rs2	= 0;
				rs3	= 0;
				rd	= (inst_reg>>8)&0x7;
				immd	= (inst_reg&0xff)<<2;
				printf("ldrh\tr%d,[r%d,#0x%x]\n",rd,rs1,immd);
			}
			else{
				OP2	= ST;
				rs1	= 13;
				rs2	= 0;
				rs3	= (inst_reg>>8)&0x7;
				rd	= 0;
				immd	= (inst_reg&0xff)<<2;
				printf("strh\tr%d,[r%d,#0x%x]\n",rs3,rs1,immd);
			}
			break;
	}
			
}

static void addr_dec(void)
{
	rs1	= 0;
	rs2	= 0;
	rd	= (inst_reg>>8)&0x7;
	immd = (inst_reg&0xff)<<2;
	printf("add\tr%d,pc,#0x%x -- 0x%08x\n",rd,immd,(PC2&0xfffffffc)+immd);
}

static void stack_dec(void)
{
	rs1	= 13;
	rs2	= 0;
	rd	= (inst_reg>>8)&0x7;
	immd = (inst_reg&0xff)<<2;
	printf("add\tr%d,r13,#0x%x\n",rd,immd);
}


static char RL[4*16+2];

static char* reg_list(int list)
{
  int i;
  char *p=RL;
  *p++ = '{';
  for(i=0;i<10;i++){
    if(list&(1<<i)){
      *p++ = 'r';
      *p++ = (i+'0');
      list = list ^ (1<<i);
      if(list==0){
	*p++ = '}';
	*p++ = 0;
	return RL;
      }
      else{
	*p++ = ',';
      }
    }
  }
  for(i=10;i<16;i++){
    if(list&(1<<i)){
      *p++ = 'r';
      *p++ = '1';
      *p++ = (i-10+'0');
      list = list ^ (1<<i);
      if(list==0){
	*p++ = '}';
	*p++ = 0;
	return RL;
      }
      else{
	*p++ = ',';
      }
    }
  }
  *p++ = '}';
  *p++ = 0;
  return RL;
}


static void misc_dec(void)
{
	int opA, opB;
	
	opcode = (inst_reg>>5)&0x7f;
	
	switch(opcode){
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
			rs1	= 13;
			rs2	= 0;
			rd	= 13;
			immd	= (inst_reg&0x7f)<<2;
			if(opcode&4){
			  printf("sub\tr13,#0x%x\n",immd);
			}
			else{
			  printf("add\tr13,#0x%x\n",immd);
			}
			break;
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			if(opcode&2){
			  printf("sxtb\tr%d,r%d\n",rd,rs1);
			}
			else{
			  printf("sxth\tr%d,r%d\n",rd,rs1);
			}
			break;
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			if(opcode&2){
			  printf("uxtb\tr%d,r%d\n",rd,rs1);
			}
			else{
			  printf("uxth\tr%d,r%d\n",rd,rs1);
			}
			break;
		case 0x20:
		case 0x21:
		case 0x22:
		case 0x23:
		case 0x24:
		case 0x25:
		case 0x26:
		case 0x27:
		case 0x28:
		case 0x29:
		case 0x2a:
		case 0x2b:
		case 0x2c:
		case 0x2d:
		case 0x2e:
		case 0x2f:
			immd	= (inst_reg&0xff)|(((inst_reg>>8)&1)<<14);
			printf("push\t%s\n",reg_list(immd));
			break;
		case 0x33:
			immd	= (inst_reg>>4)&1;
			if(immd){
			  printf("cpsid\n");
			}
			else{
			  printf("cpsie\n");
			}
			break;
		case 0x50:
		case 0x51:
		case 0x52:
		case 0x53:
		case 0x56:
		case 0x57:
			rs1	= (inst_reg>>3)&0x7;
			rs2	= 0;
			rd	= inst_reg&0x7;
			immd	= (opcode>>1)&0x3;
			if(immd==0){
			  printf("rev\tr%d,r%d\n",rd,rs1);
			}
			else if(immd==1){
			  printf("rev16\tr%d,r%d\n",rd,rs1);
			}
			else{
			  printf("revsh\tr%d,r%d\n",rd,rs1);
			}
			break;
		case 0x60:
		case 0x61:
		case 0x62:
		case 0x63:
		case 0x64:
		case 0x65:
		case 0x66:
		case 0x67:
		case 0x68:
		case 0x69:
		case 0x6a:
		case 0x6b:
		case 0x6c:
		case 0x6d:
		case 0x6e:
		case 0x6f:
			immd	= (inst_reg&0xff)|(((inst_reg>>8)&1)<<15);
			printf("pop\t%s\n",reg_list(immd));
			break;
		case 0x70:
		case 0x71:
		case 0x72:
		case 0x73:
		case 0x74:
		case 0x75:
		case 0x76:
		case 0x77:
			immd	= inst_reg&0xff;
			printf("bkpt\t#0x%x\n",immd);
			break;
		case 0x78:
		case 0x79:
		case 0x7a:
		case 0x7b:
		case 0x7c:
		case 0x7d:
		case 0x7e:
		case 0x7f:
			opA	= (inst_reg>>4)&0xf;
			opB	= inst_reg&0xf;
			if(opB!=0){
				printf(".word\t0x%04x\n",inst_reg&0xffff);
			}
			else{
				switch(opA){
					case 0:
						printf("nop\n");
						break;
					case 1:
						printf("yield\n");
						break;
					case 2:
						printf("wfe\n");
						break;
					case 3:
						printf("wfi\n");
						break;
					case 4:
						printf("sev\n");
						break;
					default:
						printf(".word\t0x%04x\n",inst_reg&0xffff);
						break;
				}
			}
			break;
		default:
			printf(".word\t0x%04x\n",inst_reg&0xffff);
			break;
	}
}

static void stm_dec(void)
{
        immd	= inst_reg&0xff;
	rs1	= (inst_reg>>8)&0x7;
	printf("stm\tr%d!,%s\n",rs1,reg_list(immd));
}

static void ldm_dec(void)
{
	immd	= inst_reg&0xff;
	rs1	= (inst_reg>>8)&0x7;
	if(immd&(1<<rs1))
	  printf("ldm\tr%d,%s\n",rs1,reg_list(immd));
	else
	  printf("ldm\tr%d!,%s\n",rs1,reg_list(immd));
}

static void jcc_dec(void)
{
	opcode	= (inst_reg>>8)&0xf;
	
	switch(opcode){
		case 0xe:
			immd    = inst_reg &0xff;
			printf("udf\t#0x%x\n",immd);
			break;
		case 0xf:
			immd    = inst_reg &0xff;
			printf("svc\t#0x%x\n",immd);
			break;
		default:
			immd	= (inst_reg &0xff);
			immd	= (immd &0x80)? 0xffffff00| immd : immd;
			immd	= immd <<1;
			immd    = PC2+immd;/* target */
			COND	= (inst_reg>>8)&0xf;
			switch(COND){
			case 0x0:
			  printf("beq\t0x%08x\n",immd);
			  break;
			case 0x1:
			  printf("bne\t0x%08x\n",immd);
			  break;
			case 0x2:
			  printf("bcs\t0x%08x\n",immd);
			  break;
			case 0x3:
			  printf("bcc\t0x%08x\n",immd);
			  break;
			case 0x4:
			  printf("bmi\t0x%08x\n",immd);
			  break;
			case 0x5:
			  printf("bpl\t0x%08x\n",immd);
			  break;
			case 0x6:
			  printf("bvs\t0x%08x\n",immd);
			  break;
			case 0x7:
			  printf("bvc\t0x%08x\n",immd);
			  break;
			case 0x8:
			  printf("bhi\t0x%08x\n",immd);
			  break;
			case 0x9:
			  printf("bls\t0x%08x\n",immd);
			  break;
			case 0xa:
			  printf("bge\t0x%08x\n",immd);
			  break;
			case 0xb:
			  printf("blt\t0x%08x\n",immd);
			  break;
			case 0xc:
			  printf("bgt\t0x%08x\n",immd);
			  break;
			case 0xd:
			  printf("ble\t0x%08x\n",immd);
			  break;
			case 0xe:
			  printf("b\t0x%08x\n",immd);
			  break;
			}
			break;
	}
}

static void jmp_dec(void)
{
	immd	= (inst_reg &0x7ff);
	immd	= (immd &0x400)? 0xfffff800| immd : immd;
	immd	= immd <<1;
	immd    = immd+PC2;
	printf("b\t0x%08x\n",immd);
}

static char * SYSm[]={
  "APSR",
  "IAPSR",
  "EAPSR",
  "xPSR",
  "SYS4",
  "IPSR",
  "EPSR",
  "IEPSR",
  "MSP",
  "PSP",
  "SYS10",
  "SYS11",
  "SYS12",
  "SYS13",
  "SYS14",
  "SYS15",
  "PRIMASK",
  "SYS17",
  "SYS18",
  "SYS19",
  "CONTROL",
  "SYS21",
  "SYS22",
  "SYS23",
  "SYS24",
  "SYS25",
  "SYS26",
  "SYS27",
  "SYS28",
  "SYS29",
  "SYS30",
  "SYS31",
};

static void long_dec(void)
{
	int op1,op2;
	
	op1	= (inst_reg>>11)&3;
	op2	= (inst_reg2>>15)&1;
	if((op1==2)&&(op2==1)){
		op1	= (inst_reg>>4)&0x7f;
		op2	= (inst_reg2>>12)&0x7;
		if(((op2&0x5)==0)&&((op1&0x7e)==0x38)){
			rs1	= inst_reg&0xf;
			rs2	= 0;
			rd	= inst_reg2&0x1f;
			printf("nsr\t%s,r%d\n",SYSm[rd],rs1);
		}
		else if(((op2&0x5)==0)&&((op1&0x7f)==0x3b)){
			op1	= (inst_reg2>>4)&0xf;
			if(op1==4){
				immd	= inst_reg2&0xf;
				printf("dsb\t(0x%x)\n",immd);
			}
			else if(op1==5){
				immd	= inst_reg2&0xf;
				printf("dmb\t(0x%x)\n",immd);
			}
			else if(op1==6){
				immd	= inst_reg2&0xf;
				printf("isb\t(0x%x)\n",immd);
			}
			else{
				printf(".word\t0x%04x%04x",inst_reg2&0xffff,inst_reg&0xffff);
			}
		}
		else if(((op2&0x5)==0)&&((op1&0x7f)==0x3e)){
			rs1	= (inst_reg2>>0)&0x1f;
			rs2	= 0;
			rd	= (inst_reg2>>8)&0xf;
			printf("nrs\tr%d,%s\n",rd,SYSm[rd]);
		}
		else if((op2==2)&&(op1==0x7f)){
			printf(".word\t0x%04x%04x",inst_reg2&0xffff,inst_reg&0xffff);
		}
		else if((op2&0x5)==5){
			int s, J1, J2;
			int I1, I2;
			int imm10, imm11;
			s	= (inst_reg>>10)&1;
			J1	= (inst_reg2>>13)&1;
			J2	= (inst_reg2>>11)&1;
			I1	= (J1 ^ s)^1;
			I2	= (J2 ^ s)^1;
			imm10	= inst_reg&0x3ff;
			imm11	= inst_reg2&0x7ff;
			immd	= (s<<23)|(I1<<22)|(I2<<21)|(imm10<<11)|imm11;
			immd	= (immd & (1<<23))? 0xff000000|immd : immd;
			immd	= immd <<1;			
			immd    = immd + PC2;/* target */
			printf("bl\t0x%08x\n",immd);
		}
		else{
			printf(".word\t0x%04x%04x",inst_reg2&0xffff,inst_reg&0xffff);
		}
	}
	else{
		printf(".word\t0x%04x%04x",inst_reg2&0xffff,inst_reg&0xffff);
	}
}

void dis(void)
{
	opcode = (inst_reg>>10)&0x3f;
	
	switch(opcode){
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case 0x09:
		case 0x0a:
		case 0x0b:
		case 0x0c:
		case 0x0d:
		case 0x0e:
		case 0x0f:
			simple_dec();
			break;
		case 0x10:
			data_dec();
			break;
		case 0x11:
			special_dec();
			break;
	        case 0x12:
		case 0x13:
			loadpc_dec();
			break;
		case 0x14:
		case 0x15:
		case 0x16:
	        case 0x17:
		case 0x18:
		case 0x19:
		case 0x1a:
		case 0x1b:
		case 0x1c:
		case 0x1d:
		case 0x1e:
		case 0x1f:
		case 0x20:
		case 0x21:
		case 0x22:
		case 0x23:
		case 0x24:
		case 0x25:
		case 0x26:
		case 0x27:
			load_store_dec();
			break;
		case 0x28:
		case 0x29:
			addr_dec();
			break;
		case 0x2a:
		case 0x2b:
			stack_dec();
			break;
		case 0x2c:
		case 0x2d:
		case 0x2e:
		case 0x2f:
			misc_dec();
			break;
		case 0x30:
		case 0x31:
			stm_dec();
			break;
		case 0x32:
		case 0x33:
			ldm_dec();
			break;
		case 0x34:
		case 0x35:
		case 0x36:
		case 0x37:
			jcc_dec();
			break;
		case 0x38:
		case 0x39:
			jmp_dec();
			break;
		default:
			long_dec();
			break;
	}
}
		
		
 void disasm(unsigned int addr1, unsigned int addr2)
 {
   PC = (int)addr1;
   while(1){
     dis_fetch();
     printf("%08x ",PC);
     dis();
     if(((unsigned int)PC2)>addr2)
       break;
     PC = PC1;
   }
 }
