#include "define.h"


static int tmp_N_flag=0;
static int tmp_Z_flag=0;
static int tmp_C_flag=0;
static int tmp_V_flag=0;
static int already_npc_set;

int N_flag=0;
int Z_flag=0;
int C_flag=0;
int V_flag=0;


extern int rs1;
extern int rs2;
extern int rs3;
extern int rd;
extern int immd;
extern int OP;
extern int OP2;
extern int COND;
extern int msize;
extern int msex;

extern int PC;
extern int PC1;
extern int PC2;

static int IADD32(int src1, int src2, int carry, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)(src1 & 0xffffffffLL);
  s2 = (unsigned long long)(src2 & 0xffffffffLL);
  d  = s1 + s2 + carry;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==0)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==1)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}

static int ISUB32(int src1, int src2, int borrow, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)( src1 & 0xffffffffLL);
  s2 = (unsigned long long)(~src2 & 0xffffffffLL);
  d  = s1 + s2 + 1 - borrow;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==1)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==0)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}


static int IMUL32(int src1, int src2, int* n, int* z, int* c, int* v)
{
  int d;
  d = src1 * src2;
  *n      = (d & 0x80000000)? 1 : 0;
  *z      = (d == 0)? 1 : 0;
  *c      = 0;
  *v      = 0;
  return d;
}

static int ISFT32(int src, int sa, int* n, int* z, int* c, int* v)
{
  long long int d;
  int cy;
  int z_val;
  int d_sign;

  sa = sa &0x1f;
  if(sa == 0){
    cy     = C_flag;
    z_val  = (src==0)? 1 : 0;
    d_sign = (src&0x80000000)? 1: 0;
    d      = src;
  }
  else{
    switch(OP){
    case ROR:
      d = (long long int)src;
      break;
    case SRA:
      if(src&0x80000000)
	d = (long long int)0xffffffffLL;
      else
	d = (long long int)0x00000000LL;
      break;
    case SRL:
    case SLL:
      d = (long long int)0x00000000LL;
      break;
    }
    d = (d<<32)|(src&0xffffffffLL);
    if(OP==SLL){
      cy  = (d & (1LL<<(32-sa))) ? 1: 0;
      d = d << sa;
    }
    else{
      cy  = (d & (1LL<<(sa-1))) ? 1: 0;
      d = d >> sa;
    }
    d = d & 0xffffffffLL;
    z_val  = (d==0LL)? 1 : 0;
    d_sign = (d&0x80000000LL)? 1 : 0;
  }
  *n = d_sign;
  *z = z_val;
  *c = cy;
  *v = 0;
  return (int)d;
}

static int v_dst;
static int v_src1;
static int v_src2;
static int v_src3;

static int BitCount(int n)
{
  int i;
  int v;
  v = 0;
  for(i=0;i<32;i++){
    if(n&(1<<i))
      v++;
  }
  return v;
}

static void do_ldstm(void)
{
  int addr;
  int i;
  if(OP==STM){
    addr = get_reg(rs1);
    for(i=0;i<8;i++){
      if(immd&(1<<i)){
	put_mem(addr,get_reg(i),WORD);
	addr = addr+4;
      }
    }
    put_reg(rs1, get_reg(rs1) + 4*BitCount(immd));
  }
  else{
    addr = get_reg(rs1);
    for(i=0;i<8;i++){
      if(immd&(1<<i)){
	put_reg(i,get_mem(addr,WORD));
	addr = addr+4;
      }
    }
    if((immd&(1<<rs1))==0)
      put_reg(rs1, get_reg(rs1) + 4*BitCount(immd));
  }
}

static void do_push_pop(void)
{
  int addr;
  int i;
  if(OP==PUSH){
    addr = get_reg(13) - 4*BitCount(immd);
    for(i=0;i<16;i++){
      if(immd&(1<<i)){
	put_mem(addr,get_reg(i),WORD);
	addr = addr+4;
      }
    }
    put_reg(13,get_reg(13) - 4*BitCount(immd));
  }
  else{
    addr = get_reg(13);
    for(i=0;i<16;i++){
      if(immd&(1<<i)){
	put_reg(i,get_mem(addr,WORD));
	addr = addr+4;
	if(i==15){
	  already_npc_set = already_npc_set|1;
	}
      }
    }
    put_reg(13,get_reg(13)+4*BitCount(immd));
  }
}

static int get_value(int n)
{
  if((n>=0)&&(n<=14))
    return get_reg(n);
  if(n==15)
    return PC2;
  if(n==IMMD)
    return immd;
  if(n==NEXT_PC)
    return PC1;
  if(n==NEXT2_PC)
    return PC2;
  if(n==NEXT3_PC)
      return PC2&0xfffffffc;
  return 0;
}

static void put_value(int n, int v)
{
  if((n>=0)&&(n<=14)){
    put_reg(n,v);
    return;
  }
  if(n==15){
    PC = (v&0xfffffffe);
    already_npc_set = already_npc_set|1;
    return;
  }
  return;
}

static int cond_check()
{
  switch(COND){
  case 0x0:
    return (Z_flag==1);
  case 0x1:
    return (Z_flag==0);
  case 0x2:
    return (C_flag==1);
  case 0x3:
    return (C_flag==0);
  case 0x4:
    return (N_flag==1);
  case 0x5:
    return (N_flag==0);
  case 0x6:
    return (V_flag==1);
  case 0x7:
    return (V_flag==0);
  case 0x8:
    return ((C_flag==1)&&(Z_flag==0));
  case 0x9:
    return ((C_flag==0)||(Z_flag==1));
  case 0xa:
    return (N_flag==V_flag);
  case 0xb:
    return (N_flag!=V_flag);
  case 0xc:
    return ((Z_flag==0)&&(N_flag==V_flag));
  case 0xd:
    return ((Z_flag==1)||(N_flag!=V_flag));
  case 0xe:
  case 0xf:
    return 1;
  }
}

void execute(void)
{
  already_npc_set = 0;

  v_src1 = get_value(rs1);
  v_src2 = get_value(rs2);
  v_src3 = get_value(rs3);

  switch(OP){
  case MOV:
    v_dst = v_src1;
    if(OP2==JPR)
      v_dst |= 1;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = C_flag;
    tmp_V_flag = V_flag;
    break;
  case NOT:
    v_dst = ~v_src1;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = 0;
    tmp_V_flag = V_flag;
    break;
  case REV:
    if(immd==0){
      v_dst = ((((v_src1)>>0)&0xff)<<24)
	     |((((v_src1)>>8)&0xff)<<16)
             |((((v_src1)>>16)&0xff)<<8)
             |((((v_src1)>>24)&0xff)<<0);
    }
    else if(immd==1){
      v_dst = ((((v_src1)>>16)&0xff)<<24)
             |((((v_src1)>>24)&0xff)<<16)
             |((((v_src1)>>0)&0xff)<<8)
             |((((v_src1)>>8)&0xff)<<0);
    }
    else{
      int resH, resL;
      resH = (v_src1&0x80)? 0xffff0000|((v_src1&0xff)<<8) : ((v_src1&0xff)<<8);
      resL = (v_src1>>8)&0xff;
      v_dst = resH | resL;
    }
    tmp_N_flag = N_flag;
    tmp_Z_flag = Z_flag;
    tmp_C_flag = C_flag;
    tmp_V_flag = V_flag;
    break;
  case SEX:
    if(msize==BYTE){
      v_dst = (v_src1&0x80)? 0xffffff00|v_src1 : v_src1&0xff;
    }
    else{
      v_dst = (v_src1&0x8000)? 0xffff0000|v_src1 : v_src1&0xffff;
    }
    tmp_N_flag = N_flag;
    tmp_Z_flag = Z_flag;
    tmp_C_flag = C_flag;
    tmp_V_flag = V_flag;
    break;
  case ZEX:
    if(msize==BYTE){
      v_dst = v_src1&0xff;
    }
    else{
      v_dst = v_src1&0xffff;
    }
    tmp_N_flag = N_flag;
    tmp_Z_flag = Z_flag;
    tmp_C_flag = C_flag;
    tmp_V_flag = V_flag;
    break;
  case ADC:
    v_dst = IADD32(v_src1, v_src2, C_flag, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case ADD:
  case NSUB:/* Not SUB */
    v_dst = IADD32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case SBC:
    if(C_flag)
      v_dst = ISUB32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    else
      v_dst = ISUB32(v_src1, v_src2, 1, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case SUB:
    v_dst = ISUB32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    break;
  case MUL:
    v_dst = IMUL32(v_src1, v_src2, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    tmp_C_flag = C_flag;
    tmp_V_flag = V_flag;
    break;
  case AND:
    v_dst = v_src1 & v_src2;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = 0;
    tmp_V_flag = V_flag;
    break;
  case NAND:/* Not AND */
    v_dst = v_src1 & ~v_src2;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = 0;
    tmp_V_flag = V_flag;
    break;
  case OR:
    v_dst = v_src1 | v_src2;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = 0;
    tmp_V_flag = V_flag;
    break;
  case XOR:
    v_dst = v_src1 ^ v_src2;
    tmp_N_flag = (v_dst&0x80000000)? 1: 0;
    tmp_Z_flag = (v_dst==0)? 1: 0;
    tmp_C_flag = 0;
    tmp_V_flag = V_flag;
    break;
  case LDM:
  case STM:
    do_ldstm();
    break;
  case ROR:
  case SLL:
  case SRA:
  case SRL:
    v_dst = ISFT32(v_src1, v_src2, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
    tmp_V_flag = V_flag;
    break;
  case POP:
  case PUSH:
    do_push_pop();
    break;
  case NOP:
  case BRK:
  case SVC:
  case UDF:
  case WFE:
  case SEV:
  case WFI:
  case DMB:
  case DSB:
  case ISB:
  case YIELD:
  case CPS:
  case MRS:
  case MSR:
    /* do noting */
    break;
  default:
    break;
  }
  if(rd != NONE){
    put_value(rd, v_dst);
    if(rd==15){
      already_npc_set = already_npc_set|1;
    }
  }
  switch(OP2){
  case FLAG:
    N_flag = tmp_N_flag;
    Z_flag = tmp_Z_flag;
    C_flag = tmp_C_flag;
    V_flag = tmp_V_flag;
    break;
  case JAL:
    put_reg(15,v_dst);
    put_reg(14, v_src3|1);
    already_npc_set = already_npc_set|1;
    break;
  case JCC:
    if(cond_check()){
      put_reg(15,v_dst);
      already_npc_set = already_npc_set|1;
    }
    break;
  case JPR:
    put_reg(15,v_src2);
    already_npc_set = already_npc_set|1;
    break;
  case LD:
    if(msize==WORD){
      put_value(rd,get_mem(v_dst,WORD));
    }
    else if(msize==HWORD){
      int d;
      d = get_mem(v_dst,HWORD);
      if(msex){
	d = (d&0x8000)? 0xffff0000|d : d &0xffff;
      }
      else{
	d = d &0xffff;
      }
      put_value(rd,d);
    }
    else{
      int d;
      d = get_mem(v_dst,BYTE);
      if(msex){
	d = (d&0x80)? 0xffffff00|d : d &0xff;
      }
      else{
	d = d &0xff;
      }
      put_value(rd,d);
    }
    break;
  case ST:
    if(msize==WORD){
      put_mem(v_dst,v_src3,WORD);
    }
    else if(msize==HWORD){
      put_mem(v_dst,v_src3,HWORD);
    }
    else{
      put_mem(v_dst,v_src3,BYTE);
    }
    break;
  case NOP:
    break;
  default:
    break;
  }
  if(already_npc_set==0){
    put_value(15,PC1);
  }
    
}
