#include "define.h"
int inst_reg;
int opcode;
int func;
int sa;
int rd;
int rs1;
int rs2;
int rs3;
int immd;
int OP;
int OP2;
int msize;
int msex;
int cond;
static int i_immd_zex;
static int i_immd_sex;
static int b_immd_zex;
static int b_immd_sex;
static int j_immd_zex;

void special_dec(void)
{
  int tmp;
  switch(func){
  case 000:
    rs1 = rs2;
    rs2 = rs2;
    rd  = rd;
    OP  = SLL;
    OP2 = NOP;
    break;
  case 002:
    rs1 = rs2;
    rs2 = rs2;
    rd  = rd;
    OP  = SRL;
    OP2 = NOP;
    break;
  case 003:
    rs1 = rs2;
    rs2 = rs2;
    rd  = rd;
    OP  = SRA;
    OP2 = NOP;
    break;
  case 004:
    tmp = rs1;
    rs1  = rs2;
    rs2 = tmp;
    rd  = rd;
    OP  = SLLV;
    OP2 = NOP;
    break;
  case 006:
    tmp = rs1;
    rs1  = rs2;
    rs2 = tmp;
    rd  = rd;
    OP  = SRLV;
    OP2 = NOP;
    break;
  case 007:
    tmp = rs1;
    rs1  = rs2;
    rs2 = tmp;
    rd  = rd;
    OP  = SRAV;
    OP2 = NOP;
    break;
  case 010:
    rs1 = rs1;
    OP  = NOP;
    OP2 = JPR;
    break;
  case 011:
    rs1 = rs1;
    rs2 = 33; /* PC+8 */
    rd  = rd;
    OP  = MOV;
    OP2 = JPR;
    break;
  case 020:
    rs2 = 35; /* HI reg */
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 021:
    rs2 = rs1;
    rd  = 35; /* HI reg */
    OP  = MOV;
    OP2 = NOP;
    break;
  case 022:
    rs2 = 36; /* LO reg */
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 023:
    rs2 = rs1;
    rd  = 36; /* LO reg */
    OP  = MOV;
    OP2 = NOP;
    break;
  case 030:
    rs1 = rs1;
    rs2 = rs2;
    rd  = 0;
    OP  = MUL;
    OP2 = NOP;
    break;
  case 031:
    rs1 = rs1;
    rs2 = rs2;
    rd  = 0;
    OP  = MULU;
    OP2 = NOP;
    break;
  case 032:
    rs1 = rs1;
    rs2 = rs2;
    rd  = 0;
    OP  = DIV;
    OP2 = NOP;
    break;
  case 033:
    rs1 = rs1;
    rs2 = rs2;
    rd  = 0;
    OP  = DIVU;
    OP2 = NOP;
    break;
  case 040:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = ADD;
    OP2 = NOP;
    break;
  case 041:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = ADDU;
    OP2 = NOP;
    break;
  case 042:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = SUB;
    OP2 = NOP;
    break;
  case 043:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = SUBU;
    OP2 = NOP;
    break;
  case 044:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = AND;
    OP2 = NOP;
    break;
  case 045:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = OR;
    OP2 = NOP;
    break;
  case 046:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = XOR;
    OP2 = NOP;
    break;
  case 047:
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = NOR;
    OP2 = NOP;
    break;
  case 052:
    cond = LT;
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 053:
    cond = LTU;
    rs1 = rs1;
    rs2 = rs2;
    rd  = rd;
    OP  = CMP;
    OP2 = NOP;
    break;
  default:
    rs1	= 0;
    rs2	= 0;
    rd	= 0;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}


void regimm_dec(void)
{
  switch(rs2){
  case 000:
    immd = b_immd_sex;
    cond = LT;
    rs1 = rs1;
    rs2 = 0;
    rd  = 0;
    OP  = CMP;
    OP2 = JCC;
    break;
  case 001:
    immd = b_immd_sex;
    cond = GE;
    rs1 = rs1;
    rs2 = 0;
    rd  = 0;
    OP  = CMP;
    OP2 = JCC;
    break;
  case 020:
    immd = b_immd_sex;
    cond = LT;
    rs1 = rs1;
    rs2 = 0;
    rd  = 31;
    OP  = CMP;
    OP2 = JCC;
    break;
  case 021:
    immd = b_immd_sex;
    cond = GE;
    rs1 = rs1;
    rs2 = 0;
    rd  = 31;
    OP  = CMP;
    OP2 = JCC;
    break;
  default:
    rs1	= 0;
    rs2	= 0;
    rd	= 0;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void decode(void)
{
  opcode	= (inst_reg>>26)&0x3f;
  func          = (inst_reg)&0x3f;
  sa            = (inst_reg>> 6)&0x1f;
  rd		= (inst_reg>>11)&0x1f;
  rs1		= (inst_reg>>21)&0x1f;
  rs2		= (inst_reg>>16)&0x1f;
  i_immd_zex	= (inst_reg)&0xffff;
  i_immd_sex	= (i_immd_zex&0x8000) ? 0xffff0000|i_immd_zex 
                : i_immd_zex;
  b_immd_zex	= (inst_reg)&0xffff;
  b_immd_sex	= (b_immd_zex&0x8000) ? 0xffff0000|b_immd_zex 
                : b_immd_zex;
  b_immd_sex    = b_immd_sex<<2;
  j_immd_zex	=  (inst_reg)&0x03ffffff;

  switch(opcode){
  case 000:
    special_dec();
    break;
  case 001:
    regimm_dec();
    break;
  case 002:
    immd = j_immd_zex;
    rs1	= 0;
    rs2	= 0;
    rd	= 0;
    OP	= NOP;
    OP2	= JMP;
    break;
  case 003:
    immd = j_immd_zex;
    rs1	= 0;
    rs2	= 33; /* PC+8 */
    rd	= 31;
    OP 	= MOV;
    OP2	= JMP;
    break;
  case 004:
    immd = b_immd_sex;
    cond = EQ;
    rs1	= rs1;
    rs2	= rs2;
    rd	= 0;
    OP	= CMP; /* see also cond */
    OP2 = JCC;
    break;
  case 005:
    immd = b_immd_sex;
    cond = NE;
    rs1	= rs1;
    rs2	= rs2;
    rd	= 0;
    OP	= CMP; /* see also cond */
    OP2 = JCC;
    break;
  case 006:
    immd = b_immd_sex;
    cond = LE;
    rs1	= rs1;
    rs2	= 0;
    rd	= 0;
    OP	= CMP; /* see also cond */
    OP2 = JCC;
    break;
  case 007:
    immd = b_immd_sex;
    cond = GT;
    rs1	= rs1;
    rs2	= 0;
    rd	= 0;
    OP	= CMP; /* see also cond */
    OP2 = JCC;
    break;
  case 010:
    immd = i_immd_sex;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= ADD;
    OP2	= NOP;
    break;
  case 011:
    immd = i_immd_sex;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= ADDU;
    OP2	= NOP;
    break;
  case 012:
    immd = i_immd_sex;
    cond = LT;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= CMP;
    OP2	= NOP;
    break;
  case 013:
    immd = i_immd_sex;
    cond = LTU;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= CMP;
    OP2	= NOP;
    break;
  case 014:
    immd = i_immd_zex;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= AND;
    OP2	= NOP;
    break;
  case 015:
    immd = i_immd_zex;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= OR;
    OP2	= NOP;
    break;
  case 016:
    immd = i_immd_zex;
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= XOR;
    OP2	= NOP;
    break;
  case 017:
    immd = (i_immd_zex<<16);
    rs1	= rs1;
    rd	= rs2;
    rs2	= 32; /* immd */
    OP	= MOV;
    OP2	= NOP;
    break;
  case 040:
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LD;
    msex = 1;
    msize = BYTE;
    break;
  case 041:
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LD;
    msex = 1;
    msize = HWORD;
  case 042:
    break;
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LWL;
    msex = 1;
    msize = WORD;
    break;
  case 043:
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LD;
    msex = 1;
    msize = WORD;
    break;
  case 044:
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LD;
    msex = 0;
    msize = BYTE;
    break;
  case 045:
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LD;
    msex = 0;
    msize = HWORD;
  case 046:
    break;
    immd = i_immd_sex;
    rs1 = rs1;
    rd  = rs2;
    rs2 = 32; /* immd */
    OP  = ADDU;
    OP2 = LWR;
    msex = 1;
    msize = WORD;
    break;
  case 050:
    immd = i_immd_sex;
    rs1 = rs1;
    rs3  = rs2;
    rs2 = 32; /* immd */
    rd  = 0;
    OP  = ADDU;
    OP2 = ST;
    msex = 0;
    msize = BYTE;
    break;
  case 051:
    immd = i_immd_sex;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = 32; /* immd */
    rd  = 0;
    OP  = ADDU;
    OP2 = ST;
    msex = 1;
    msize = HWORD;
  case 052:
    break;
    immd = i_immd_sex;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = 32; /* immd */
    rd  = 0;
    OP  = ADDU;
    OP2 = SWL;
    msex = 0;
    msize = WORD;
    break;
  case 053:
    immd = i_immd_sex;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = 32; /* immd */
    rd  = 0;
    OP  = ADDU;
    OP2 = ST;
    msex = 1;
    msize = WORD;
    break;
  case 056:
    break;
    immd = i_immd_sex;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = 32; /* immd */
    rd  = 0;
    OP  = ADDU;
    OP2 = SWR;
    msex = 1;
    msize = WORD;
    break;
  default:
    rs1	= 0;
    rs2	= 0;
    rd	= 0;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}
