#define ADD   0
#define ADDU  1
#define AND   2
#define CMP   3
#define DIV   4
#define DIVU  5
#define MOV   6
#define MUL   7
#define MULU  8
#define NOP   9
#define NOR  10
#define OR   11
#define SLL  12
#define SLLV 13
#define SRA  14
#define SRAV 15
#define SRL  16
#define SRLV 17
#define SUB  18
#define SUBU 19
#define XOR  20

#define EXP  21
#define JCC  22
#define JMP  23
#define JPR  24
#define LD   25
#define LWL  26
#define LWR  27
#define ST   28
#define SWL  29
#define SWR  30


#define WORD  0
#define HWORD 1
#define BYTE  2

#define EQ 0
#define NE 1
#define LT 2
#define GE 3
#define LTU 4
#define GEU 5
#define LE  6
#define GT  7

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

