#include <stdio.h>
#include "define.h"

int PC;
int RF[32];
int HI_REG, LO_REG;

int get_reg(int reg)
{
  if(reg==35)
    return HI_REG;
  if(reg==36)
    return LO_REG;
  if((reg>=1)&&(reg<=31))
	  return RF[reg];
  return 0;
}

void put_reg(int reg, int value)
{
  if(reg==35)
    HI_REG = value;
  if(reg==36)
    LO_REG = value;
  if((reg>=1)&&(reg<=31))
    RF[reg] = value;
}
#if 1
void reg_dump(void)
{
    printf("pc:%08x 01:%08x 02:%08x 03:%08x 04:%08x 05:%08x 06:%08x 07:%08x\n",
	   PC, RF[1], RF[2], RF[3], RF[4], RF[5], RF[6], RF[7]);
    printf("08:%08x 09:%08x 10:%08x 11:%08x 12:%08x 13:%08x 14:%08x 15:%08x\n",
	   RF[8], RF[9], RF[10], RF[11], RF[12], RF[13], RF[14], RF[15]);
    printf("16:%08x 17:%08x 18:%08x 19:%08x 20:%08x 21:%08x 22:%08x 23:%08x\n",
	   RF[16], RF[17], RF[18], RF[19], RF[20], RF[21], RF[22], RF[23]);
    printf("24:%08x 25:%08x 26:%08x 27:%08x 28:%08x 29:%08x 30:%08x 31:%08x\n",
	   RF[24], RF[25], RF[26], RF[27], RF[28], RF[29], RF[30], RF[31]);
    printf("HI:%08x LO:%08x\n",
	   HI_REG, LO_REG);
}
#else
void reg_dump(void)
{
  printf("[cpu]\n");
  printf("pc:%016x 01:%016x 02:%016x 03:%016x\n",PC-4, RF[1], RF[2], RF[3]) ;
  printf("04:%016x 05:%016x 06:%016x 07:%016x\n", RF[4], RF[5], RF[6], RF[7]);
  printf("08:%016x 09:%016x 10:%016x 11:%016x\n", RF[8], RF[9], RF[10], RF[11]);
  printf("12:%016x 13:%016x 14:%016x 15:%016x\n", RF[12], RF[13], RF[14], RF[15]);
  printf("16:%016x 17:%016x 18:%016x 19:%016x\n", RF[16], RF[17], RF[18], RF[19]);
  printf("20:%016x 21:%016x 22:%016x 23:%016x\n", RF[20], RF[21], RF[22], RF[23]);
  printf("24:%016x 25:%016x 26:%016x 27:%016x\n", RF[24], RF[25], RF[26], RF[27]);
  printf("28:%016x 29:%016x 30:%016x 31:%016x\n", RF[28], RF[29], RF[30], RF[31]);
  printf("hi:%016x lo:%016x\n",   HI_REG, LO_REG);
}
#endif
