#include "define.h"
int inst_reg;
int opcode;
int rd;
int funct3;
int rs1;
int rs2;
int rs3;
int funct7;
int immd;
int OP;
int OP2;
static int i_immd_zex;
static int i_immd_sex;
static int s_immd_zex;
static int s_immd_sex;
static int u_immd_zex;
static int u_immd_sex;
static int b_immd_zex;
static int b_immd_sex;
static int j_immd_zex;
static int j_immd_sex;

void decode(void)
{
  opcode	= inst_reg & 0x7f;
  rd		= (inst_reg>>7) &0x1f;
  funct3	= (inst_reg>>12)&0x7;
  rs1		= (inst_reg>>15)&0x1f;
  rs2		= (inst_reg>>20)&0x1f;
  funct7	= (inst_reg>>25)&0x3f;
  i_immd_zex	= (inst_reg>>20)&0xfff;
  i_immd_sex	= (i_immd_zex&0x800) ? 0xfffff000|i_immd_zex 
                                     : i_immd_zex;
  s_immd_zex	= (((inst_reg>>25)&0x7f)<<5)|((inst_reg>>7)&0x1f);
  s_immd_sex	= (s_immd_zex&0x800) ? 0xfffff000|s_immd_zex 
                                     : s_immd_zex;
  u_immd_zex	= ((inst_reg>>12)&0xfffff)<<12;
  u_immd_sex	= u_immd_zex;
  b_immd_zex	= (((inst_reg>>31)&1)<<12)
                | (((inst_reg>>7 )&1)<<11)
                | (((inst_reg>>25)&0x3f)<<5)
                | ((inst_reg>>8 )&0xf)<<1;
  b_immd_sex	= (b_immd_zex&0x1000) ? 0xffffe000|b_immd_zex 
                                      : b_immd_zex;
  j_immd_zex	= (((inst_reg>>31)&0x01)<<20)
                | (((inst_reg>>12)&0xff)<<12)
                | (((inst_reg>>20)&0x01)<<11)
                | (((inst_reg>>21)&0x3ff)<<1);
  j_immd_sex	= (j_immd_zex&(1<<20))? 0xffe00000|j_immd_zex 
                                      : j_immd_zex;

  switch(opcode){
  case 0x37:
    immd = u_immd_sex;
    rs1 = rs1;
    rs2	= 32;/* immd */
    rd	= rd;
    OP	= MOV;
    OP2	= NOP;
    break;
  case 0x17:
    immd = u_immd_sex;
    rs1 = 33; /* PC */
    rs2 = 32; /* immd */
    rd	= rd;
    OP	= ADDI;
    OP2	= NOP;
    break;
  case 0x6f:
    immd = j_immd_sex;
    rs1	= rs1;
    rs2	= 34; /* PC+4 */
    rd	= rd;
    OP	= MOV;
    OP2	= JMP;
    break;
  case 0x67:
    rs1	= rs1;
    rs2	= 34; /* PC+4 */
    rd	= rd;
    OP 	= MOV;
    OP2	= JPR;
    break;
  case 0x63:
    immd = b_immd_sex;
    rs1	= rs1;
    rs2	= rs2;
    rd	= 0;
    OP	= CMP; /* see also funct3 */
    OP2 = JCC;
    break;
  case 0x03:
    immd = i_immd_sex;
    rs1	= rs1;
    rs2	= 32; /* immd */
    rd	= rd;
    OP	= ADDI;
    OP2	= LD; /* see also funct3 */
    break;
  case 0x23:
    immd = s_immd_sex;
    rs1	= rs1;
    rs3	= rs2;
    rs2	= 32; /* immd */
    rd	= 0;
    OP	= ADDI;
    OP2	= ST; /* see also funct3 */
    break;
  case 0x13:
    immd = ((funct3==1)||(funct3==5))? i_immd_sex & 0x1f
                                     : i_immd_sex;
    rs1	= rs1;
    rs2	= 32; /* immd */
    rd	= rd;
    OP	= (funct3==0)? ADDI : ALU; /* see also funct3 */
    OP2	= NOP;
    break;
  case 0x33:
    immd = b_immd_sex;
    rs1	= rs1;
    rs2	= rs2;
    rd	= rd;
    OP	= ALU; /* see also funct3 */
    OP2	= NOP;
    break;
  case 0x0f:/* FENCE */
    immd = i_immd_sex;
    rs1	= rs1;
    rs2	= rs2;
    rd	= 0;
    OP	= NOP;
    OP2	= NOP;
    break;
  case 0x73:
    immd = i_immd_sex;
    rs1	= rs1;
    rs2	= rs2;
    rd	= 0;
    OP	= NOP;
    OP2	= SPC;
    break;
  defaut:
    rs1	= 0;
    rs2	= 0;
    rd	= 0;
    OP	= NOP;
    OP2	= EXP;
  }
}
