#include <stdio.h>
#include "define.h"

static int opcode;
static int rd;
static int funct3;
static int rs1;
static int rs2;
static int rs3;
static int funct7;
static int immd;
static int i_immd_zex;
static int i_immd_sex;
static int s_immd_zex;
static int s_immd_sex;
static int u_immd_zex;
static int u_immd_sex;
static int b_immd_zex;
static int b_immd_sex;
static int j_immd_zex;
static int j_immd_sex;
static int inst_reg;
static int PC;

static void print_mem(int immd)
{
  if(immd<0)
    printf("-0x%x(x%d)",-immd,rs1);
    else
      printf("0x%x(x%d)",immd,rs1);
}

static void print_immd(void)
{
  if(i_immd_sex<0)
    printf("-0x%x",-i_immd_sex);
  else
    printf("0x%x",i_immd_sex);
}

static char fence_para_data[5];

static char* fence_para(int i)
{
  char *p=fence_para_data;
  *p = 0;

  if(i&8)
    *p++ = 'i';
  if(i&4)
    *p++ = 'o';
  if(i&2)
    *p++ = 'r';
  if(i&1)
    *p++ = 'w';
  *p = 0;
	
  return fence_para_data;
}

void dis()
{

  inst_reg = get_mem(PC, WORD);

  opcode	= inst_reg & 0x7f;
  rd		= (inst_reg>>7) &0x1f;
  funct3	= (inst_reg>>12)&0x7;
  rs1		= (inst_reg>>15)&0x1f;
  rs2		= (inst_reg>>20)&0x1f;
  funct7	= (inst_reg>>25)&0x3f;
  i_immd_zex	= (inst_reg>>20)&0xfff;
  i_immd_sex	= (i_immd_zex&0x800) ? 0xfffff000|i_immd_zex 
                                     : i_immd_zex;
  s_immd_zex	= (((inst_reg>>25)&0x7f)<<5)|((inst_reg>>7)&0x1f);
  s_immd_sex	= (s_immd_zex&0x800) ? 0xfffff000|s_immd_zex 
                                     : s_immd_zex;
  u_immd_zex	= (((inst_reg>>12)&0xfffff)<<12);
  u_immd_sex	= u_immd_zex;
  b_immd_zex	= (((inst_reg>>31)&1)<<12)
                | (((inst_reg>>7 )&1)<<11)
                | (((inst_reg>>25)&0x3f)<<5)
                | (((inst_reg>>8 )&0xf)<<1);
  b_immd_sex	= (b_immd_zex&0x1000) ? 0xffffe000|b_immd_zex 
                                      : b_immd_zex;
  j_immd_zex	= (((inst_reg>>31)&0x01)<<20)
                | (((inst_reg>>12)&0xff)<<12)
                | (((inst_reg>>20)&0x01)<<11)
                | (((inst_reg>>21)&0x3ff)<<1);
  j_immd_sex	= (j_immd_zex&(1<<20))? 0xffe00000|j_immd_zex 
                                      : j_immd_zex;

  switch(opcode){
  case 0x37:
    printf("lui\tx%d,0x%08x\n",rd,u_immd_sex);
    break;
  case 0x17:
    printf("auipc\tx%d,0x%08x\n",rd,u_immd_sex);
    break;
  case 0x6f:
    printf("jal\tx%d,%08x\n",rd,PC+j_immd_sex);
    break;
  case 0x67:
    printf("jalr\tx%d,x%d\n",rd,rs1);
    break;
  case 0x63:
    switch(funct3){
    case 0:
      printf("beq\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    case 1:
      printf("bne\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    case 4:
      printf("blt\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    case 5:
      printf("bge\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    case 6:
      printf("bltu\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    case 7:
      printf("bgeu\tx%d,x%d,0x%08x\n",rs1,rs2,PC+b_immd_sex);
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  case 0x03:
    switch(funct3){
    case 0:
      printf("lb\tx%d,",rd);
      print_mem(i_immd_sex);
      printf("\n");
      break;
    case 1:
      printf("lh\tx%d,",rd);
      print_mem(i_immd_sex);
      printf("\n");
      break;
    case 2:
      printf("lw\tx%d,",rd);
      print_mem(i_immd_sex);
      printf("\n");
      break;
    case 4:
      printf("lbu\tx%d,",rd);
      print_mem(i_immd_sex);
      printf("\n");
      break;
    case 5:
      printf("lhu\tx%d,",rd);
      print_mem(i_immd_sex);
      printf("\n");
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  case 0x23:
    switch(funct3){
    case 0:
      printf("sb\tx%d,",rs2);
      print_mem(s_immd_sex);
      printf("\n");
      break;
    case 1:
      printf("sh\tx%d,",rs2);
      print_mem(s_immd_sex);
      printf("\n");
      break;
    case 2:
      printf("sw\tx%d,",rs2);
      print_mem(s_immd_sex);
      printf("\n");
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  case 0x13:
    switch(funct3){
    case 0:
      printf("addi\tx%d,x%d,",rd,rs1);
      print_immd();
      printf("\n");
      break;
    case 1:
      printf("slli\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex&0x1f);
      break;
    case 2:
      printf("slti\tx%d,x%d,",rd,rs1);
      print_immd();
      printf("\n");
      break;
    case 3:
      printf("sltiu\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex);
      break;
    case 4:
      printf("xori\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex);
      break;
    case 5:
      if(funct7)
	printf("srai\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex&0x1f);
      else
	printf("srli\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex&0x1f);
      break;
    case 6:
      printf("ori\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex);
      break;
    case 7:
      printf("andi\tx%d,x%d,0x%x\n",rd,rs1,i_immd_sex);
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  case 0x33:
    switch(funct3){
    case 0:
      if(funct7==0)
	printf("add\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==0x20)
	printf("sub\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("mul\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 1:
      if(funct7==0)
	printf("sll\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("mulh\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 2:
      if(funct7==0)
	printf("slt\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("mulhsu\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 3:
      if(funct7==0)
	printf("sltu\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("mulhu\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 4:
      if(funct7==0)
	printf("xor\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("div\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 5:
      if(funct7==0)
	printf("srl\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==0x20)
	printf("sra\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("divu\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 6:
      if(funct7==0)
	printf("or\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("rem\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    case 7:
      if(funct7==0)
	printf("and\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else if(funct7==1)
	printf("remu\tx%d,x%d,x%d\n",rd,rs1,rs2);
      else
	printf(".word\t0x%08x\n",inst_reg);
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  case 0x0f:/* FENCE */
    if(funct3)
      printf("fence.i\n");
    else{
      if(i_immd_zex==0)
	printf("fence\n");
      else
	printf("fence\t%s,%s\n",fence_para((i_immd_zex>>4)&0xf),fence_para((i_immd_zex>>0)&0xf));
    }
    break;
  case 0x73:
    switch(funct3){
    case 0x0:
      if(funct7)
	printf("ebreak\n");
      else
	printf("ecall\n");
      break;
    case 0x1:/* csrrw */
      printf("csrrw\tx%d,csr%d,x%d\n",rd,i_immd_zex,rs1);
      break;
    case 0x2:/* csrrs */
      printf("csrrs\tx%d,csr%d,x%d\n",rd,i_immd_zex,rs1);
      break;
    case 0x3:/* csrrc */
      printf("csrrc\tx%d,csr%d,x%d\n",rd,i_immd_zex,rs1);
      break;
    case 0x5:/* csrrwi */
      printf("csrrwi\tx%d,csr%d,0x%x\n",rd,i_immd_zex,rs1);
      break;
    case 0x6:/* carrsi */
      printf("csrrsi\tx%d,csr%d,0x%x\n",rd,i_immd_zex,rs1);
      break;
    case 0x7:/* csrrci */
      printf("csrrci\tx%d,csr%d,0x%x\n",rd,i_immd_zex,rs1);
      break;
    default:
      printf(".word\t0x%08x\n",inst_reg);
      break;
    }
    break;
  default:
    printf(".word\t0x%08x\n",inst_reg);
    break;
  }
}

void disasm(unsigned int addr1, unsigned int addr2)
{
  unsigned int i;
  for(i=addr1;i<=addr2;i+=4){
    PC = i;
    printf("%08x ",i);
    dis();
  }
}

