#include "define.h"
int inst_reg;
int opcode;
int func;
int rd;
int rs1;
int rs2;
int rs3;
int immd;
int OP;
int OP2;
int mtype;
int msize;
int msex;
int cond;
int delay_slot;
static int i_immd_zex;
static int i_immd_sex;
static int b_immd_zex;
static int b_immd_sex;

void dec_0(void)
{
  switch(inst_reg){
  case 0x08:/*CLRT */
    cond = NE;
    rs1 = 0;
    rs2 = 0;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    return;
  case 0x09:/* NOP */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = NOP;
    return;
  case 0x0b:/* RTS */
    rs1 = PR_REG;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = JPR;
    delay_slot = 1;
    return;
  case 0x18:/* SETT */
    cond = EQ;
    rs1 = 0;
    rs2 = 0;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    return;
  case 0x19:/* DIV0U */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = DIV0U;
    OP2 = NOP;
    return;
  case 0x1b:/* SLEEP */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = SLEEP;
    return;
  case 0x28:/* CLRMAC */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = CLRMAC;
    OP2 = NOP;
    return;
  case 0x2b:/* RTE */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = RTE;
    delay_slot = 1;
    return;
  default:
    break;
  }
  switch(func){
  case 0x03:/* BSRF */
    rs1 = rs1;
    rs2 = PC_REG;
    rd  = PR_REG;
    OP  = MOV;
    OP2 = BRR;
    delay_slot = 1;
    return;
  case 0x23:/* BRAF */
    rs1 = rs1;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = BRR;
    delay_slot = 1;
    return;
  case 0x02:/* STC SR */
    rs2 = SR_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x0a:/* STS MACH */
    rs2 = MACH_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x12:/* STC GBR */
    rs2 = GBR_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x1a:/* STS MACL */
    rs2 = MACL_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x22:/* STC VBR */
    rs2 = VBR_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x29:/* MOVT */
    rs2 = T_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  case 0x2a:/* STS PR */
    rs2 = PR_REG;
    rd  = rd;
    OP  = MOV;
    OP2 = NOP;
    return;
  default:
    break;
  }
  switch(func&0xf){
  case 0x4:
    rs3 = rs2;
    rs1 = rs1;
    rs2 = 0;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = BYTE;
    msex  = 0;
    mtype = NORMAL;
    return;
  case 0x5:
    rs3 = rs2;
    rs1 = rs1;
    rs2 = 0;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 0;
    mtype = NORMAL;
    return;
  case 0x6:
    rs3 = rs2;
    rs1 = rs1;
    rs2 = 0;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex  = 0;
    mtype = NORMAL;
    return;
  case 0x7:
    rs1 = rs1;
    rs2 = rs2;
    rd  = MACL_REG;
    OP  = MULL;
    OP2 = NOP;
    return;
  case 0xc:
    rs1 = 0;
    rs2 = rs2;
    rd  = rd;
    OP  = ADD;
    OP2 = LD;
    msize = BYTE;
    msex = 1;
    mtype = NORMAL;
    return;
  case 0xd:
    rs1 = 0;
    rs2 = rs2;
    rd  = rd;
    OP  = ADD;
    OP2 = LD;
    msize = HWORD;
    msex = 1;
    mtype = NORMAL;
    return;
  case 0xe:
    rs1 = 0;
    rs2 = rs2;
    rd  = rd;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex = 1;
    mtype = NORMAL;
    return;
  case 0xf:
    rs1 = rs1;
    rs2 = rs2;
    rd  = NONE;
    OP  = MAC;
    OP2 = NOP;
    msize = WORD;
    msex = 0;
    mtype = NORMAL;
    return;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void dec_1(void)
{
  immd = (func & 0xf)<<2;
  rs1 = rs1;
  rs3 = rs2;
  rs2 = IMMD;
  rd  = NONE;
  OP  = ADD;
  OP2 = ST;
  msize = WORD;
  msex  = 0;
  mtype = NORMAL;
}

void dec_2(void)
{
  switch(func&0xf){
  case 0:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = BYTE;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 1:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 2:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 4:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = BYTE;
    msex  = 0;
    mtype = PREDEC;
    break;
  case 5:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 0;
    mtype = PREDEC;
    break;
  case 6:
    immd = 0;
    rs1 = rs1;
    rs3 = rs2;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex  = 0;
    mtype = PREDEC;
    break;
  case 7:
    rd  = NONE;
    OP  = DIV0S;
    OP2 = NOP;
    break;
  case 8:
    cond = TST;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 9:
    OP  = AND;
    OP2 = NOP;
    break;
  case 10:
    OP  = XOR;
    OP2 = NOP;
    break;
  case 11:
    OP  = OR;
    OP2 = NOP;
    break;
  case 12:
    cond = STR;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 13:
    OP  = XTRCT;
    OP2 = NOP;
    break;
  case 14:
    rd  = NONE;
    OP  = MULUW;
    OP2 = NOP;
    break;
  case 15:
    rd  = NONE;
    OP  = MULW;
    OP2 = NOP;
    break;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void dec_3(void)
{
  switch(func&0xf){
  case 0:
    cond = EQ;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 2:
    cond = GEU;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 3:
    cond = GE;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 4:
    rd  = NONE;
    OP  = DIV1;
    OP2 = NOP;
    break;
  case 5:
    rd  = NONE;
    OP  = MULU;
    OP2 = NOP;
    break;
  case 6:
    cond = GTU;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 7:
    cond = GT;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 8:
    OP  = SUB;
    OP2 = NOP;
    break;
  case 10:
    OP  = SUBC;
    OP2 = NOP;
    break;
  case 11:
    OP  = SUBV;
    OP2 = NOP;
    break;
  case 12:
    OP  = ADD;
    OP2 = NOP;
    break;
  case 13:
    rd  = NONE;
    OP  = MUL;
    OP2 = NOP;
    break;
  case 14:
    OP  = ADDC;
    OP2 = NOP;
    break;
  case 15:
    OP  = ADDV;
    OP2 = NOP;
    break;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void dec_4(void)
{
  switch(func){
  case 0x06:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = MACH_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x07:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = SR_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x0a:
    rs2 = rs1;
    rd  = MACH_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x0b:
    rs2 = PC_REG;
    rd  = PR_REG;
    OP  = MOV;
    OP2 = JPR;
    delay_slot = 1;
    break;
  case 0x0e:
    rs2 = rs1;
    rd  = SR_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x16:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = MACL_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x17:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = GBR_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x1a:
    rs2 = rs1;
    rd  = MACL_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x1e:
    rs2 = rs1;
    rd  = GBR_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x26:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = PR_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x27:
    immd = 0;
    rs1 = rs1;
    rs2 = IMMD;
    rd  = VBR_REG;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x2a:
    rs2 = rs1;
    rd  = PR_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x2b:
    rd  = NONE;
    OP  = NOP;
    OP2 = JPR;
    delay_slot = 1;
    break;
  case 0x2c:
    rs2 = rs1;
    rd  = VBR_REG;
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x00:
    immd = 1;
    rs2 = IMMD;
    OP  = SLL;
    OP2 = NOP;
    break;
  case 0x01:
    immd = 1;
    rs2 = IMMD;
    OP  = SRL;
    OP2 = NOP;
    break;
  case 0x02:
    immd = 0;
    rs3 = MACH_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x03:
    immd = 0;
    rs3 = SR_REG;
    rs2 = IMMD;
    OP  = ADD;
    rd  = NONE;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x04:
    immd = 1;
    rs2 = IMMD;
    OP  = ROL;
    OP2 = NOP;
    break;
  case 0x05:
    immd = 1;
    rs2 = IMMD;
    OP  = ROR;
    OP2 = NOP;
    break;
  case 0x08:
    immd = 2;
    rs2 = IMMD;
    OP  = SLL;
    OP2 = NOP;
    break;
  case 0x09:
    immd = 2;
    rs2 = IMMD;
    OP  = SRL;
    OP2 = NOP;
    break;
  case 0x10:
    cond = DT;
    rd   = T_REG;
    OP   = CMP;
    OP2  = NOP;
    break;
  case 0x11:
    immd = 0;
    cond = GE;
    rs2 = IMMD;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 0x12:
    immd = 0;
    rs3 = MACL_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x13:
    immd = 0;
    rs3 = GBR_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x15:
    immd = 0;
    cond = GT;
    rs2 = IMMD;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 0x18:
    immd = 8;
    rs2 = IMMD;
    OP  = SLL;
    OP2 = NOP;
    break;
  case 0x19:
    immd = 8;
    rs2 = IMMD;
    OP  = SRL;
    OP2 = NOP;
    break;
  case 0x1b:
    rd  = NONE;
    OP  = TAS;
    OP2 = NOP;
    break;
  case 0x20:
    immd = 1;
    rs2 = IMMD;
    OP  = SLA;
    OP2 = NOP;
    break;
  case 0x21:
    immd = 1;
    rs2 = IMMD;
    OP  = SRA;
    OP2 = NOP;
    break;
  case 0x22:
    immd = 0;
    rs3 = PR_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x23:
    immd = 0;
    rs3 = VBR_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex = 0;
    mtype = PREDEC;
    break;
  case 0x24:
    immd = 1;
    rs2 = IMMD;
    OP  = ROLC;
    OP2 = NOP;
    break;
  case 0x25:
    immd = 1;
    rs2 = IMMD;
    OP  = RORC;
    OP2 = NOP;
    break;
  case 0x28:
    immd = 16;
    rs2 = IMMD;
    OP  = SLL;
    OP2 = NOP;
    break;
  case 0x29:
    immd = 16;
    rs2 = IMMD;
    OP  = SRL;
    OP2 = NOP;
    break;
  case 0x0f:
  case 0x1f:
  case 0x2f:
  case 0x3f:
  case 0x4f:
  case 0x5f:
  case 0x6f:
  case 0x7f:
  case 0x8f:
  case 0x9f:
  case 0xaf:
  case 0xbf:
  case 0xcf:
  case 0xdf:
  case 0xef:
  case 0xff:
    rs1 = rs1;
    rs2 = rs2;
    rd  = NONE;
    OP  = MAC;
    OP2 = NOP;
    msize = HWORD;
    msex = 0;
    mtype = NORMAL;
    break;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void dec_5(void)
{
  immd = (func & 0xf)<<2;
  rs1 = rs2;
  rs2 = IMMD;
  OP  = ADD;
  OP2 = LD;
  msize = WORD;
  msex  = 0;
  mtype = NORMAL;
}

void dec_6(void)
{
  switch(func&0xf){
  case 0x0:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = BYTE;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x1:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = HWORD;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x2:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x3:
    OP  = MOV;
    OP2 = NOP;
    break;
  case 0x4:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = BYTE;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x5:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = HWORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x6:
    immd = 0;
    rs1 = rs2;
    rs2 = IMMD;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = POSTINC;
    break;
  case 0x7:
    OP  = NOT;
    OP2 = NOP;
    break;
  case 0x8:
    OP  = SWAPB;
    OP2 = NOP;
    break;
  case 0x9:
    OP  = SWAPW;
    OP2 = NOP;
    break;
  case 0xa:
    OP  = NEGC;
    OP2 = NOP;
    break;
  case 0xb:
    OP  = NEG;
    OP2 = NOP;
    break;
  case 0xc:
    OP  = ZEX;
    OP2 = NOP;
    msize = BYTE;
    break;
  case 0xd:
    OP  = ZEX;
    OP2 = NOP;
    msize = HWORD;
    break;
  case 0xe:
    OP  = SEX;
    OP2 = NOP;
    msize = BYTE;
    break;
  case 0xf:
    OP  = SEX;
    OP2 = NOP;
    msize = HWORD;
    break;
  }
}

void dec_7(void)
{
  immd = i_immd_sex;
  rs2 = IMMD;
  OP  = ADD;
  OP2 = NOP;
}

void dec_8(void)
{
  switch(rs1){
  case 0x0:
    rs3 = 0;
    rs1 = rs2;
    rs2 = IMMD;
    immd = (func&0xf);
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = BYTE;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 0x1:
    rs3 = 0;
    rs1 = rs2;
    rs2 = IMMD;
    immd = (func&0xf)<<1;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 0x4:
    rs1 = rs2;
    rs2 = IMMD;
    immd = (func&0xf);
    rd  = 0;
    OP  = ADD;
    OP2 = LD;
    msize = BYTE;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x5:
    rs1 = rs2;
    rs2 = IMMD;
    immd = (func&0xf)<<1;
    rd  = 0;
    OP  = ADD;
    OP2 = LD;
    msize = HWORD;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x8:
    cond = EQ;
    rs1 = 0;
    rs2 = IMMD;
    immd = i_immd_sex;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 0x9:
    cond = TRUE;
    immd = b_immd_sex<<1;
    rs1 = PC_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = CMP;
    OP2 = JCC;
    break;
  case 0xb:
    cond = FALSE;
    immd = b_immd_sex<<1;
    rs1 = PC_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = CMP;
    OP2 = JCC;
    break;
  case 0xd:
    cond = TRUE;
    immd = b_immd_sex<<1;
    rs1 = PC_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = CMP;
    OP2 = JCC;
    delay_slot = 1;
    break;
  case 0xf:
    cond = FALSE;
    immd = b_immd_sex<<1;
    rs1 = PC_REG;
    rs2 = IMMD;
    rd  = NONE;
    OP  = CMP;
    OP2 = JCC;
    delay_slot = 1;
    break;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}

void dec_9(void)
{
  immd = i_immd_zex<<1;
  rs1 = PC_REG;
  rs2 = IMMD;
  rd  = rd;
  OP  = ADD;
  OP2 = LD;
  msize = HWORD;
  msex  = 1;
  mtype = NORMAL;
}

void dec_a(void)
{
  cond = ALWAYS;
  immd = (inst_reg&0xfff);
  immd = (immd & 0x800)? 0xfffff000 | immd : immd;
  immd = immd<<1;
  rs1 = PC_REG;
  rs2 = IMMD;
  rd  = NONE;
  OP  = CMP;
  OP2 = JCC;
  delay_slot = 1;
}

void dec_b(void)
{
  immd = (inst_reg&0xfff);
  immd = (immd & 0x800)? 0xfffff000 | immd : immd;
  immd = immd<<1;
  rs1 = PC_REG;
  rs2 = IMMD;
  rs3 = PC_REG;
  rd  = NONE;
  OP  = ADD;
  OP2 = JSR;
  delay_slot = 1;
}

void dec_c(void)
{
  switch(rs1){
  case 0x0:
    rs3 = 0;
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = BYTE;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 0x1:
    rs3 = 0;
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex<<1;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 0x2:
    rs3 = 0;
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex<<2;
    rd  = NONE;
    OP  = ADD;
    OP2 = ST;
    msize = WORD;
    msex  = 0;
    mtype = NORMAL;
    break;
  case 0x3:
    immd = i_immd_zex;
    rd  = NONE;
    OP  = NOP;
    OP2 = TRAP;
    break;
  case 0x4:
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = 0;
    OP  = ADD;
    OP2 = LD;
    msize = BYTE;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x5:
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex<<1;
    rd  = 0;
    OP  = ADD;
    OP2 = LD;
    msize = HWORD;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x6:
    rs1 = GBR_REG;
    rs2 = IMMD;
    immd = i_immd_zex<<2;
    rd  = 0;
    OP  = ADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
    mtype = NORMAL;
    break;
  case 0x7:
    rs1 = PC_REG;
    rs2 = IMMD;
    immd = i_immd_zex<<2;
    rd  = 0;
    OP  = ADD;
    OP2 = NOP;
    msize = WORD;
    break;
  case 0x8:
    cond = TST;
    rs1 = 0;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = T_REG;
    OP  = CMP;
    OP2 = NOP;
    break;
  case 0x9:
    rs1 = 0;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = 0;
    OP  = AND;
    OP2 = NOP;
    break;
  case 0xa:
    rs1 = 0;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = 0;
    OP  = XOR;
    OP2 = NOP;
    break;
  case 0xb:
    rs1 = 0;
    rs2 = IMMD;
    immd = i_immd_zex;
    rd  = 0;
    OP  = OR;
    OP2 = NOP;
    break;
  case 0xc:
    immd = i_immd_zex;
    rs1 = 0;
    rs2 = GBR_REG;
    rd  = NONE;
    OP  = ADD;
    OP2 = LDST_TST;
    break;
  case 0xd:
    immd = i_immd_zex;
    rs1 = 0;
    rs2 = GBR_REG;
    rd  = NONE;
    OP  = ADD;
    OP2 = LDST_AND;
    break;
  case 0xe:
    immd = i_immd_zex;
    rs1 = 0;
    rs2 = GBR_REG;
    rd  = NONE;
    OP  = ADD;
    OP2 = LDST_XOR;
    break;
  case 0xf:
    immd = i_immd_zex;
    rs1 = 0;
    rs2 = GBR_REG;
    rd  = NONE;
    OP  = ADD;
    OP2 = LDST_OR;
    break;
  }
}

void dec_d(void)
{
  immd = i_immd_zex<<2;
  rs1 = PC_REG;
  rs2 = IMMD;
  rd  = rd;
  OP  = ADD;
  OP2 = LD;
  msize = WORD;
  msex  = 1;
  mtype = NORMAL;
}

void dec_e(void)
{
  immd = i_immd_sex;
  rs1 = NONE;
  rs2 = IMMD;
  rd  = rd;
  OP  = MOV;
  OP2 = NOP;
}

void decode(void)
{
  opcode	= (inst_reg>>12)&0xf;
  func          = (inst_reg)&0xff;
  rd		= (inst_reg>>8)&0xf;
  rs1		= (inst_reg>>8)&0xf;
  rs2           = (inst_reg>>4)&0xf;
  i_immd_zex	= (inst_reg)&0xff;
  i_immd_sex	= (i_immd_zex&0x80) ? 0xffffff00|i_immd_zex 
                : i_immd_zex;
  b_immd_zex	= (inst_reg)&0xff;
  b_immd_sex	= (b_immd_zex&0x80) ? 0xffffff00|b_immd_zex 
                : b_immd_zex;

  delay_slot = 0;
  msize = NONE;

  switch(opcode){
  case 0x0:
    dec_0();
    break;
  case 0x1:
    dec_1();
    break;
  case 0x2:
    dec_2();
    break;
  case 0x3:
    dec_3();
    break;
  case 0x4:
    dec_4();
    break;
  case 0x5:
    dec_5();
    break;
  case 0x6:
    dec_6();
    break;
  case 0x7:
    dec_7();
    break;
  case 0x8:
    dec_8();
    break;
  case 0x9:
    dec_9();
    break;
  case 0xa:
    dec_a();
    break;
  case 0xb:
    dec_b();
    break;
  case 0xc:
    dec_c();
    break;
  case 0xd:
    dec_d();
    break;
  case 0xe:
    dec_e();
    break;
  default:
    rs1	= NONE;
    rs2	= NONE;
    rd	= NONE;
    OP	= NOP;
    OP2	= EXP;
    break;
  }
}
