/* for OP */
#define ADD    0
#define ADDC   1
#define ADDV   2
#define AND    3
#define CLRMAC 4
#define CMP    5
#define DIV0S  6
#define DIV0U  7
#define DIV1   8
#define MAC    9
#define MOV   10
#define MUL   11
#define MULU  12
#define MULUW 13
#define MULW  14
#define NEG   15
#define NEGC  16
#define NOP   17
#define NOT   18
#define OR    19
#define ROL   20
#define ROLC  21
#define ROR   22
#define RORC  23
#define SEX   24
#define SLA   25
#define SLL   26
#define SRA   27
#define SRL   28
#define SUB   29
#define SUBC  30
#define SUBV  31
#define SWAPB 32
#define SWAPW 33
#define TAS   34
#define XOR   35
#define XTRCT 36
#define ZEX   37
/* for OP2 */
#define BRR   50
#define EXP   51
#define JCC   52
#define JPR   53
#define JSR   54
#define LD    55
#define LDST_AND 56
#define LDST_OR  57
#define LDST_TST 58
#define LDST_XOR 59
#define RTE   61
#define SLEEP 62
#define ST    63
#define TRAP  64
#define MULL  65
/* for msize */
#define WORD  0
#define HWORD 1
#define BYTE  2
/* for cond */
#define ALWAYS 0
#define DT     1
#define EQ     2
#define FALSE  3
#define GE     4
#define GEU    5
#define GT     6
#define GTU    7
#define NE     8
#define LT     9
#define LTU   10
#define LE    11
#define STR   12
#define TRUE  13
#define TST   14
/* for rs1, rs2, rs3 */
#define NONE     100
#define IMMD     101
#define GBR_REG  102
#define MACH_REG 103
#define MACL_REG 104
#define PC_REG   105
#define PR_REG   106
#define T_REG    107
#define VBR_REG  108
#define SR_REG   109
#define Q_REG    110
#define M_REG    111
/* for mtype */
#define NORMAL   0
#define POSTINC  1
#define PREDEC   2

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

