#include <stdio.h>
#include "define.h"
static int inst_reg;
static int opcode;
static int func;
static int rd;
static int rs1;
static int rs2;
static int rs3;
static int immd;
static int OP;
static int OP2;
static int mtype;
static int msize;
static int msex;
static int cond;
static int delay_slot;
static int i_immd_zex;
static int i_immd_sex;
static int b_immd_zex;
static int b_immd_sex;
static int PC;


static void dis_0(void)
{
  switch(inst_reg){
  case 0x08:/*CLRT */
    printf("clrt\n");
    return;
  case 0x09:/* NOP */
    printf("nop\n");
    return;
  case 0x0b:/* RTS */
    printf("rts\n");
    return;
  case 0x18:/* SETT */
    printf("sett\n");
    return;
  case 0x19:/* DIV0U */
    printf("div0u\n");
    return;
  case 0x1b:/* SLEEP */
    printf("sleep\n");
    return;
  case 0x28:/* CLRMAC */
    printf("clrmac\n");
    return;
  case 0x2b:/* RTE */
    printf("rte\n");
    return;
  default:
    break;
  }
  switch(func){
  case 0x03:/* BSRF */
    printf("bsrf\tr%d\n",rs1);
    return;
  case 0x23:/* BRAF */
    printf("bsaf\tr%d\n",rs1);
    return;
  case 0x02:/* STC SR */
    printf("stc\tsr,r%d\n",rs1);
    return;
  case 0x0a:/* STS MACH */
    printf("sts\tmach,r%d\n",rs1);
    return;
  case 0x12:/* STC GBR */
    printf("stc\tgbr,r%d\n",rs1);
    return;
  case 0x1a:/* STS MACL */
    printf("sts\tmacl,r%d\n",rs1);
    return;
  case 0x22:/* STC VBR */
    printf("stc\tvbr,r%d\n",rs1);
    return;
  case 0x29:/* MOVT */
    printf("movt\tr%d\n",rs1);
    return;
  case 0x2a:/* STS PR */
    printf("sts\tpr,r%d\n",rs1);
    return;
  default:
    break;
  }
  switch(func&0xf){
  case 0x4:
    printf("mov.b\tr%d,@(r0,r%d)\n",rs2,rs1);
    return;
  case 0x5:
    printf("mov.w\tr%d,@(r0,r%d)\n",rs2,rs1);
    return;
  case 0x6:
    printf("mov.l\tr%d,@(r0,r%d)\n",rs2,rs1);
    return;
  case 0x7:
    printf("mul.l\tr%d,r%d\n",rs2,rs1);
    return;
  case 0xc:
    printf("mov.b\t@(r0,r%d),r%d\n",rs2,rs1);
    return;
  case 0xd:
    printf("mov.w\t@(r0,r%d),r%d\n",rs2,rs1);
    return;
  case 0xe:
    printf("mov.l\t@(r0,r%d),r%d\n",rs2,rs1);
    return;
  case 0xf:
    printf("mac.l\t@r%d+,r%d+\n",rs2,rs1);
    return;
  default:
    printf(".hword\t0x%04x\n",inst_reg);
    break;
  }
}

static void dis_1(void)
{
  immd = (func & 0xf)<<2;
  printf("mov.l\tr%d,@(0x%x,r%d)\n",rs2,immd,rs1);
}

static void dis_2(void)
{
  switch(func&0xf){
  case 0:
    printf("mov.b\tr%d,@r%d\n",rs2,rs1);
    break;
  case 1:
    printf("mov.w\tr%d,@r%d\n",rs2,rs1);
    break;
  case 2:
    printf("mov.l\tr%d,@r%d\n",rs2,rs1);
    break;
  case 4:
    printf("mov.b\tr%d,@-r%d\n",rs2,rs1);
    break;
  case 5:
    printf("mov.w\tr%d,@-r%d\n",rs2,rs1);
    break;
  case 6:
    printf("mov.l\tr%d,@-r%d\n",rs2,rs1);
    break;
  case 7:
    printf("div0s\tr%d,r%d\n",rs2,rs1);
    break;
  case 8:
    printf("tst\tr%d,r%d\n",rs2,rs1);
    break;
  case 9:
    printf("and\tr%d,r%d\n",rs2,rs1);
    break;
  case 10:
    printf("xor\tr%d,r%d\n",rs2,rs1);
    break;
  case 11:
    printf("or\tr%d,r%d\n",rs2,rs1);
    break;
  case 12:
    printf("cmp/str\tr%d,r%d\n",rs2,rs1);
    break;
  case 13:
    printf("xtrct\tr%d,r%d\n",rs2,rs1);
    break;
  case 14:
    printf("mulu.w\tr%d,r%d\n",rs2,rs1);
    break;
  case 15:
    printf("muls.w\tr%d,r%d\n",rs2,rs1);
    break;
  default:
    printf(".hword\0x%04x\n",inst_reg);
    break;
  }
}

static void dis_3(void)
{
  switch(func&0xf){
  case 0:
    printf("cmp/eq\tr%d,r%d\n",rs2,rs1);
    break;
  case 2:
    printf("cmp/hs\tr%d,r%d\n",rs2,rs1);
    break;
  case 3:
    printf("cmp/ge\tr%d,r%d\n",rs2,rs1);
    break;
  case 4:
    printf("div1\tr%d,r%d\n",rs2,rs1);
    break;
  case 5:
    printf("dmultu.l\tr%d,r%d\n",rs2,rs1);
    break;
  case 6:
    printf("cmp/hi\tr%d,r%d\n",rs2,rs1);
    break;
  case 7:
    printf("cmp/gt\tr%d,r%d\n",rs2,rs1);
    break;
  case 8:
    printf("sub\tr%d,r%d\n",rs2,rs1);
    break;
  case 10:
    printf("subc\tr%d,r%d\n",rs2,rs1);
    break;
  case 11:
    printf("subv\tr%d,r%d\n",rs2,rs1);
    break;
  case 12:
    printf("add\tr%d,r%d\n",rs2,rs1);
    break;
  case 13:
    printf("dmuls.l\tr%d,r%d\n",rs2,rs1);
    break;
  case 14:
    printf("addc\tr%d,r%d\n",rs2,rs1);
    break;
  case 15:
    printf("addv\tr%d,r%d\n",rs2,rs1);
    break;
  default:
    printf(".hword\t0x%04x\n",inst_reg);
    break;
  }
}

static void dis_4(void)
{
  switch(func){
  case 0x06:
    printf("lds.l\t@r%d+,mach\n",rs1);
    break;
  case 0x07:
    printf("ldc.l\t@r%d+,sr\n",rs1);
    break;
  case 0x0a:
    printf("lds\tr%d,mach\n",rs1);
    break;
  case 0x0b:
    printf("jsr\t@r%d\n",rs1);
    break;
  case 0x0e:
    printf("ldc\tr%d,sr\n",rs1);
    break;
  case 0x16:
    printf("lds.l\t@r%d+,macl\n",rs1);
    break;
  case 0x17:
    printf("ldc.l\t@r%d+,gbr\n",rs1);
    break;
  case 0x1a:
    printf("lds\tr%d,macl\n",rs1);
    break;
  case 0x1e:
    printf("lds\tr%d,gbr\n",rs1);
    break;
  case 0x26:
    printf("lds.l\t@r%d+,pr\n",rs1);
    break;
  case 0x27:
    printf("ldc.l\t@r%d+,vbr\n",rs1);
    break;
  case 0x2a:
    printf("lds\tr%d,pr\n",rs1);
    break;
  case 0x2b:
    printf("jmp\t@r%d\n",rs1);
    break;
  case 0x2c:
    printf("ldc\tr%d,vbr\n",rs1);
    break;
  case 0x00:
    printf("shll\tr%d\n",rs1);
    break;
  case 0x01:
    printf("shlr\tr%d\n",rs1);
    break;
  case 0x02:
    printf("sts.l\tmach,@-r%d\n",rs1);
    break;
  case 0x03:
    printf("stc.l\tsr,@-r%d\n",rs1);
    break;
  case 0x04:
    printf("rotl\tr%d\n",rs1);
    break;
  case 0x05:
    printf("rotr\tr%d\n",rs1);
    break;
  case 0x08:
    printf("shll2\tr%d\n",rs1);
    break;
  case 0x09:
    printf("shlr2\tr%d\n",rs1);
    break;
  case 0x10:
    printf("dt\tr%d\n",rs1);
    break;
  case 0x11:
    printf("cmp/pz\tr%d\n",rs1);
    break;
  case 0x12:
    printf("sts.l\tmacl,@-r%d\n",rs1);
    break;
  case 0x13:
    printf("sts.l\tgbr,@-r%d\n",rs1);
    break;
  case 0x15:
    printf("cmp/pl\tr%d\n",rs1);
    break;
  case 0x18:
    printf("shll8\tr%d\n",rs1);
    break;
  case 0x19:
    printf("shlr8\tr%d\n",rs1);
    break;
  case 0x1b:
    printf("tas.b\t@r%d\n",rs1);
    break;
  case 0x20:
    printf("shal\tr%d\n",rs1);
    break;
  case 0x21:
    printf("shar\tr%d\n",rs1);
    break;
  case 0x22:
    printf("sts.l\tpr,@-r%d\n",rs1);
    break;
  case 0x23:
    printf("stc.l\tvbr,@-r%d\n",rs1);
    break;
  case 0x24:
    printf("rotcl\tr%d\n",rs1);
    break;
  case 0x25:
    printf("rotcr\tr%d\n",rs1);
    break;
  case 0x28:
    printf("shll16\tr%d\n",rs1);
    break;
  case 0x29:
    printf("shlr16\tr%d\n",rs1);
    break;
  case 0x0f:
  case 0x1f:
  case 0x2f:
  case 0x3f:
  case 0x4f:
  case 0x5f:
  case 0x6f:
  case 0x7f:
  case 0x8f:
  case 0x9f:
  case 0xaf:
  case 0xbf:
  case 0xcf:
  case 0xdf:
  case 0xef:
  case 0xff:
    printf("mac.w\t@r%d+,@r%d+\n",rs2,rs1);
    break;
  default:
    printf(".hword\t0x%04x\n",inst_reg);
    break;
  }
}

static void dis_5(void)
{
  immd = (func & 0xf)<<2;
  printf("mov.l\t@(0x%x,r%d),r%d\n",immd,rs2,rs1);
}

static void dis_6(void)
{
  switch(func&0xf){
  case 0x0:
    printf("mov.b\t@r%d,r%d\n",rs2,rs1);
    break;
  case 0x1:
    printf("mov.w\t@r%d,r%d\n",rs2,rs1);
    break;
  case 0x2:
    printf("mov.l\t@r%d,r%d\n",rs2,rs1);
    break;
  case 0x3:
    printf("mov\tr%d,r%d\n",rs2,rs1);
    break;
  case 0x4:
    printf("mov.b\t@r%d+,r%d\n",rs2,rs1);
    break;
  case 0x5:
    printf("mov.w\t@r%d+,r%d\n",rs2,rs1);
    break;
  case 0x6:
    printf("mov.l\t@r%d+,r%d\n",rs2,rs1);
    break;
  case 0x7:
    printf("not\tr%d,r%d\n",rs2,rs1);
    break;
  case 0x8:
    printf("swap.b\tr%d,r%d\n",rs2,rs1);
    break;
  case 0x9:
    printf("swap.w\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xa:
    printf("negc\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xb:
    printf("neg\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xc:
    printf("extu.b\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xd:
    printf("extu.w\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xe:
    printf("exts.b\tr%d,r%d\n",rs2,rs1);
    break;
  case 0xf:
    printf("exts.w\tr%d,r%d\n",rs2,rs1);
    break;
  }
}

static void dis_7(void)
{
  immd = i_immd_sex;
  if(immd<0)
    printf("add\t#-0x%x,r%d\n",-immd,rs1);
  else
    printf("add\t#0x%x,r%d\n",immd,rs1);
}

void dis_8(void)
{
  switch(rs1){
  case 0x0:
    immd = (func&0xf);
    printf("mov.b\tr0,@(0x%x,r%d)\n",immd,rs2);
    break;
  case 0x1:
    immd = (func&0xf)<<1;
    printf("mov.w\tr0,@(0x%x,r%d)\n",immd,rs2);
    break;
  case 0x4:
    immd = (func&0xf);
    printf("mov.b\t@(0x%x,r%d),r0\n",immd,rs2);
    break;
  case 0x5:
    immd = (func&0xf)<<1;
    printf("mov.w\t@(0x%x,r%d),r0\n",immd,rs2);
    break;
  case 0x8:
    immd = i_immd_sex;
    if(immd<0)
      printf("cmp/eq\t#-0x%x,r0\n",-immd);
    else
      printf("cmp/eq\t#0x%x,r0\n",immd);
    break;
  case 0x9:
    immd = b_immd_sex<<1;
    printf("bt\t0x%x\n",PC+4+immd);
    break;
  case 0xb:
    immd = b_immd_sex<<1;
    printf("bf\t0x%x\n",PC+4+immd);
    break;
  case 0xd:
    immd = b_immd_sex<<1;
    printf("bt/s\t0x%x\n",PC+4+immd);
    break;
  case 0xf:
    immd = b_immd_sex<<1;
    printf("bf/s\t0x%x\n",PC+4+immd);
    break;
  default:
    printf(".hword\t0x%04x\n",inst_reg);
    break;
  }
}

static void dis_9(void)
{
  immd = i_immd_zex<<1;
  printf("mov.w\t@(0x%x,pc),r%d\n",immd,rs1);
}

static void dis_a(void)
{
  cond = ALWAYS;
  immd = (inst_reg&0xfff);
  immd = (immd & 0x800)? 0xfffff000 | immd : immd;
  immd = immd<<1;
  printf("bra\t0x%08x\n",PC+4+immd);
}

static void dis_b(void)
{
  immd = (inst_reg&0xfff);
  immd = (immd & 0x800)? 0xfffff000 | immd : immd;
  immd = immd<<1;
  printf("bsr\t0x%08x\n",PC+4+immd);
}

static void dis_c(void)
{
  switch(rs1){
  case 0x0:
    immd = i_immd_zex;
    printf("mov.b\tr0,@(0x%x,gbr)\n",immd);
    break;
  case 0x1:
    immd = i_immd_zex<<1;
    printf("mov.w\tr0,@(0x%x,gbr)\n",immd);
    break;
  case 0x2:
    immd = i_immd_zex<<2;
    printf("mov.l\tr0,@(0x%x,gbr)\n",immd);
    break;
  case 0x3:
    immd = i_immd_zex;
    printf("trapa\t#0x%x\n",immd);
    break;
  case 0x4:
    immd = i_immd_zex;
    printf("mov.b\t@(0x%x,gbr),r0\n",immd);
    break;
  case 0x5:
    immd = i_immd_zex<<1;
    printf("mov.w\t@(0x%x,gbr),r0\n",immd);
    break;
  case 0x6:
    immd = i_immd_zex<<2;
    printf("mov.l\t@(0x%x,gbr),r0\n",immd);
    break;
  case 0x7:
    immd = i_immd_zex<<2;
    printf("mova\t@(0x%x,pc),r0\n",immd);
    break;
  case 0x8:
    immd = i_immd_zex;
    printf("tst\t#0x%x,r0\n",immd);
    break;
  case 0x9:
    immd = i_immd_zex;
    printf("and\t#0x%x,r0\n",immd);
    break;
  case 0xa:
    immd = i_immd_zex;
    printf("xor\t#0x%x,r0\n",immd);
    break;
  case 0xb:
    immd = i_immd_zex;
    printf("or\t#0x%x,r0\n",immd);
    break;
  case 0xc:
    immd = i_immd_zex;
    printf("tst.b\t#0x%x,@(r0,gbr)\n",immd);
    break;
  case 0xd:
    immd = i_immd_zex;
    printf("and.b\t#0x%x,@(r0,gbr)\n",immd);
    break;
  case 0xe:
    immd = i_immd_zex;
    printf("xor.b\t#0x%x,@(r0,gbr)\n",immd);
    break;
  case 0xf:
    immd = i_immd_zex;
    printf("or.b\t#0x%x,@(r0,gbr)\n",immd);
    break;
  }
}

static void dis_d(void)
{
  immd = i_immd_zex<<2;
  printf("mov.l\t@(0x%x,pc),r%d\n",immd,rs1);
}

static void dis_e(void)
{
  immd = i_immd_sex;
  if(immd<0)
    printf("mov\t#-0x%x,r%d\n",-immd,rs1);
  else
    printf("mov\t#0x%x,r%d\n",immd,rs1);
}

static void dis(void)
{
  opcode	= (inst_reg>>12)&0xf;
  func          = (inst_reg)&0xff;
  rd		= (inst_reg>>8)&0xf;
  rs1		= (inst_reg>>8)&0xf;
  rs2           = (inst_reg>>4)&0xf;
  i_immd_zex	= (inst_reg)&0xff;
  i_immd_sex	= (i_immd_zex&0x80) ? 0xffffff00|i_immd_zex 
                : i_immd_zex;
  b_immd_zex	= (inst_reg)&0xff;
  b_immd_sex	= (b_immd_zex&0x80) ? 0xffffff00|b_immd_zex 
                : b_immd_zex;

  delay_slot = 0;

  switch(opcode){
  case 0x0:
    dis_0();
    break;
  case 0x1:
    dis_1();
    break;
  case 0x2:
    dis_2();
    break;
  case 0x3:
    dis_3();
    break;
  case 0x4:
    dis_4();
    break;
  case 0x5:
    dis_5();
    break;
  case 0x6:
    dis_6();
    break;
  case 0x7:
    dis_7();
    break;
  case 0x8:
    dis_8();
    break;
  case 0x9:
    dis_9();
    break;
  case 0xa:
    dis_a();
    break;
  case 0xb:
    dis_b();
    break;
  case 0xc:
    dis_c();
    break;
  case 0xd:
    dis_d();
    break;
  case 0xe:
    dis_e();
    break;
  default:
    printf(".hword\t0x%04x\n",inst_reg);
    break;
  }
}

void disasm(unsigned int addr1, unsigned int addr2)
{
  unsigned int i;
  for(i=addr1;i<=addr2;i+=2){
    PC = i;
    inst_reg = get_mem((int)i,HWORD);
    printf("%08x %04x: ",PC, inst_reg);
    dis();
  }
}

