#include <stdio.h>
#include "define.h"
/*
GBR_REG
IMMD
MACH_REG
MACL_REG
NONE
PC_REG
PR_REG
SR_REG
T_REG
VBR_REG
*/

int PC;
int RF[16];
int MACH, MACL;
int GBR;
int PR;
int SR;
int T;
int Q;
int M;
int VBR;

int get_reg(int reg)
{
  if((reg>=0)&&(reg<=15))
    return RF[reg];
  if(reg==GBR_REG)
    return GBR;
  if(reg==MACH_REG)
    return MACH;
  if(reg==MACL_REG)
    return MACL;
  if(reg==PC_REG)
    return PC+4;
  if(reg==PR_REG)
    return PR;
  if(reg==SR_REG)
    return SR;
  if(reg==T_REG)
    return T;
  if(reg==Q_REG)
    return Q;
  if(reg==M_REG)
    return M;
  if(reg==VBR_REG)
    return VBR;
  return 0;
}

void put_reg(int reg, int value)
{
  if((reg>=0)&&(reg<=15)){
   RF[reg] = value;
    return;
  }
  if(reg==GBR_REG){
    GBR = value;
    return;
  }
  if(reg==MACH_REG){
    MACH = value;
    return;
  }
  if(reg==MACL_REG){
    MACL = value;
    return;
  }
  if(reg==PC_REG){
    PC = value &0xfffffffe;
    return;
  }
  if(reg==PR_REG){
    PR = value;
    return;
  }
  if(reg==SR_REG){
    SR = value;
    return;
  }
  if(reg==T_REG){
    T = value & 1;
    return;
  }
  if(reg==Q_REG){
    Q = value & 1;
    return;
  }
  if(reg==M_REG){
    M = value & 1;
    return;
  }
  if(reg==VBR_REG){
    VBR = value;
    return;
  }
}

void reg_dump(void)
{
    printf("00:%08x 01:%08x 02:%08x 03:%08x 04:%08x 05:%08x 06:%08x 07:%08x\n",
	   RF[0], RF[1], RF[2], RF[3], RF[4], RF[5], RF[6], RF[7]);
    printf("08:%08x 09:%08x 10:%08x 11:%08x 12:%08x 13:%08x 14:%08x 15:%08x\n",
	   RF[8], RF[9], RF[10], RF[11], RF[12], RF[13], RF[14], RF[15]);
    printf("MACH:%08x MACL:%08x PR:%08x GBR: %08x T:%d M:%d Q:%d\n",
	   MACH, MACL, PR, GBR, T, M , Q);
}
