#include "define.h"
int rs1;
int rs2;
int rs3;
int rs4;
int rd;
int immd;
int immd2;
int OP;
int OP2;
int cond;
int msize;
int msex;
int rlist;
int inst_len;

int inst_reg;
int inst_reg2;
int inst_reg3;
int inst_reg4;

static int opcode;

void dec_00(void)
{
  if(rs2!=0){/* MOV */
	rs2 = rs1;
    OP  = MOV;
    OP2 = NOP;
    return;
  }
  switch(rs1){
  case 0x00:/* NOP */
    rd  = NONE;
    OP  = NOP;
    OP2 = NOP;
    break;
  case 0x1d:/* SYNCE */
    rd  = NONE;
    OP  = NOP;
    OP2 = NOP;
    break;
  case 0x1e:/* SYNCM */
    rd  = NONE;
    OP  = NOP;
    OP2 = NOP;
    break;
  case 0x1f:/* SYNCP */
    rd  = NONE;
    OP  = NOP;
    OP2 = NOP;
    break;
  default:
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
    break;
  }
}

void dec_01(void)
{
  rs2 = rs1;
  OP  = NOT;
  OP2 = NOP;
}

void dec_02(void)
{
  switch(rs1){
  case 0x00:/* RIE / FETRAP */
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
    break;
  default:
    if(rs2==0){
      rd  = NONE;
      OP  = SWITCH;
      OP2 = NOP;
    }
    else{
      rs3 = 0;
      rd  = NONE;
      OP  = DIVH;
      OP2 = NOP;
    }
    break;
  }
}

void dec_03(void)
{
  switch(rs2){
  case 0x00:/* JMP [reg] */
    immd = 0;
    rs2 = IMMD;
    rd  = NONE;
    OP  = EADD;
    OP2 = JPR;
    break;
  default:
    if(rs1&0x10){
      immd = (rs1 & 0xf)<<1;
      msize = HWORD;
    }
    else{
      immd = rs1 & 0xf;
      msize = BYTE;
    }
    msex = 0;
    rs1 = 30;
    rs2 = IMMD;
    OP  = EADD;
    OP2 = LD;
    break;
  }
}

void dec_04(void)
{
  int tmp;
  if(rs2==0){
    rd  = rs1;
    rs2 = rs1;
    OP  = ZEX;
    OP2 = NOP;
    msize = BYTE;
  }
  else{
    tmp = rs1;
    rs1 = rs2;
    rs2 = tmp;
    OP  = SATSUB;
    OP2 = NOP;
  }
}

void dec_05(void)
{
  if(rs2==0){
    rd  = rs1;
    rs2 = rs1;
    OP  = SEX;
    OP2 = NOP;
    msize = BYTE;
  }
  else{
    OP  = SATSUB;
    OP2 = NOP;
  }
}

void dec_06(void)
{
  if(rs2==0){
    rd  = rs1;
    rs2 = rs1;
    OP  = ZEX;
    OP2 = NOP;
    msize = HWORD;
  }
  else{
    OP  = SATADD;
    OP2 = NOP;
  }
}

void dec_07(void)
{
  if(rs2==0){
    rd  = rs1;
    rs2 = rs1;
    OP  = SEX;
    OP2 = NOP;
    msize = HWORD;
  }
  else{
    OP  = MULH;
    OP2 = NOP;
  }
}

void dec_08(void)
{
  OP  = OR;
  OP2 = NOP;
}

void dec_09(void)
{
  OP  = XOR;
  OP2 = NOP;
}

void dec_0a(void)
{
  OP  = AND;
  OP2 = NOP;
}

void dec_0b(void)
{
  rd  = NONE;
  OP  = AND;
  OP2 = NOP;
}

void dec_0c(void)
{
  int tmp;

  tmp = rs1;
  rs1 = rs2;
  rs2 = tmp;
  OP  = SUB;
  OP2 = NOP;
}

void dec_0d(void)
{
  OP  = SUB;
  OP2 = NOP;
}

void dec_0e(void)
{
  OP  = ADD;
  OP2 = NOP;
}

void dec_0f(void)
{
  rd  = NONE;
  OP  = SUB;
  OP2 = NOP;
}

void dec_10(void)
{
  if(rs2==0){/* CALLT */
    immd = (rs1|0x00)<<1;
    rd  = NONE;
    OP  = CALLT;
    OP2 = NOP;
  }
  else{
    immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1;
    rs2 = IMMD;
    OP  = MOV;
    OP2 = NOP;
  }
}

void dec_11(void)
{
  if(rs2==0){/* CALLT */
    immd = (rs1|0x20)<<1;
    rd  = NONE;
    OP  = CALLT;
    OP2 = NOP;
  }
  else{
    immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1;
    rs1 = IMMD;
    OP  = SATADD;
    OP2 = NOP;
  }
}

void dec_12(void)
{
  immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1;
  rs1 = IMMD;
  OP  = ADD;
  OP2 = NOP;
}

void dec_13(void)
{
  immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1;
  rs1 = IMMD;
  rd  = NONE;
  OP  = SUB;
  OP2 = NOP;
}

void dec_14(void)
{
  immd = rs1;
  rs1 = IMMD;
  OP  = SRL;
  OP2 = NOP;
}

void dec_15(void)
{
  immd = rs1;
  rs1 = IMMD;
  OP  = SRA;
  OP2 = NOP;
}

void dec_16(void)
{
  immd = rs1;
  rs1 = IMMD;
  OP  = SLL;
  OP2 = NOP;
}


void dec_17(void)
{
  if((rs1==0)&&(rs2==0)){/* JR */
    immd = (inst_reg2<<16)|(inst_reg&0xfffffffe);
    rs1 = CUR_PC;
    rs2 = IMMD;
    rd  = NONE;
    OP  = EADD;
    OP2 = JMP;
    inst_len = 6;
  }
  else if(rs2==0){ /* JARL */
    immd = (inst_reg2<<16)|(inst_reg&0xfffffffe);
    rd  = rs1;
    rs1 = CUR_PC;
    rs2 = IMMD;
    rs3 = NXT_PC;
    OP  = EADD;
    OP2 = JARL;
    inst_len = 6;
  }
  else{
    immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1;
    rs1 = IMMD;
    OP  = MULH;
    OP2 = NOP;
  }
}

void dec_18(void)
{
  immd = (inst_reg)&0x7f;
  rs1 = 30;
  rs2 = IMMD;
  OP  = EADD;
  OP2 = LD;
  msize = BYTE;
  msex  = 1;
}

void dec_19(void)
{
  dec_18();
}

void dec_1a(void)
{
  dec_18();
}

void dec_1b(void)
{
  dec_18();
}

void dec_1c(void)
{
  immd = (inst_reg)&0x7f;
  rs3 = rs2;
  rs1 = 30;
  rs2 = IMMD;
  rd  = NONE;
  OP  = EADD;
  OP2 = ST;
  msize = BYTE;
  msex  = 1;
}

void dec_1d(void)
{
  dec_1c();
}

void dec_1e(void)
{
  dec_1c();
}

void dec_1f(void)
{
  dec_1c();
}

void dec_20(void)
{
  immd = (inst_reg)&0x7f;
  immd = immd<<1;
  rs1 = 30;
  rs2 = IMMD;
  OP  = EADD;
  OP2 = LD;
  msize = HWORD;
  msex  = 1;
}

void dec_21(void)
{
  dec_20();
}

void dec_22(void)
{
  dec_20();
}

void dec_23(void)
{
  dec_20();
}

void dec_24(void)
{
  immd = (inst_reg)&0x7f;
  immd = immd <<1;
  rs3 = rs2;
  rs1 = 30;
  rs2 = IMMD;
  rd  = NONE;
  OP  = EADD;
  OP2 = ST;
  msize = HWORD;
  msex  = 1;
}

void dec_25(void)
{
  dec_24();
}

void dec_26(void)
{
  dec_24();
}

void dec_27(void)
{
  dec_24();
}

void dec_28(void)
{
  immd = (inst_reg)&0x7e;
  immd = immd<<1;
  if(rs1&1){
    rs3 = rs2;
    rs1 = 30;
    rs2 = IMMD;
    rd  = NONE;
    OP  = EADD;
    OP2 = ST;
    msize = HWORD;
    msex  = 1;
  }
  else{
    rs1 = 30;
    rs2 = IMMD;
    OP  = EADD;
    OP2 = LD;
    msize = WORD;
    msex  = 1;
  }
}

void dec_29(void)
{
  dec_28();
}

void dec_2a(void)
{
  dec_28();
}

void dec_2b(void)
{
  dec_28();
}

void dec_2c(void)
{
  immd = (rs2<<3)|((inst_reg>>4)&7);
  immd = (immd&0x80)? 0xffffff00|immd : immd;
  immd = immd <<1;
  cond = rs1&0xf;
  rs1  = CUR_PC;
  rs2  = IMMD;
  rd   = NONE;
  OP   = EADD;
  OP2  = JCC;
}

void dec_2d(void)
{
  dec_2c();
}

void dec_2e(void)
{
  dec_2c();
}

void dec_2f(void)
{
  dec_2c();
}

void dec_30(void)
{
  immd = inst_reg2;
  immd = (immd & 0x8000)? 0xffff0000|immd : immd & 0xffff;
  rs2  = IMMD;
  OP   = ADD;
  OP2  = NOP;
  inst_len = 4;
}

void dec_31(void)
{
  if(rs2==0){
    immd = (inst_reg3<<16)|inst_reg2;
    rd   = rs1;
    rs2 = IMMD;
    OP  = MOV;
    OP2 = NOP;
    inst_len = 6;
  }
  else{
    immd = inst_reg2;
    immd = (immd & 0x8000)? 0xffff0000|immd : immd & 0xffff;
    rs2  = IMMD;
    OP   = EADD;
    OP2  = NOP;
    inst_len = 4;
  }
}

void dec_32(void)
{
  if(rs2==0){/* DISPOSE */
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rs3 = inst_reg2 & 0x1f;
    rd = NONE;
    OP  = DISPOSE;
    OP2 = NOP;
  }
  else{ /* MOVHI */
    immd = inst_reg2;
    immd = (immd & 0x8000)? 0xffff0000|immd : immd & 0xffff;
    immd = immd <<16;
    rs2  = IMMD;
    OP   = EADD;
    OP2  = NOP;
  }
  inst_len = 4;
}

void dec_33(void)
{
  if(rs2==0){/* DISPOSE */
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rs3 = inst_reg2 & 0x1f;
    rd = NONE;
    OP  = DISPOSE;
    OP2 = NOP;
  }
  else{
    immd = inst_reg2;
    immd = (immd & 0x8000)? 0xffff0000|immd : immd & 0xffff;
    rs2  = IMMD;
    OP   = SATSUB;
    OP2  = NOP;
  }
  inst_len = 4;
}

void dec_34(void)
{
  immd = inst_reg2&0xffff;
  rs2 = IMMD;
  OP  = OR;
  OP2 = NOP;
  inst_len = 4;
}

void dec_35(void)
{
  immd = inst_reg2&0xffff;
  rs2 = IMMD;
  OP  = XOR;
  OP2 = NOP;
  inst_len = 4;
}

void dec_36(void)
{
  immd = inst_reg2&0xffff;
  rs2 = IMMD;
  OP  = AND;
  OP2 = NOP;
  inst_len = 4;
}

void dec_37(void)
{
  if(rs2==0){/* JMP imm32[reg1] */
    immd = (inst_reg3<<16)|(inst_reg2&0xfffffffe);
    rs2 = IMMD;
    rd  = NONE;
    OP  = EADD;
    OP2 = JPR;
    inst_len = 6;
  }
  else{
    immd = inst_reg2&0xffff;
    rs2 = IMMD;
    OP  = MULH;
    OP2 = NOP;
    inst_len = 4;
  }
}

void dec_38(void)
{
  immd = inst_reg2;
  immd = (inst_reg2 &0x8000)? 0xffff0000 | immd : immd &0xffff;
  rs2 = IMMD;
  OP  = EADD;
  OP2 = LD;
  msize = BYTE;
  msex = 1;
  inst_len = 4;
}

void dec_39(void)
{
  immd = inst_reg2&0xfffe;
  immd = (inst_reg2 &0x8000)? 0xffff0000 | immd : immd &0xffff;
  rs2 = IMMD;
  OP  = EADD;
  OP2 = LD;
  msize = (inst_reg2&1)? WORD : HWORD;
  msex = 1;
  inst_len = 4;
}

void dec_3a(void)
{
  immd = inst_reg2;
  immd = (inst_reg2 &0x8000)? 0xffff0000 | immd : immd &0xffff;
  rs3 = rs2;
  rs2 = IMMD;
  rd  = NONE;
  OP  = EADD;
  OP2 = ST;
  msize = BYTE;
  msex = 1;
  inst_len = 4;
}

void dec_3b(void)
{
  immd = inst_reg2&0xfffe;
  immd = (inst_reg2 &0x8000)? 0xffff0000 | immd : immd &0xffff;
  rs3 = rs2;
  rs2 = IMMD;
  rd  = NONE;
  OP  = EADD;
  OP2 = ST;
  msize = (inst_reg2&1)? WORD : HWORD;
  msex = 1;
  inst_len = 4;
}

static void dec_prep(void)
{
  switch((inst_reg2>>3)&0x3){
  case 0:
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rd = NONE;
    rs3 = inst_reg2 & 0x1f;
    OP  = PREPARE;
    OP2 = NOP;
    inst_len = 4;
    break;
  case 1:
    immd2 = inst_reg3;
    immd2 = (immd2 &0x8000)? 0xffff0000|immd2 : immd2 &0xffff;
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rd = NONE;
    rs3 = inst_reg2 & 0x1f;
    OP  = PREPARE;
    OP2 = NOP;
    inst_len = 6;
    break;
  case 2:
    immd2 = inst_reg3 <<16;
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rd = NONE;
    rs3 = inst_reg2 & 0x1f;
    OP  = PREPARE;
    OP2 = NOP;
    inst_len = 6;
    break;
  case 3:
    immd2 = (inst_reg3<<16)|(inst_reg2&0xffff);
    immd = (inst_reg>>1)&0x1f;
    rlist = (((inst_reg2>>5)&0x7ff)<<1)|(rs1&1);
    rs3 = inst_reg2 & 0x1f;
    rd = NONE;
    OP  = PREPARE;
    OP2 = NOP;
    inst_len = 8;
    break;
  }
 }


void dec_3c(void)
{
  if(rs2==0){
    switch(inst_reg2&0xf){
    case 1:
    case 3:/* PREPARE */
    case 11:
      dec_prep();
      break;
    case 5:
    case 7:
    case 9:
      immd = ((inst_reg2>>4)&0x7f)|(inst_reg3<<7);
      immd = (immd & 0x400000)? 0xff800000|immd : immd &0x3fffff;
      rd = (inst_reg2>>11)&0x1f;
      rs2 = IMMD;
      OP  = EADD;
      OP2 = LD;
      switch(inst_reg2&0xf){
      case 5:
	msize = BYTE;
	break;
      case 7:
	msize = HWORD;
      default:
	msize = WORD;
	break;
      }
      msex = 1;
      inst_len = 6;
      break;
    case 13:
    case 15:
      immd = ((inst_reg2>>4)&0x7f)|(inst_reg3<<7);
      immd = (immd & 0x400000)? 0xff800000|immd : immd &0x3fffff;
      rs3 = (inst_reg2>>11)&0x1f;
      rs2 = IMMD;
      rd  = NONE;
      OP  = EADD;
      OP2 = ST;
      switch(inst_reg2&0xf){
      case 15:
	msize = BYTE;
	break;
      default:
	msize = WORD;
	break;
      }
      msex = 1;
      inst_len = 6;
    default:/* JR disp22 */
      immd = ((inst_reg&0x3f)<<16)|(inst_reg2&0xfffe);
      immd = (immd &0x200000)? 0xffc00000|immd : immd&0x3fffff;
      rs1 = CUR_PC;
      rs2 = IMMD;
      rd  = NONE;
      OP  = EADD;
      OP2 = JMP;
      inst_len = 4;
      break;
    }
  }
  else{
    if(inst_reg2&1){/* LD.BU disp16 */
      immd = (inst_reg2 & 0xfffe)|((inst_reg>>5)&1);
      immd = (immd & 0x8000)? 0xffff0000|immd : immd&0xffff;
      rs2 = IMMD;
      OP  = EADD;
      OP2 = LD;
      msize = BYTE;
      msex = 0;
      inst_len = 4;
    }
    else{
      immd = ((inst_reg&0x3f)<<16)|(inst_reg2&0xfffe);
      immd = (immd &0x200000)? 0xffc00000|immd : immd&0x3fffff;
      rd  = rs2;
      rs1 = CUR_PC;
      rs2 = IMMD;
      rs3 = NXT_PC;
      OP  = EADD;
      OP2 = JARL;
      inst_len = 4;
    }
  }
}

void dec_3d(void)
{
  if(rs2==0){
    switch(inst_reg2&0xf){
    case 1:
    case 3:/* PREPARE */
    case 11:
      dec_prep();
      break;
    case 5:
    case 7:
      immd = ((inst_reg2>>4)&0x7f)|(inst_reg3<<7);
      immd = (immd & 0x400000)? 0xff800000|immd : immd &0x3fffff;
      rd = (inst_reg2>>11)&0x1f;
      rs2 = IMMD;
      OP  = EADD;
      OP2 = LD;
      switch(inst_reg2&0xf){
      case 5:
	msize = BYTE;
	break;
      default:
	msize = WORD;
	break;
      }
      msex = 0;
      inst_len = 6;
      break;
    case 13:
      immd = ((inst_reg2>>4)&0x7f)|(inst_reg3<<7);
      immd = (immd & 0x400000)? 0xff800000|immd : immd &0x3fffff;
      rs3 = (inst_reg2>>11)&0x1f;
      rs2 = IMMD;
      rd  = NONE;
      OP  = EADD;
      OP2 = ST;
      msize = HWORD;
      msex = 1;
      inst_len = 6;
      break;
    default:/* JR disp22 */
      immd = ((inst_reg&0x3f)<<16)|(inst_reg2&0xfffe);
      immd = (immd &0x200000)? 0xffc00000|immd : immd&0x3fffff;
      rs1 = CUR_PC;
      rs2 = IMMD;
      rd  = NONE;
      OP  = EADD;
      OP2 = JMP;
      inst_len = 4;
      break;
    }
  }
  else{
    if(inst_reg2&1){/* LD.BU disp16 */
      immd = (inst_reg2 & 0xfffe)|((inst_reg>>5)&1);
      immd = (immd & 0x8000)? 0xffff0000|immd : immd&0xffff;
      rs2 = IMMD;
      OP  = EADD;
      OP2 = LD;
      msize = BYTE;
      msex = 0;
      inst_len = 4;
    }
    else{
      immd = ((inst_reg&0x3f)<<16)|(inst_reg2&0xfffe);
      immd = (immd &0x200000)? 0xffc00000|immd : immd&0x3fffff;
      rd  = rs2;
      rs1 = CUR_PC;
      rs2 = IMMD;
      rs3 = NXT_PC;
      OP  = EADD;
      OP2 = JARL;
      inst_len = 4;
    }
  }
}

void dec_3e(void)
{
  immd = inst_reg2;
  immd = (immd & 0x8000)? 0xffff0000|immd : immd&0xffff;
  immd2 = rs2&0x7;
  rs2 = IMMD;
  OP  = EADD;
  switch((rd>>3)&0x3){
  case 0:
    OP2 = SET1;
    break;
  case 1:
    OP2 = NOT1;
    break;
  case 2:
    OP2 = CLR1;
    break;
  case 3:
    OP2 = TST1;
    break;
  }
  rd  = NONE;
  inst_len = 4;
}

void dec_3f_00(void)
{
  if(rs1&0x10){ /* RIE */
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = RIE;
  }
  else{ /* SETF */
    cond = rs1 &0xf;
    OP  = SETF;
    OP2 = NOP;
  }
}

void dec_3f_01(void)
{
  rd  = NONE;
  OP  = LDSR;
  OP2 = NOP;
}

void dec_3f_02(void)
{
  rd  = NONE;
  OP  = STSR;
  OP2 = NOP;
}


void dec_3f_03(void)
{
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
}

void dec_3f_04(void)
{
  if(inst_reg2&0x2){
    rd  = rs2;
  }
  OP  = SRL;
  OP2 = NOP;
}

void dec_3f_05(void)
{
  if(inst_reg2&0x2){
    rd  = rs2;
  }
  OP  = SRA;
  OP2 = NOP;
}

void dec_3f_06(void)
{
  if(inst_reg2&0x2){
    rd  = rs2;
  }
  OP  = SLL;
  OP2 = NOP;
}

void dec_3f_07(void)
{
  if(((inst_reg2>>11)&0x1f)!=0){
    rs3 = (inst_reg2>>11)&0x1f;
    OP  = CAXI;
    OP2 = NOP;
    return;
  }
  immd = 0;
  immd2 = 0x100|rs2;
  rs2 = IMMD;
  OP  = EADD;
  switch(inst_reg2&0x7){
  case 0:
    OP2 = SET1;
    break;
  case 2:
    OP2 = NOT1;
    break;
  case 4:
    OP2 = CLR1;
    break;
  case 6:
    OP2 = TST1;
    break;
  }
}

void dec_3f_08(void)
{
  immd = rs1;
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = TRAP;
}

void dec_3f_09(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = HALT;
}

void dec_3f_0a(void)
{
  switch((inst_reg2)&0xf){
  case 0:
    OP2 = RETI;
    break;
  case 4:
    OP2 = CTRET;
    break;
  case 8:
    OP2 = EIRET;
    break;
  case 10:
    OP2 = FERET;
    break;
  default:
    OP2 = EXP;
    break;
  }
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
}

void dec_3f_0b(void)
{
  switch(rs2){
  case 0x00:
    OP2 = DI;
    break;
  case 0x10:
    OP2 = EI;
    break;
  case 0x1a:
    immd = rs1;
    OP2 = SYSCALL;
    break;
  case 10:
    OP2 = FERET;
    break;
  default:
    OP2 = EXP;
    break;
  }
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
}

void dec_3f_0c(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = EXP;
}

void dec_3f_0d(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = EXP;
}

void dec_3f_0e(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = EXP;
}

void dec_3f_0f(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = EXP;
}

void dec_3f_10(void)
{
  cond = rs1 &0xf;
  rs1 = rs2;
  rs2 = rs2;
  OP  = SASF;
  OP2 = NOP;
}

void dec_3f_11(void)
{
  rs3 = (inst_reg2>>11)&0x1f;
  rd  = NONE;
  OP  = (inst_reg2&2)? MULU : MUL;
  OP2 = NOP;
}

void dec_3f_12(void)
{
  immd = (((inst_reg2>>2)&0xf)<<5)|rs1;
  rs1 = IMMD;
  rs3 = (inst_reg2>>11)&0x1f;
  rd  = NONE;
  if(inst_reg2&2){
    immd = immd & 0x1ff;
    OP  = MULU;
  }
  else{
    immd = (immd & 0x100)? 0xfffffe00|immd : immd &0x1ff;
    OP  = MUL;
  }
  OP2 = NOP;
}

void dec_3f_13(void)
{
  dec_3f_12();
}

void dec_3f_14(void)
{
  rs3 = (inst_reg2>>11)&0x1f;
  rd  = NONE;
  OP  = (inst_reg2&2)? DIVHU : DIVH;
  OP2 = NOP;
}

void dec_3f_15(void)
{
  rs1 = NONE;
  rs2 = NONE;
  rd  = NONE;
  OP  = NOP;
  OP2 = EXP;
}

void dec_3f_16(void)
{
  rs3 = (inst_reg2>>11)&0x1f;
  rd  = NONE;
  OP  = (inst_reg2&2)? DIVU : DIV;
  OP2 = NOP;
}

void dec_3f_17(void)
{
  rs3 = (inst_reg2>>11)&0x1f;
  rd  = NONE;
  OP  = (inst_reg2&2)? DIVQU : DIVQ;
  OP2 = NOP;
}

void dec_3f_18(void)
{
  cond = (inst_reg2>>1)&0xf;
  rd   = (inst_reg2>>11)&0x1f;
  immd = (rs1&0x10)? 0xffffffe0|rs1 : rs1&0x1f;
  rs1 = IMMD;
  OP  = CMOV;
  OP2 = NOP;
}

void dec_3f_19(void)
{
  cond = (inst_reg2>>1)&0xf;
  rd   = (inst_reg2>>11)&0x1f;
  OP  = CMOV;
  OP2 = NOP;
}

void dec_3f_1a(void)
{
  rd  = (inst_reg2>>11)&0x1f;
  switch(inst_reg2&0xf){
  case 0:
    OP  = BSW;
    break;
  case 2:
    OP  = BSH;
    break;
  case 4:
    OP  = HSW;
    break;
  case 6:
    OP  = HSH;
    break;
  default:
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
    break;
  }
}

void dec_3f_1b(void)
{
  rd  = (inst_reg2>>11)&0x1f;
  switch(inst_reg2&0xf){
  case 0:
    OP  = SCH0R;
    break;
  case 2:
    OP  = SCH1R;
    break;
  case 4:
    OP  = SCH0L;
    break;
  case 6:
    OP  = SCH1L;
    break;
  default:
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
    break;
  }
}

void dec_3f_1c(void)
{
  rd  = (inst_reg2>>11)&0x1f;
  cond = (inst_reg2>>1)&0xf;
  if(cond!=0xb){
    OP  = SBF;
  }
  else {
    OP = SATSUB;
  }
  OP2  = NOP;
}

void dec_3f_1d(void)
{
  rd  = (inst_reg2>>11)&0x1f;
  cond = (inst_reg2>>1)&0xf;
  if(cond!=0xb){
    OP  = ADF;
  }
  else {
    OP = SATADD;
  }
  OP2  = NOP;
}

void dec_3f_1e(void)
{
  rs3 = (inst_reg2>>11)&0x1f;
  rs4 = (inst_reg2>> 0)&0x1f;
  rd  = NONE;
  OP  = MAC;
  OP2 = NOP;
}

void dec_3f_1f(void)
{
  rs3 = (inst_reg2>>11)&0x1e;
  rs4 = (inst_reg2>> 0)&0x1e;
  rd  = NONE;
  OP  = MACU;
  OP2 = NOP;
}

void dec_3f(void)
{
  if(inst_reg2&1){/* LD.HU */
    immd = inst_reg2&0xfffe;
    immd = (immd & 0x8000)? 0xffff0000|immd : immd&0xffff;
    rs2 = IMMD;
    OP  = EADD;
    OP2 = LD;
    msize = HWORD;
    msex = 0;
    inst_len = 4;
    return;
  }

  switch((inst_reg2>>5)&0x3f){
  case 0x00:
    dec_3f_00();
    break;
  case 0x01:
    dec_3f_01();
    break;
  case 0x02:
    dec_3f_02();
    break;
  case 0x03:
    dec_3f_03();
    break;
  case 0x04:
    dec_3f_04();
    break;
  case 0x05:
    dec_3f_05();
    break;
  case 0x06:
    dec_3f_06();
    break;
  case 0x07:
    dec_3f_07();
    break;
  case 0x08:
    dec_3f_08();
    break;
  case 0x09:
    dec_3f_09();
    break;
  case 0x0a:
    dec_3f_0a();
    break;
  case 0x0b:
    dec_3f_0b();
    break;
  case 0x0c:
    dec_3f_0c();
    break;
  case 0x0d:
    dec_3f_0d();
    break;
  case 0x0e:
    dec_3f_0e();
    break;
  case 0x0f:
    dec_3f_0f();
    break;
  case 0x10:
    dec_3f_10();
    break;
  case 0x11:
    dec_3f_11();
    break;
  case 0x12:
    dec_3f_12();
    break;
  case 0x13:
    dec_3f_13();
    break;
  case 0x14:
    dec_3f_14();
    break;
  case 0x15:
    dec_3f_15();
    break;
  case 0x16:
    dec_3f_16();
    break;
  case 0x17:
    dec_3f_17();
    break;
  case 0x18:
    dec_3f_18();
    break;
  case 0x19:
    dec_3f_19();
    break;
  case 0x1a:
    dec_3f_1a();
    break;
  case 0x1b:
    dec_3f_1b();
    break;
  case 0x1c:
    dec_3f_1c();
    break;
  case 0x1d:
    dec_3f_1d();
    break;
  case 0x1e:
    dec_3f_1e();
    break;
  case 0x1f:
    dec_3f_1f();
    break;
  default:
    rs1 = NONE;
    rs2 = NONE;
    rd  = NONE;
    OP  = NOP;
    OP2 = EXP;
  }
  inst_len = 4;
}

void decode(void)
{
  opcode = (inst_reg>>5)&0x3f;
  rs1 = (inst_reg>> 0)&0x1f;
  rs2 = (inst_reg>>11)&0x1f;
  rd  = rs2;

  inst_len = 2;
  
  OP  = NOP;
  OP2 = NOP;
	
  switch(opcode){
  case 0x00:
    dec_00();
    break;
  case 0x01:
    dec_01();
    break;
  case 0x02:
    dec_02();
    break;
  case 0x03:
    dec_03();
    break;
  case 0x04:
    dec_04();
    break;
  case 0x05:
    dec_05();
    break;
  case 0x06:
    dec_06();
    break;
  case 0x07:
    dec_07();
    break;
  case 0x08:
    dec_08();
    break;
  case 0x09:
    dec_09();
    break;
  case 0x0a:
    dec_0a();
    break;
  case 0x0b:
    dec_0b();
    break;
  case 0x0c:
    dec_0c();
    break;
  case 0x0d:
    dec_0d();
    break;
  case 0x0e:
    dec_0e();
    break;
  case 0x0f:
    dec_0f();
    break;
  case 0x10:
    dec_10();
    break;
  case 0x11:
    dec_11();
    break;
  case 0x12:
    dec_12();
    break;
  case 0x13:
    dec_13();
    break;
  case 0x14:
    dec_14();
    break;
  case 0x15:
    dec_15();
    break;
  case 0x16:
    dec_16();
    break;
  case 0x17:
    dec_17();
    break;
  case 0x18:
    dec_18();
    break;
  case 0x19:
    dec_19();
    break;
  case 0x1a:
    dec_1a();
    break;
  case 0x1b:
    dec_1b();
    break;
  case 0x1c:
    dec_1c();
    break;
  case 0x1d:
    dec_1d();
    break;
  case 0x1e:
    dec_1e();
    break;
  case 0x1f:
    dec_1f();
    break;
  case 0x20:
    dec_20();
    break;
  case 0x21:
    dec_21();
    break;
  case 0x22:
    dec_22();
    break;
  case 0x23:
    dec_23();
    break;
  case 0x24:
    dec_24();
    break;
  case 0x25:
    dec_25();
    break;
  case 0x26:
    dec_26();
    break;
  case 0x27:
    dec_27();
    break;
  case 0x28:
    dec_28();
    break;
  case 0x29:
    dec_29();
    break;
  case 0x2a:
    dec_2a();
    break;
  case 0x2b:
    dec_2b();
    break;
  case 0x2c:
    dec_2c();
    break;
  case 0x2d:
    dec_2d();
    break;
  case 0x2e:
    dec_2e();
    break;
  case 0x2f:
    dec_2f();
    break;
  case 0x30:
    dec_30();
    break;
  case 0x31:
    dec_31();
    break;
  case 0x32:
    dec_32();
    break;
  case 0x33:
    dec_33();
    break;
  case 0x34:
    dec_34();
    break;
  case 0x35:
    dec_35();
    break;
  case 0x36:
    dec_36();
    break;
  case 0x37:
    dec_37();
    break;
  case 0x38:
    dec_38();
    break;
  case 0x39:
    dec_39();
    break;
  case 0x3a:
    dec_3a();
    break;
  case 0x3b:
    dec_3b();
    break;
  case 0x3c:
    dec_3c();
    break;
  case 0x3d:
    dec_3d();
    break;
  case 0x3e:
    dec_3e();
    break;
  case 0x3f:
    dec_3f();
    break;
  }
}
		
		
