#define EADD	0
#define MOV	1
#define NOT	2
#define ADD	3
#define SUB	4
#define MUL	5
#define MULU	6
#define MULH	7
#define MAC	8
#define MACU	9
#define DIV	10
#define DIVU	11
#define DIVH	12
#define DIVHU	13
#define DIVQ    45
#define DIVQU   46
#define AND	14
#define OR	15
#define XOR	16
#define SASF	17
#define SLL	18
#define SRA	19
#define SRL	20
#define BSH	21
#define BSW	22
#define HSH	23
#define HSW	24
#define CALLT	25
#define SWITCH	26
#define CMOV	27
#define CAXI	28
#define LDSR	29
#define STSR	30
#define PREPARE	31
#define DISPOSE	32
#define SATADD	33
#define SATSUB	34
#define ADF	35
#define SBF	36
#define SETF	37
#define SCH0L	38
#define SCH0R	39
#define SCH1L	40
#define SCH1R	41
#define SEX	42
#define ZEX	43
#define NOP	44

#define SET1	50
#define CLR1	51
#define NOT1	52
#define TST1	53
#define CTRET	54
#define EIRET	55
#define FERET	56
#define RETI	57
#define JARL	58
#define JCC	59
#define JMP	60
#define JPR	61
#define LD	62
#define ST	63
#define DI	64
#define EI	65
#define HALT	66
#define SYSCALL	67
#define TRAP	68
#define RIE	69
#define EXP	70

#define IMMD   100
#define CUR_PC 101
#define NXT_PC 102
#define NONE   103

#define WORD  0
#define HWORD 1
#define BYTE  2

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);



#define ADC  100
#define BRK  103
#define CPS  104
#define DMB  105
#define DSB  106
#define FLAG  107
#define ISB  108
#define LDM  113
#define MRS  115
#define MSR  116
#define NAND  118
#define NSUB  122
#define POP  124
#define PUSH  125
#define REV  126
#define ROR  127
#define SBC  128
#define SEV  129
#define STM  135
#define SVC  137
#define UDF  138
#define WFE  139
#define WFI  140
#define YIELD  142
#define JAL 143

#define NEXT_PC  201
#define NEXT2_PC 202
#define NEXT3_PC 203
