#include <stdio.h>
#include <string.h>
#include "define.h"

static int PC=0;
static int disp;

static char *cond[]={
"bv",
"bc",
"bz",
"bnh",
"bn",
"br",
"blt",
"ble",
"bnv",
"bnc",
"bnz",
"bh",
"bp",
"bsa",
"bge",
"bgt",
};

static char *cond2[]={
"bv",
"bc",
"bz",
"bnh",
"bn",
"bt",
"blt",
"ble",
"bnv",
"bnc",
"bnz",
"bh",
"bp",
"bsa",
"bge",
"bgt",
};

static char _mem[8];
static int  byte_ptr;

static void dis_fetch(void)
{
  _mem[0]=get_mem(PC,BYTE);
  _mem[1]=get_mem(PC+1,BYTE);
  _mem[2]=get_mem(PC+2,BYTE);
  _mem[3]=get_mem(PC+3,BYTE);
  _mem[4]=get_mem(PC+4,BYTE);
  _mem[5]=get_mem(PC+5,BYTE);
  _mem[6]=get_mem(PC+6,BYTE);
  _mem[7]=get_mem(PC+7,BYTE);
  byte_ptr = 0;
}

static int get_next_byte(void)
{
  return _mem[byte_ptr++];
}

void  dis63(int r,int R,int r2,int c2,int R2,int d0)
{
  switch(c2){
  case 0:
    if(R&0x10){
      printf("\trie\n");
    }
    else{
      printf("\tsetf\t%s,r%d\n",cond2[R&0xf]+1,r);
    }
    break;
  case 1:
    printf("\tldsr\tr%d,%d\n",R,r);
    break;
  case 2:
    printf("\tstsr\t%d,r%d\n",R,r);
    break;
  case 3:
    printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    break;
  case 4:
    if(R2==0){
      printf("\tshr\tr%d,r%d\n",R,r);
    }
    else if (R2==2){
      printf("\tshr\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 5:
    if(R2==0){
      printf("\tsar\tr%d,r%d\n",R,r);
    }
    else if (R2==2){
      printf("\tsar\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 6:
    if(R2==0){
      printf("\tshl\tr%d,r%d\n",R,r);
    }
    else if (R2==2){
      printf("\tshl\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 7:
    if(r2==0){
      switch(R2){
      case 0:
	printf("\tset1\tr%d,[r%d]\n",r,R);
	break;
      case 2:
	printf("\tnot1\tr%d,[r%d]\n",r,R);
	break;
      case 4:
	printf("\tclr1\tr%d,[r%d]\n",r,R);
	break;
      case 6:
	printf("\ttst1\tr%d,[r%d]\n",r,R);
	break;
      default:
	printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
      }
    }
    else if(R2==14){
      printf("\tcaxi\[tr%d],r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 8:
    printf("\ttrap\t0x%x\n",R);
    break;
  case 9:
    printf("\thalt\n");
    break;
  case 10:
    switch(R2){
    case 0:
      printf("\treti\n");
      break;
    case 4:
      printf("\tctret\n");
      break;
    case 8:
      printf("\teiret\n");
      break;
    default:
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 11:
    if(R2==0){
      if(r==0){
	printf("\tdi\n");
      }
      else if(r==16){
	printf("\tei\n");
      }
      else if(r==26){
	printf("\tsyscall\t0x%x\n",(r2<<5)|R);
      }
      else{
	printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
      }
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 16:
    if(r2==0){
      printf("\tsasf\t%s,r%d\n",cond[R&0xf]+1,r);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 17:
    if(R2==0){
      printf("\tmul\tr%d,r%d,r%d\n",R,r,r2);
    }
    else if(R2==2){
      printf("\tmulu\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 18:
  case 19:
    if((R2&3)==0){
      printf("\tmul\t0x%x,r%d,r%d\n",(((d0>>2)&0xf)<<5)|R,r,r2);
    }
    else if((R2&3)==2){
      printf("\tmulu\t0x%x,r%d,r%d\n",(((d0>>2)&0xf)<<5)|R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 20:
    if(R2==0){
    }
    else if(R2==2){
      printf("\tdivhu\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 22:
    if(R2==0){
      printf("\tdiv\tr%d,r%d,r%d\n",R,r,r2);
    }
    else if(R2==2){
      printf("\tdivu\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 23:
    if(R2==28){
      printf("\tdivq\tr%d,r%d,r%d\n",R,r,r2);
    }
    else if(R2==30){
      printf("\tdivqu\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 24:
    printf("\tcmov\t%s,0x%x,r%d,r%d\n",cond2[(R2>>1)&0xf]+1,R,r,r2);
    break;
  case 25:
    printf("\tcmov\t%s,r%d,r%d,r%d\n",cond2[(R2>>1)&0xf]+1,R,r,r2);
    break;
  case 26:
    if(R2==0){
      printf("\tbsw\tr%d,r%d\n",r,r2);
    }
    else if(R2==2){
      printf("\tbsh\tr%d,r%d\n",r,r2);
    }
    else if(R2==4){
      printf("\thsw\tr%d,r%d\n",r,r2);
    }
    else if(R2==6){
      printf("\thsh\tr%d,r%d\n",r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 27:
    if(R2==0){
      printf("\tsch0r\tr%d,r%d\n",r,r2);
    }
    else if(R2==2){
      printf("\tsch1r\tr%d,r%d\n",r,r2);
    }
    else if(R2==4){
      printf("\tsch0l\tr%d,r%d\n",r,r2);
    }
    else if(R2==6){
      printf("\tsch1l\tr%d,r%d\n",r,r2);
    }
    else{
      printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
    }
    break;
  case 28:
    if(R2==26){
      printf("\tsatsub\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\tsbf\t%s,r%d,r%d.r%d\n",cond[(R2>>1)&0xf]+1,R,r,r2);
    }
    break;
  case 29:
    if(R2==26){
      printf("\tsatadd\tr%d,r%d,r%d\n",R,r,r2);
    }
    else{
      printf("\tabf\t%s,r%d,r%d.r%d\n",cond[(R2>>1)&0xf]+1,R,r,r2);
    }
    break;
  case 30:
    printf("\tmac\tr%d,r%d,r%d,r%d\n",R,r,r2&0x1e,R2&0x1e);
    break;
  case 31:
    printf("\tmacu\tr%d,r%d,r%d,r%d\n",R,r,r2&0x1e,R2&0x1e);
    break;
  default:
    printf("\t.word\t0x%04x%04x\n",d0,(r<<11)|(63<<5)|R);
  }
}

static char RL[100];
static char *rlist(int d)
{
  int e=0;
  RL[0]=0;
  if(d&(1<<7)){
    strcat(RL,"r20");
    e=1;
  }
  if(d&(1<<6)){
    if(e)
      strcat(RL,",r21");
    else
      strcat(RL,"r21");
    e=1;
  }
  if(d&(1<<5)){
    if(e)
      strcat(RL,",r22");
    else
      strcat(RL,"r22");
    e=1;
  }
  if(d&(1<<4)){
    if(e)
      strcat(RL,",r23");
    else
      strcat(RL,"r23");
    e=1;
  }
  if(d&(1<<11)){
    if(e)
      strcat(RL,",r24");
    else
      strcat(RL,"r24");
    e=1;
  }
  if(d&(1<<10)){
    if(e)
      strcat(RL,",r25");
    else
      strcat(RL,"r25");
    e=1;
  }
  if(d&(1<<9)){
    if(e)
      strcat(RL,",r26");
    else
      strcat(RL,"r26");
    e=1;
  }
  if(d&(1<<8)){
    if(e)
      strcat(RL,",r27");
    else
      strcat(RL,"r27");
    e=1;
  }
  if(d&(1<<3)){
    if(e)
      strcat(RL,",r28");
    else
      strcat(RL,"r28");
    e=1;
  }
  if(d&(1<<2)){
    if(e)
      strcat(RL,",r29");
    else
      strcat(RL,"r29");
    e=1;
  }
  if(d&(1<<0)){
    if(e)
      strcat(RL,",r30");
    else
      strcat(RL,"r30");
    e=1;
  }
  if(d&(1<<1)){
    if(e)
      strcat(RL,",r31");
    else
      strcat(RL,"r31");
    e=1;
  }
  return RL;
}

void dis(void)
{
  int code;
  int code1;
  int code2;
  int r,c,R;
  int r2,c2,R2;
  int d3,d2,d1,d0;
  code1 = get_next_byte() & 0xff;
  code2 = get_next_byte() & 0xff;
  code = (code2<<8)|code1;
  PC+=2;
  if(code==0){
    printf("\tnop\n");
    return;
  }
  if(code==0xffff){
    printf("\t.hword\t0xffff\n");
    return;
  }
  if(code==0x1d){
    printf("\tsynce\n");
    return;
  }
  if(code==0x1e){
    printf("\tsyncm\n");
    return;
  }
  if(code==0x1f){
    printf("\tsyncp\n");
    return;
  }
  r=(code>>11)&0x1f;
  c=(code>>5)&0x3f;
  R=(code&0x1f);
  switch(c){
  case 0:
    printf("\tmov\tr%d,r%d\n",R,r);
    return;
  case 1:
    printf("\tnot\tr%d,r%d\n",R,r);
    return;
  case 2:
    if((r==0)&&(R==0)){
      printf("\trie\n");
      return;
    }
    if((r==0)&&(R!=0)){
      printf("\tswitch\tr%d\n",R);
      return;
    }
    if((r!=0)&&(R==0)){
      printf("\tfetrap\t%d\n",r);
      return;
    }
    if((r!=0)&&(R!=0)){
      printf("\tdivh\tr%d,r%d\n",R,r);
      return;
    }
  case 3:
    if(r==0){
      printf("\tjmp\t[r%d]\n",R);
      return;
    }
    if(0x10&R){
      printf("\tsld.hu\t%d[ep],r%d\n",(R&0xf)<<1,r);
      return;
    }
    else{
      printf("\tsld.bu\t%d[ep],r%d\n",R&0xf,r);
      return;
    }
  case 4:
    if(r==0){
      printf("\tzxb\tr%d\n",R);
      return;
    }
    printf("\tsatsubr\tr%d,r%d\n",R,r);
    return;
  case 5:
    if(r==0){
      printf("\tsxb\tr%d\n",R);
      return;
    }
    printf("\tsatsub\tr%d,r%d\n",R,r);
    return;
  case 6:
    if(r==0){
      printf("\tzxh\tr%d\n",R);
      return;
    }
    printf("\tsatadd\tr%d,r%d\n",R,r);
    return;
  case 7:
    if(r==0){
      printf("\tsxh\tr%d\n",R);
      return;
    }
    printf("\tmulh\tr%d,r%d\n",R,r);
    return;
  case 8:
    printf("\tor\tr%d,r%d\n",R,r);
    return;
  case 9:
    printf("\txor\tr%d,r%d\n",R,r);
    return;
  case 10:
    printf("\tand\tr%d,r%d\n",R,r);
    return;
  case 11:
    printf("\ttst\tr%d,r%d\n",R,r);
    return;
  case 12:
    printf("\tsubr\tr%d,r%d\n",R,r);
    return;
  case 13:
    printf("\tsub\tr%d,r%d\n",R,r);
    return;
  case 14:
    printf("\tadd\tr%d,r%d\n",R,r);
    return;
  case 15:
    printf("\tcmp\tr%d,r%d\n",R,r);
    return;
  case 16:
    if(r!=0){
      if(R&(1<<4))
	disp = R | 0xffffffe0;
      else
	disp = R & 0xf;
      if(disp<0)
	printf("\tmov\t-0x%x,r%d\n",-disp,r);
      else
	printf("\tmov\t0x%x,r%d\n",disp,r);
      return;
    }
    printf("\tcallt\t0x%x\n",R);
    return;
  case 17:
    if(r!=0){
      if(R&(1<<4))
	disp = R | 0xffffffe0;
      else
	disp = R & 0xf;
      if(disp<0)
	printf("\tsatadd\t-0x%x,r%d\n",-disp,r);
      else
	printf("\tsatadd\t0x%x,r%d\n",disp,r);
      return;
    }
    printf("\tcallt\t0x%x\n",R|0x20);
    return;
  case 18:
    if(R&(1<<4))
      disp = R | 0xffffffe0;
    else
      disp = R & 0xf;
    if(disp<0)
      printf("\tadd\t-0x%x,r%d\n",-disp,r);
    else
      printf("\tadd\t0x%x,r%d\n",disp,r);
    return;
  case 19:
    if(R&(1<<4))
      disp = R | 0xffffffe0;
    else
      disp = R & 0xf;
    if(disp<0)
      printf("\tcmp\t-0x%x,r%d\n",-disp,r);
    else
      printf("\tcmp\t0x%x,r%d\n",disp,r);
    return;
  case 20:
    printf("\tshr\t0x%x,r%d\n",R,r);
    return;
  case 21:
    printf("\tsar\t0x%x,r%d\n",R,r);
    return;
  case 22:
    printf("\tshl\t0x%x,r%d\n",R,r);
    return;
  case 23:
    if(r!=0){
      printf("\tmulh\t0x%x,r%d\n",R,r);
      return;
    }
    d0=get_next_byte()&0xff;
    d1=get_next_byte()&0xff;
    d2=get_next_byte()&0xff;
    d3=get_next_byte()&0xff;
    PC+=4;
    if(R==0){
      printf("\tjr\tL%08x\n",((d3<<24)|(d2<<16)|(d1<<8)|d0)+(PC-8));
      return;
    }
    printf("\tjarl\tL%08x,r%d\n",((d3<<24)|(d2<<16)|(d1<<8)|d0)+(PC-8),R);
    return;
  case 24:
  case 25:
  case 26:
  case 27:
    printf("\tsld.b\t0x%x[ep],r%d\n",((c&3)<<5)|R,r);
    return;
  case 28:
  case 29:
  case 30:
  case 31:
    printf("\tsst.b\tr%d,0x%x[ep]\n",r,((c&3)<<5)|R);
    return;
  case 32:
  case 33:
  case 34:
  case 35:
    printf("\tsld.h\t0x%x[ep],r%d\n",(((c&3)<<5)|R)<<1,r);
    return;
  case 36:
  case 37:
  case 38:
  case 39:
    printf("\tsst.h\tr%d,0x%x[ep]\n",r,(((c&3)<<5)|R)<<1);
    return;
  case 40:
  case 41:
  case 42:
  case 43:
    if((R&1)==0){
      printf("\tsld.w\t0x%x[ep],r%d\n",((((c&3)<<5)|R)>>1)<<2,r);
      return;
    }
    printf("\tsst.w\tr%d,0x%x[ep]\n",r,((((c&3)<<5)|R)>>1)<<2);
    return;
  case 44:
  case 45:
  case 46:
  case 47:
    d0 = (r<<3)|((code1>>4)&7);
    d0 = d0+d0;
    if(d0&(1<<8))
      d0|=0xfffffe00;
    printf("\t%s\tL%08x\n",cond[R&0xf],d0+(PC-2));
    return;
  case 48:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    d0 = d0 | (d1<<8);
    if(d0&0x8000)
      d0 |= 0xffff0000;
    else
      d0 &= 0x7fff;
    if(d0<0)
      printf("\taddi\t-0x%04x,r%d,r%d\n",-d0,R,r);
    else
      printf("\taddi\t0x%04x,r%d,r%d\n",d0,R,r);
    return;
  case 49:
    if(r==0){
      d0 = get_next_byte()&0xff;
      d1 = get_next_byte()&0xff;
      d2 = get_next_byte()&0xff;
      d3 = get_next_byte()&0xff;
      PC+=4;
      printf("\tmov\t0x%08x,r%d\n",(d3<<24)|(d2<<16)|(d1<<8)|d0,R);
      return;
    }
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    d0 = d0 | (d1<<8);
    if(d0&0x8000)
      d0 |= 0xffff0000;
    else
      d0 &= 0x7fff;
    if(d0<0)
      printf("\tmovea\t-0x%04x,r%d,r%d\n",-d0,R,r);
    else
      printf("\tmovea\t0x%04x,r%d,r%d\n",d0,R,r);
    return;
  case 50:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    if(r!=0){
      printf("\tmovhi\t0x%04x,r%d,r%d\n",(d1<<8)|d0,R,r);
      return;
    }
    d2 = (R>>1)|((c&1)<<4);
    d3 = ((d1<<8)|d0)>>5;
    d3 = (d3<<1)|(R&1);
    if((d0&0x1f)==0){
      printf("\tdispose\t0x%x,{%s}\n",d2,rlist(d3));
    }
    else{
      printf("\tdispose\t0x%x,{%s},r%d\n",d2,rlist(d3),d0&0x1f);
    }
    return;
  case 51:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    if(r!=0){
      disp = (d1<<8)|d0;
      if(disp&0x8000)
	disp |= 0xffff0000;
      else
	disp &= 0xffff;
      if(disp<0)
        printf("\tsatsubi\t-0x%04x,r%d,r%d\n",-disp,R,r);
      else
        printf("\tsatsubi\t0x%04x,r%d,r%d\n",disp,R,r);
      return;
    }
    d2 = (R>>1)|((c&1)<<4);
    d3 = ((d1<<8)|d0)>>5;
    d3 = (d3<<1)|(R&1);
    if((d0&0x1f)==0){
      printf("\tdispose\t0x%x,{%s}\n",d2,rlist(d3));
    }
    else{
      printf("\tdispose\t0x%x,{%s},r%d\n",d2,rlist(d3),d0&0x1f);
    }
    return;
  case 52:      
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    printf("\tori\t0x%04x,r%d,r%d\n",(d1<<8)|d0,R,r);
    return;
  case 53:      
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    printf("\txori\t0x%04x,r%d,r%d\n",(d1<<8)|d0,R,r);
    return;
  case 54:      
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    printf("\tandi\t0x%04x,r%d,r%d\n",(d1<<8)|d0,R,r);
    return;
  case 55:      
    if(r!=0){
      d0 = get_next_byte()&0xff;
      d1 = get_next_byte()&0xff;
      PC+=2;
      printf("\tmulhi\t0x%04x,r%d,r%d\n",(d1<<8)|d0,R,r);
      return;
    }
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    d2 = get_next_byte()&0xff;
    d3 = get_next_byte()&0xff;
    PC+=4;
    printf("\tjmp\t0x%08x[r%d]\n",(d3<<24)|(d2<<16)|(d1<<8)|d0,R);
    return;
  case 56:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    disp = (d1<<8)|d0;
    if(disp & (1<<15))
      disp |= 0xffff0000;
    else
      disp &= 0x7fff;
    if(disp<0)
      printf("\tld.b\t-0x%04x[r%d],r%d\n",-disp,R,r);
    else
      printf("\tld.b\t0x%04x[r%d],r%d\n",disp,R,r);
    return;
  case 57:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    disp = ((d1<<8)|d0)&0xfffffffe;
    if(disp&(1<<15))
      disp |= 0xffff0000;
    else
      disp &= 0x7fff;
    if((d0&1)==0){
      if(disp<0)
	printf("\tld.h\t-0x%04x[r%d],r%d\n",-disp,R,r);
      else
	printf("\tld.h\t0x%04x[r%d],r%d\n",disp,R,r);
      return;
    }
    if(disp<0)
      printf("\tld.w\t-0x%04x[r%d],r%d\n",-disp,R,r);
    else
      printf("\tld.w\t0x%04x[r%d],r%d\n",disp,R,r);
    return;
  case 58:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    disp = (d1<<8)|d0;
    if(disp &(1<<15))
      disp |= 0xffff0000;
    else
      disp &= 0x7fff;
    if(disp<0)
      printf("\tst.b\tr%d,-0x%04x[r%d]\n",r,-disp,R);
    else
      printf("\tst.b\tr%d,0x%04x[r%d]\n",r,disp,R);
    return;
  case 59:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    disp = ((d1<<8)|d0)&0xfffffffe;
    if(disp &(1<<15))
      disp |= 0xffff0000;
    else
      disp &= 0x7fff;
    if((d0&1)==0){
      if(disp<0)
	printf("\tst.h\tr%d,-0x%04x[r%d]\n",r,-disp,R);
      else
	printf("\tst.h\tr%d,0x%04x[r%d]\n",r,disp,R);
      return;
    }
    if(disp<0)
      printf("\tst.w\tr%d,-0x%04x[r%d]\n",r,-disp,R);
    else
      printf("\tst.w\tr%d,0x%04x[r%d]\n",r,disp,R);
    return;
  case 60:
  case 61:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    if(r==0){
      if(d0&1){
	if((d0&0xe)==0){/* prepare */
	  d2 = (code>>1)&0x1f;
	  d3 = ((d1<<8)|d0)>>5;
	  d3 = (d3<<1)|(R&1);
	  printf("\tprepare\t{%s},0x%x\n",rlist(d3),d2);
	}
	if((d0&0xe)==2){/* prepare */
	  d2 = (code>>1)&0x1f;
	  d3 = ((d1<<8)|d0)>>5;
	  d3 = (d3<<1)|(R&1);
	  switch((d0>>3)&0x3){
	  case 0:
	    printf("\tprepare\t{%s},0x%x,sp\n",rlist(d3),d2);
	    break;
	  case 1:
	    printf("\tprepare\t{%s},0x%x,",rlist(d3),d2);
	    d2 = get_next_byte()&0xff;
	    d3 = get_next_byte()&0xff;
	    PC+=2;
	    printf("0x%04x\n",(d3<<8)|d2);
	    break;
	  case 2:
	    printf("\tprepare\t{%s},0x%x,",rlist(d3),d2);
	    d2 = get_next_byte()&0xff;
	    d3 = get_next_byte()&0xff;
	    PC+=2;
	    printf("0x%04x0000\n",(d3<<8)|d2);
	    break;
	  case 3:
	    printf("\tprepare\t{%s},0x%x,",rlist(d3),d2);
	    d2 = get_next_byte()&0xff;
	    d3 = get_next_byte()&0xff;
	    PC+=2;
	    printf("0x%04x",(d3<<8)|d2);
	    d2 = get_next_byte()&0xff;
	    d3 = get_next_byte()&0xff;
	    PC+=2;
	    printf("%04x\n",(d3<<8)|d2);
	    break;
	  }
	}
	if((d0&0xe)==4){/* ld.b/st.b/ld.bu */
	  d2 = get_next_byte()&0xff;
	  d3 = get_next_byte()&0xff;
	  PC+=2;
	  disp = (((d3<<8)|d2)<<7)|(((d1<<8)|d0)>>4)&0x7f;
	  if(disp & (1<<22))
	    disp |= 0xff800000;
	  else
	    disp &= 0x007fffff;
	  if(c&1){
	    if(disp<0)
	      printf("\tld.bu\t-0x%x[r%d],r%d\n",-disp,R,(((d1<<8)|d0)>>11)&0x1f);
	    else
	      printf("\tld.bu\t0x%x[r%d],r%d\n",disp,R,(((d1<<8)|d0)>>11)&0x1f);
	  }
	  else{
	    if(disp<0)
	      printf("\tld.b\t-0x%x[r%d],r%d\n",-disp,R,(((d1<<8)|d0)>>11)&0x1f);
	    else
	      printf("\tld.b\t0x%x[r%d],r%d\n",disp,R,(((d1<<8)|d0)>>11)&0x1f);
	  }
	}
	if((d0&0xe)==6){/* ld.h/st.h/ld.hu */
	  d2 = get_next_byte()&0xff;
	  d3 = get_next_byte()&0xff;
	  PC+=2;
	  disp = ((((d3<<8)|d2)<<6)|(((d1<<8)|d0)>>5)&0x3f)<<1;
	  if(disp & (1<<22))
	    disp |= 0xff800000;
	  else
	    disp &= 0x007fffff;
	  if(c&1){
	    if(disp<0)
	      printf("\tld.hu\t-0x%x[r%d],r%d\n",-disp,R,(((d1<<8)|d0)>>11)&0x1f);
	    else
	      printf("\tld.hu\t0x%x[r%d],r%d\n",disp,R,(((d1<<8)|d0)>>11)&0x1f);
	  }
	  else{
	    if(disp<0)
	      printf("\tld.h\t-0x%x[r%d],r%d\n",-disp,R,(((d1<<8)|d0)>>11)&0x1f);
	    else
	      printf("\tld.h\t0x%x[r%d],r%d\n",disp,R,(((d1<<8)|d0)>>11)&0x1f);
	  }
	}
	if((d0&0xe)==8){/* ld.w/st.w/st.h */
	  d2 = get_next_byte()&0xff;
	  d3 = get_next_byte()&0xff;
	  PC+=2;
	  disp = ((((d3<<8)|d2)<<6)|(((d1<<8)|d0)>>5)&0x3f)<<1;
	  if(disp & (1<<22))
	    disp |= 0xff800000;
	  else
	    disp &= 0x007fffff;
	  if(disp<0)
	    printf("\tld.w\t-0x%x[r%d],r%d\n",-disp,R,(((d1<<8)|d0)>>11)&0x1f);
	  else
	    printf("\tld.w\t0x%x[r%d],r%d\n",disp,R,(((d1<<8)|d0)>>11)&0x1f);
	}
	if((d0&0xe)==12){/* ld.b/st.b/ld.bu */
	  d2 = get_next_byte()&0xff;
	  d3 = get_next_byte()&0xff;
	  PC+=2;
	  if(c&1){
	    disp = ((((d3<<8)|d2)<<6)|(((d1<<8)|d0)>>5)&0x3f)<<1;
	    if(disp & (1<<22))
	      disp |= 0xff800000;
	    else
	      disp &= 0x007fffff;
	    if(disp<0)
	      printf("\tst.h\tr%d,-0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,-disp,R);
	    else
	      printf("\tst.h\tr%d,0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,disp,R);
	  }
	  else{
	    disp = ((((d3<<8)|d2)<<7)|(((d1<<8)|d0)>>4)&0x7f)<<0;
	    if(disp & (1<<22))
	      disp |= 0xff800000;
	    else
	      disp &= 0x007fffff;
	    if(disp<0)
	      printf("\tst.b\tr%d,-0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,-disp,R);
	    else
	      printf("\tst.b\tr%d,0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,disp,R);
	  }
	}
	if((d0&0xe)==14){/* ld.w/st.w/st.h */
	  d2 = get_next_byte()&0xff;
	  d3 = get_next_byte()&0xff;
	  PC+=2;
	  disp = ((((d3<<8)|d2)<<6)|(((d1<<8)|d0)>>5)&0x3f)<<1;
	  if(disp & (1<<22))
	    disp |= 0xff800000;
	  else
	    disp &= 0x007fffff;
	  if(disp<0)
	    printf("\tst.w\tr%d,-0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,-disp,R);
	  else
	    printf("\tst.w\tr%d,0x%x[r%d]\n",(((d1<<8)|d0)>>11)&0x1f,disp,R);
	}
      }
      else{/* jrl */
	d2=((code1&0x3f)<<16)|(d1<<8)|d0;
	if(d2&(1<<21))
	  d2 |= 0xffc00000;
	printf("\tjr\tL%08x\n",(d2)+(PC-4));
      }
    }
    else {
      if(d0&1){ /* ld.bu */
	d2=(((d1<<8)|d0)&0xfffe)|(c&1);
	if(d2&(1<<15))
	  d2 |= 0xffff0000;
	else
	  d2 &= 0x7fff;
	if(d2<0)
	  printf("\tld.bu\t-0x%0x[r%d],r%d\n",-d2,R,r);
	else
	  printf("\tld.bu\t0x%0x[r%d],r%d\n",d2,R,r);
      }
      else{ /* jarl */
	d2=((code1&0x3f)<<16)|(d1<<8)|d0;
	if(d2&(1<<21))
	  d2 |= 0xffc00000;
	printf("\tjarl\tL%08x,r%d\n",d2+PC-4,r);
      }
    }
    return;
  case 62:
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    d0 = (d1<<8)|d0;
    if(d0&(1<<15))
      d0 |= 0xffff0000;
    else
      d0 &= 0x7fff;
    switch((r>>3)&0x3){
    case 0:
      if(d0<0)
	printf("\tset1\t%d,-0x%x[r%d]\n",r&0x7,-d0,R);
      else
	printf("\tset1\t%d,0x%x[r%d]\n",r&0x7,d0,R);
      break;
    case 1:
      if(d0<0)
	printf("\tnot1\t%d,-0x%x[r%d]\n",r&0x7,-d0,R);
      else
	printf("\tnot1\t%d,0x%x[r%d]\n",r&0x7,d0,R);
      break;
    case 2:
      if(d0<0)
	printf("\tclr1\t%d,-0x%x[r%d]\n",r&0x7,-d0,R);
      else
	printf("\tclr1\t%d,0x%x[r%d]\n",r&0x7,d0,R);
      break;
    case 3:
      if(d0<0)
	printf("\ttst1\t%d,-0x%x[r%d]\n",r&0x7,-d0,R);
      else
	printf("\ttst1\t%d,0x%x[r%d]\n",r&0x7,d0,R);
      break;
    }
    return;
  default: 
    d0 = get_next_byte()&0xff;
    d1 = get_next_byte()&0xff;
    PC+=2;
    disp = (d1<<8)|d0;
    disp &= 0xfffffffe;
    if(disp&(1<<15))
      disp |= 0xffff0000;
    else
      disp &= 0x7fff;
    if((r!=0)&&(d0&1)){
      if(disp<0)
	printf("\tld.hu\t-0x%x[r%d],r%d\n",-disp,R,r);
      else
	printf("\tld.hu\t0x%x[r%d],r%d\n",disp,R,r);
      return;
    }
    d0 = (d1<<8)|d0;
    r2 = (d0>>11)&0x1f;
    c2 = (d0>>5)&0x3f;
    R2 = d0 &0x1f;
    dis63(r,R,r2,c2,R2,d0);
    return;
  }
}

void disasm(unsigned int addr1, unsigned int addr2)
{
  PC = (int)addr1;
  while(1){
    dis_fetch();
    printf("%08x ",PC);
    dis();
    if(((unsigned int)PC)>addr2)
      break;
  }
}

