#include "define.h"


static int tmp_CV_flag=0;
static int tmp_Z_flag=0;
static int tmp_CY_flag=0;
static int tmp_S_flag=0;
static int tmp_SAT_flag=0;


int OV_flag=0;
int Z_flag=0;
int CY_flag=0;
int S_flag=0;
int SAT_flag=0;

int BSEL;
int PSW;
int CTPC;
int CTPSW;
int CTBP;

int PC_BAK;
static int already_npc_set;

extern int rs1;
extern int rs2;
extern int rs3;
extern int rs4;
extern int rd;
extern int immd;
extern int immd2;
extern int OP;
extern int OP2;
extern int cond;
extern int msize;
extern int msex;
extern int rlist;

extern int PC;
extern int inst_len;

static void IADD64(int hi1, int lo1, int hi2, int lo2, int* dh, int* dl)
{
  long long int s1h,s1l,s2h,s2l,d;
  s1h = (long long int)(hi1&0xffffffff);
  s1l = (long long int)(lo1&0xffffffff);
  s2h = (long long int)(hi2&0xffffffff);
  s2l = (long long int)(lo2&0xffffffff);
  s1h = (s1h<<32)|(s1l&0xffffffffLL);
  s2h = (s2h<<32)|(s2l&0xffffffffLL);
  d   = s1h + s2h;
  *dh = (int)((d>>32)&0xffffffffLL);
  *dl = (int)((d>> 0)&0xffffffffLL);
}

static int IADD32(int src1, int src2, int carry, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)(src1 & 0xffffffffLL);
  s2 = (unsigned long long)(src2 & 0xffffffffLL);
  d  = s1 + s2 + carry;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==0)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==1)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}

static int ISUB32(int src1, int src2, int borrow, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)( src1 & 0xffffffffLL);
  s2 = (unsigned long long)(~src2 & 0xffffffffLL);
  d  = s1 + s2 + 1 - borrow;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==1)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==0)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}


static void IMUL32(int src1, int src2, int* hi, int* lo)
{
  long long int s1, s2, d;

  s1 = (src1&0x80000000)? src1|0xffffffff00000000LL : src1&0xffffffffLL;
  s2 = (src2&0x80000000)? src2|0xffffffff00000000LL : src2&0xffffffffLL;
  d = s1 * s2;
  *hi = (int)((d>>32)&0xffffffffLL);
  *lo = (int)((d>> 0)&0xffffffffLL);
}

static void IMULU32(int src1, int src2, int* hi, int* lo)
{
  long long int s1, s2, d;

  s1 = src1&0xffffffffLL;
  s2 = src2&0xffffffffLL;
  d = s1 * s2;
  *hi = (int)((d>>32)&0xffffffffLL);
  *lo = (int)((d>> 0)&0xffffffffLL);
}

static int ISFT32(int src, int sa, int* n, int* z, int* c, int* v)
{
  long long int d;
  int cy;
  int z_val;
  int d_sign;

  sa = sa &0x1f;
  if(sa == 0){
    cy     = 0;
    z_val  = (src==0)? 1 : 0;
    d_sign = (src&0x80000000)? 1: 0;
    d      = src;
  }
  else{
    switch(OP){
    case ROR:
      d = (long long int)src;
      break;
    case SRA:
      if(src&0x80000000)
	d = (long long int)0xffffffffLL;
      else
	d = (long long int)0x00000000LL;
      break;
    case SRL:
    case SLL:
      d = (long long int)0x00000000LL;
      break;
    }
    d = (d<<32)|(src&0xffffffffLL);
    if(OP==SLL){
      cy  = (d & (1LL<<(32-sa))) ? 1: 0;
      d = d << sa;
    }
    else{
      cy  = (d & (1LL<<(sa-1))) ? 1: 0;
      d = d >> sa;
    }
    d = d & 0xffffffffLL;
    z_val  = (d==0LL)? 1 : 0;
    d_sign = (d&0x80000000LL)? 1 : 0;
  }
  *n = d_sign;
  *z = z_val;
  *c = cy;
  *v = 0;
  return (int)d;
}

static int v_dst;
static int v_dst2;
static int v_src1;
static int v_src2;
static int v_src3;

static void do_prepare()
{
  int addr;
  addr = get_reg(3);
  if(rlist&0x080){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(20),WORD);
  }
  if(rlist&0x040){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(21),WORD);
  }
  if(rlist&0x020){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(22),WORD);
  }
  if(rlist&0x010){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(23),WORD);
  }
  if(rlist&0x800){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(24),WORD);
  }
  if(rlist&0x400){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(25),WORD);
  }
  if(rlist&0x200){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(26),WORD);
  }
  if(rlist&0x100){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(27),WORD);
  }
  if(rlist&0x008){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(28),WORD);
  }
  if(rlist&0x004){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(29),WORD);
  }
  if(rlist&0x001){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(30),WORD);
  }
  if(rlist&0x002){
    addr -= 4;
    put_mem(addr&0xfffffffc,get_reg(31),WORD);
  }
  put_reg(3,addr-(immd<<2));
  if(inst_len!=4){
    switch((rs3>>3)&3){
    case 0:
      put_reg(30,get_reg(3));
      break;
    default:
      put_reg(30,immd2);
      break;
    }
  }
}

static void do_dispose()
{
  int addr;
  addr = get_reg(3)+(immd<<2);
  if(rlist&0x002){
    put_reg(31,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x001){
    put_reg(30,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x004){
    put_reg(29,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x008){
    put_reg(28,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x100){
    put_reg(27,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x200){
    put_reg(26,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  } 
  if(rlist&0x400){
    put_reg(25,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x800){
    put_reg(24,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x010){
    put_reg(23,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
 if(rlist&0x020){
    put_reg(22,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x040){
    put_reg(21,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  if(rlist&0x080){
    put_reg(20,get_mem(addr&0xfffffffc,WORD));
    addr += 4;
  }
  put_reg(3,addr);
  if(rs3!=0){
    PC = get_reg(rs3);
    already_npc_set |= 1;
  }
}

static void do_ldsr(int id, int val)
{
  if(id==31){
    BSEL = val;
    return;
  }
  if(BSEL==0){
    switch(id){
    case 5:/* PSW */
      PSW = val;
      Z_flag  = (val&0x01)? 1:0;
      S_flag  = (val&0x02)? 1:0;
      OV_flag = (val&0x04)? 1:0;
      CY_flag = (val&0x08)? 1:0;
      SAT_flag = (val&0x10)? 1:0;
      break;
    case 16:/* CTPC */
      CTPC = val;
      break;
    case 17:/* CTPSW */
      CTPSW = val;
      break;
    case 20:/* CTBP */
      CTBP = val;
      break;
    default:
      /* not implemented */
      break;
    }
  }
  else{
    /* not implemented */
  }
}

static void do_stsr(int id, int reg)
{
  if(id==31){
    put_reg(reg,BSEL);
    return;
  }
  if(BSEL==0){
    switch(id){
    case 5:/* PSW */
      put_reg(reg,
	      (PSW&0xffffffe0)
	      |(SAT_flag<<4)
	      |(CY_flag<<3)
	      |(OV_flag<<2)
	      |(S_flag<<1)
	      |Z_flag);
      break;
    case 16:/* CTPC */
      put_reg(reg, CTPC);
      break;
    case 17:/* CTPSW */
      put_reg(reg, CTPSW);
      break;
    case 20:/* CTBP */
      put_reg(reg, CTBP);
      break;
    default:
      /* not implemented */
      break;
    }
  }
  else{
    /* not implemented */
  }
}


static int get_value(int n)
{
  if(n==0)
    return 0;
  if((n>=1)&&(n<=31))
    return get_reg(n);
  if(n==IMMD)
    return immd;
  if(n==NXT_PC)
    return PC+inst_len;
  if(n==CUR_PC)
    return PC;
  return 0;
}

static void put_value(int n, int v)
{
  if((n>=1)&&(n<=31)){
    put_reg(n,v);
  }
}

static int cond_check()
{
  switch(cond){
  case 0x0:
    return (OV_flag==1);
  case 0x8:
    return (OV_flag==0);
  case 0x1:
    return (CY_flag==1);
  case 0x9:
    return (CY_flag==0);
  case 0x2:
    return (Z_flag==1);
  case 0xa:
    return (Z_flag==0);
  case 0x3:
    return ((CY_flag|Z_flag)==1);
  case 0xb:
    return ((CY_flag|Z_flag)==0);
  case 0x4:
    return (S_flag==1);
  case 0xc:
    return (S_flag==0);
  case 0x5:
    return 1;
  case 0xd:
    return (SAT_flag==1);
  case 0x6:
    return ((S_flag^OV_flag)==1);
  case 0xe:
    return ((S_flag^OV_flag)==0);
  case 0x7:
    return (((S_flag^OV_flag)|Z_flag)==1);
  case 0xf:
    return (((S_flag^OV_flag)|Z_flag)==0);
  }
}

void execute(void)
{
  unsigned int us1,us2;
  int hh,hl,lh,ll;
  v_src1 = get_value(rs1);
  v_src2 = get_value(rs2);
  v_src3 = get_value(rs3);
  us1 = (unsigned int)v_src1;
  us2 = (unsigned int)v_src2;
  already_npc_set=0;

  switch(OP){
  case EADD:
    v_dst = v_src2 + v_src1;
    //    printf("%08x + %08x = %08x\n",v_src2,v_src1,v_dst);
    break;
  case MOV:
    v_dst = v_src2;
    break;
  case NOT:
    v_dst = ~v_src2;
    OV_flag = 0;
    S_flag  = (v_dst&0x80000000)? 1: 0;
    Z_flag  = (v_dst==0)? 1: 0;
    break;
  case ADD:
    v_dst = IADD32(v_src2, v_src1, 0, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    break;
  case SUB:
    v_dst = ISUB32(v_src2, v_src1, 0, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    CY_flag ^= 1;
    break;
  case MUL:
    IMUL32(v_src1, v_src2, &v_dst2, &v_dst);
    put_reg(rs2,v_dst);
    put_reg(rs3,v_dst2);
    break;
  case MULU:
    IMULU32(v_src1, v_src2, &v_dst2, &v_dst);
    put_reg(rs2,v_dst);
    put_reg(rs3,v_dst2);
    break;
  case MULH:
    IMULU32(v_src1&0xffff, v_src2&0xffff, &v_dst2, &v_dst);
    break;
  case MAC:
    IMUL32(v_src1, v_src2, &v_dst2, &v_dst);
    IADD64(v_dst2, v_dst,  get_reg(rs3+1), v_src3, &v_dst2, &v_dst);
    put_reg(rs4+0,v_dst);
    put_reg(rs4+1,v_dst2);
    break;
  case MACU:
    IMULU32(v_src1, v_src2, &v_dst2, &v_dst);
    IADD64(v_dst2, v_dst,  get_reg(rs3+1), v_src3, &v_dst2, &v_dst);
    put_reg(rs4+0,v_dst);
    put_reg(rs4+1,v_dst2);
    break;
  case DIV:
  case DIVQ:
    if(v_src1==0){
      OV_flag = 1;
      S_flag = 1;
      Z_flag = 0;
      put_reg(rs2,-1);
      put_reg(rs3,v_src2);
    }
    else{
      v_dst = v_src2 / v_src1;
      v_dst2= v_src2 % v_src1;
      OV_flag = 0;
      S_flag = (v_dst&0x80000000)? 1 : 0;
      Z_flag = (v_dst==0)? 1 : 0;
      put_reg(rs2,v_dst);
      put_reg(rs3,v_dst2);
    }
    break;
  case DIVU:
  case DIVQU:
    if(us1==0){
      OV_flag = 1;
      S_flag = 1;
      Z_flag = 0;
      put_reg(rs2,-1);
      put_reg(rs3,v_src2);
    }
    else{
      v_dst = us2 / us1;
      v_dst2= us2 % us1;
      OV_flag = 0;
      S_flag = (v_dst&0x80000000)? 1 : 0;
      Z_flag = (v_dst==0)? 1 : 0;
      put_reg(rs2,v_dst);
      put_reg(rs3,v_dst2);
    }
    break;
  case DIVH:
    if(v_src1==0){
      OV_flag = 1;
      S_flag = 1;
      Z_flag = 0;
      put_reg(rs2,-1);
      put_reg(rs3,v_src2);
    }
    else{
      v_src1 = (v_src1&0x8000)? 0xffff0000|v_src1 : v_src1&0xffff;
      v_dst = v_src2 / v_src1;
      v_dst2= v_src2 % v_src1;
      OV_flag = 0;
      S_flag = (v_dst&0x80000000)? 1 : 0;
      Z_flag = (v_dst==0)? 1 : 0;
      put_reg(rs2,v_dst);
      put_reg(rs3,v_dst2);
    }
    break;
  case DIVHU:
    if(us1==0){
      OV_flag = 1;
      S_flag = 1;
      Z_flag = 0;
      put_reg(rs2,-1);
      put_reg(rs3,v_src2);
    }
    else{
      us1 &= 0xffff;
      v_dst = us2 / us1;
      v_dst2= us2 % us1;
      OV_flag = 0;
      S_flag = (v_dst&0x80000000)? 1 : 0;
      Z_flag = (v_dst==0)? 1 : 0;
      put_reg(rs2,v_dst);
      put_reg(rs3,v_dst2);
    }
    break;
  case AND:
    v_dst = v_src1 & v_src2;
    OV_flag = 0;
    S_flag = (v_dst&0x80000000)? 1 : 0;
    Z_flag = (v_dst==0)? 1 : 0;
    break;
  case OR:
    v_dst = v_src1 | v_src2;
    OV_flag = 0;
    S_flag = (v_dst&0x80000000)? 1 : 0;
    Z_flag = (v_dst==0)? 1 : 0;
    break;
  case XOR:
    v_dst = v_src1 ^ v_src2;
    OV_flag = 0;
    S_flag = (v_dst&0x80000000)? 1 : 0;
    Z_flag = (v_dst==0)? 1 : 0;
    break;
  case SASF:
    v_dst = (v_src1<<1)|cond_check();
    break;
  case SLL:
  case SRA:
  case SRL:
    v_dst = ISFT32(v_src2, v_src1&0x1f, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    break;
  case BSH:
    hh = (v_src2>>24)&0xff;
    hl = (v_src2>>16)&0xff;
    lh = (v_src2>> 8)&0xff;
    ll = (v_src2>> 0)&0xff;
    v_dst = (hl<<24)|(hh>>16)|(ll<<8)|lh;
    CY_flag = (ll==0)||(lh==0);
    OV_flag = 0;
    S_flag  = (v_dst&0x80000000)? 1 : 0;
    Z_flag  = (ll==0)&&(lh==0);
    break;
  case BSW:
    hh = (v_src2>>24)&0xff;
    hl = (v_src2>>16)&0xff;
    lh = (v_src2>> 8)&0xff;
    ll = (v_src2>> 0)&0xff;
    v_dst = (ll<<24)|(lh>>16)|(hl<<8)|hh;
    CY_flag = (ll==0)||(lh==0)||(hl==0)||(hh==0);
    OV_flag = 0;
    S_flag  = (v_dst&0x80000000)? 1 : 0;
    Z_flag  = (ll==0)&&(lh==0)&&(hl==0)&&(hh==0);
    break;
  case HSH:
    v_dst = v_src2;
    CY_flag = ((v_dst&0x0000ffff)==0)? 1: 0;
    OV_flag = 0;
    S_flag  = (v_dst&0x80000000)? 1 : 0;
    Z_flag  = ((v_dst&0x0000ffff)==0)? 1: 0;
    break;
  case HSW:
    hh = (v_src2>>16)&0xffff;
    ll = (v_src2>> 0)&0xffff;
    v_dst = (ll<<16)|hh;
    CY_flag = (hh==0)||(ll==0);
    OV_flag = 0;
    S_flag  = (v_dst&0x80000000)? 1 : 0;
    Z_flag  = (hh==0)&&(ll==0);
    break;
  case CALLT:
    CTPC  = PC+2;
    CTPSW = (PSW&0xffffffe0)
      |(SAT_flag<<4)
      |(CY_flag<<3)
      |(OV_flag<<2)
      |(S_flag<<1)
      |Z_flag;
    v_dst = CTBP + immd;
    PC = CTBP + get_mem(v_dst,HWORD)&0xffff;
    already_npc_set |= 1;
    break;
  case SWITCH:
    v_dst = PC+2+(v_src1<<1);
    v_dst2 = get_mem(v_dst, HWORD);
    v_dst2 = (v_dst&0x8000)? 0xffff0000|v_dst: v_dst&0xffff;
    PC = (PC+2)+(v_dst<<1);
    already_npc_set |= 1;
    break;
  case CMOV:
    v_dst = (cond_check())? v_src1 : v_src2;
    break;
  case CAXI:
    v_dst = get_mem(v_src1&0xfffffffc,WORD);
    v_dst2 = ISUB32(v_src2, v_dst, 0, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    CY_flag ^= 1;
    if(v_dst2==0){
      put_mem(v_src1&0xfffffffc,v_src3,WORD);
      put_reg(rs3,v_dst);
    }
    else{
      put_mem(v_src1&0xfffffffc,v_dst,WORD);
      put_reg(rs3,v_dst);
    }
    break;
  case LDSR:
    do_ldsr(v_src1,v_src2);
    break;
  case STSR:
    do_stsr(v_src1,rs2);
    break;
  case PREPARE:
    do_prepare();
    break;
  case DISPOSE:
    do_dispose();
    break;
  case SATADD:
    v_dst = IADD32(v_src2, v_src1, 0, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    SAT_flag = OV_flag;
    if(S_flag)
      v_dst = 0x7fffffff;
    else
      v_dst = 0x80000000;
    break;
  case SATSUB:
    v_dst = ISUB32(v_src2, v_src1, 0, &S_flag, &Z_flag, &CY_flag, &OV_flag);
    CY_flag ^= 1;
    SAT_flag = OV_flag;
    if(S_flag)
      v_dst = 0x7fffffff;
    else
      v_dst = 0x80000000;
    break;
  case ADF:
    v_dst = IADD32(v_src2, v_src1, cond_check(), &S_flag, &Z_flag, &CY_flag, &OV_flag);
    break;
  case SBF:
    v_dst = ISUB32(v_src2, v_src1, cond_check(), &S_flag, &Z_flag, &CY_flag, &OV_flag);
    CY_flag ^= 1;
    break;
  case SETF:
    v_dst = cond_check();
    break;
  case SCH0L:
    for(v_dst=0;v_dst<32;v_dst++){
      if((v_src2 & (1<<(31-v_dst)))==0)
	break;
    }
    if(v_dst>=32){
      v_dst = 0;
      Z_flag = 1;
    }
    else{
      v_dst++;
      Z_flag = 0;
    }
    if(v_dst==32){
      CY_flag = 1;
    }
    else{
      CY_flag = 0;
    }
    OV_flag = 0;
    S_flag = 0;
    break;
  case SCH0R:
    for(v_dst=0;v_dst<32;v_dst++){
      if((v_src2 & (1<<v_dst))==0)
	break;
    }
    if(v_dst>=32){
      v_dst = 0;
      Z_flag = 1;
    }
    else{
      v_dst++;
      Z_flag = 0;
    }
    if(v_dst==32){
      CY_flag = 1;
    }
    else{
      CY_flag = 0;
    }
    OV_flag = 0;
    S_flag = 0;
    break;
  case SCH1L:
    for(v_dst=0;v_dst<32;v_dst++){
      if((v_src2 & (1<<(31-v_dst)))!=0)
	break;
    }
    if(v_dst>=32){
      v_dst = 0;
      Z_flag = 1;
    }
    else{
      v_dst++;
      Z_flag = 0;
    }
    if(v_dst==32){
      CY_flag = 1;
    }
    else{
      CY_flag = 0;
    }
    OV_flag = 0;
    S_flag = 0;
    break;
  case SCH1R:
    for(v_dst=0;v_dst<32;v_dst++){
      if((v_src2 & (1<<v_dst))!=0)
	break;
    }
    if(v_dst>=32){
      v_dst = 0;
      Z_flag = 1;
    }
    else{
      v_dst++;
      Z_flag = 0;
    }
    if(v_dst==32){
      CY_flag = 1;
    }
    else{
      CY_flag = 0;
    }
    OV_flag = 0;
    S_flag = 0;
    break;
  case SEX:
    if(msize==BYTE){
      v_dst = (v_src2&0x80)? 0xffffff00|v_src2 : v_src2&0xff;
    }
    else{
      v_dst = (v_src2&0x8000)? 0xffff0000|v_src2 : v_src2&0xffff;
    }
    break;
  case ZEX:
    if(msize==BYTE){
      v_dst = v_src2&0xff;
    }
    else{
      v_dst = v_src2&0xffff;
    }
    break;
  }

  put_value(rd, v_dst);

  switch(OP2){
  case SET1:
  	if(immd2&0x100){
		immd2 = get_reg(immd2-0x100)&0x7;
	}
    v_dst2 = get_mem(v_dst, BYTE);
    Z_flag = (v_dst2&(1<<immd2))? 0 : 1;
    v_dst2 |= (1<<immd2);
    put_mem(v_dst,v_dst2, BYTE);
    break;
  case CLR1:
  	if(immd2&0x100){
		immd2 = get_reg(immd2-0x100)&0x7;
	}
    v_dst2 = get_mem(v_dst, BYTE);
    Z_flag = (v_dst2&(1<<immd2))? 0 : 1;
    v_dst2 &= ~(1<<immd2);
    put_mem(v_dst,v_dst2, BYTE);
    break;
  case NOT1:
  	if(immd2&0x100){
		immd2 = get_reg(immd2-0x100)&0x7;
	}
    v_dst2 = get_mem(v_dst, BYTE);
    Z_flag = (v_dst2&(1<<immd2))? 0 : 1;
    v_dst2 ^= (1<<immd2);
    put_mem(v_dst,v_dst2, BYTE);
    break;
  case TST1:
  	if(immd2&0x100){
		immd2 = get_reg(immd2-0x100)&0x7;
	}
    v_dst2 = get_mem(v_dst, BYTE);
    Z_flag = (v_dst2&(1<<immd2))? 0 : 1;
    break;
  case CTRET:
    PC  = CTPC;
    PSW = (PSW&0xffffffe0)
      |(SAT_flag<<4)
      |(CY_flag<<3)
      |(OV_flag<<2)
      |(S_flag<<1)
      |Z_flag;
    already_npc_set |= 1;
    break;
  case JARL:
    PC = v_dst;
    put_reg(rd, v_src3);
    already_npc_set |= 1;
    break;
  case JCC:
    if(cond_check()){
      PC = v_dst;
      already_npc_set |= 1;
    }
    break;
  case JMP:
  case JPR:
    PC = v_dst;
    already_npc_set |= 1;
    break;
  case LD:
    if(msize==WORD){
      put_value(rd,get_mem(v_dst,WORD));
    }
    else if(msize==HWORD){
      int d;
      d = get_mem(v_dst,HWORD);
      if(msex){
	d = (d&0x8000)? 0xffff0000|d : d &0xffff;
      }
      else{
	d = d &0xffff;
      }
      put_value(rd,d);
    }
    else{
      int d;
      d = get_mem(v_dst,BYTE);
      if(msex){
	d = (d&0x80)? 0xffffff00|d : d &0xff;
      }
      else{
	d = d &0xff;
      }
      put_value(rd,d);
    }
    break;
  case ST:
    if(msize==WORD){
      put_mem(v_dst,v_src3,WORD);
    }
    else if(msize==HWORD){
      put_mem(v_dst,v_src3,HWORD);
    }
    else{
      put_mem(v_dst,v_src3,BYTE);
    }
    break;
  case DI:
    PSW &= ~0x20;
    break;
  case EI:
    PSW |= 0x20;
    break;
  case HALT:
  case SYSCALL:
  case TRAP:
  case RIE:
  case EIRET:
  case FERET:
  case RETI:
  case EXP:
    break;
  }
  if(already_npc_set==0){
    PC += inst_len;
  PC_BAK = PC;
  }
}
