#include <stdio.h>
#include <string.h>
#include <signal.h>
#include "define.h"
extern char *__version;
static FILE *fp;
static char cmd[100];
static char av1[100];
static char av2[100];
static char lin[1024];
static int  trace_num;
static int  da0,da1;

static int   bp_a;
static int   bp_a_v = 0;
static char  bp_a_msg[256]="Break_on_Address";

static int   disp_inst=1;
static int   disp_regs=1;

static int   sig_occur=0;

extern int mem_ovf;

extern int PC;
extern int PC_BAK;

static void version(void)
{
  printf("****************************************************\n");
  printf("*   V850E2 Simulator (%20s) *\n",__version);
  printf("****************************************************\n");
  printf("\n");
}

static void help(void)
{
  printf("q                        ... quit form simulator\n");
  printf("t      [times]           ... trace\n");
  printf("u      addr1 addr2       ... disassemble\n");
  printf("li     fname             ... load index hex file\n");
  printf("ls     fname             ... load motorola hex file\n");
  printf("le     fname             ... load ELF file\n");
  printf("s      reg_no value      ... register set\n");
  printf("r                        ... register dump\n");
  printf("disp   [inst|regs|all]   ... display instruction or registers\n");
  printf("nodisp [inst|regs|all]   ... don't display instruction or registers\n");
  printf("ba     addr              ... set breakpoint by address\n");
  printf("m      addr  data        ... set memory value\n");
  printf("dw     addr1 addr2       ... dump memory by word\n");
  printf("dh     addr1 addr2       ... dump memory by halfword\n");
  printf("db     addr1 addr2       ... dump memory by byte\n");
  printf("h                        ... display this message\n");
  printf("\n");
}

static void sig_handler()
{
  sig_occur=1;
  signal(SIGINT, sig_handler);
}


static int white(int ch)
{
  return (ch==' ')||(ch=='\t');
}

static int eol(int ch)
{
  return (ch=='\0')||(ch=='\n')||(ch=='\r');
}

static int split(void)
{
  char *p;
  char *q;

  signal(SIGINT, sig_handler);

  cmd[0] = '\0';
  av1[0] = '\0';
  av2[0] = '\0';
  p = &lin[0];
  while(white(*p))
    p++;
  if(eol(*p))
    return 0;
  q = &cmd[0];
  while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  if(eol(*p))
    return 1;
  while(white(*p))
    p++;
  if(eol(*p))
    return 1;
  q = &av1[0];
  while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  if(eol(*p))
    return 2;
  while(white(*p))
    p++;
  if(eol(*p))
    return 2;
  q = &av2[0];
    while(!(white(*p)||eol(*p)))
    *q++ = *p++;
  *q = '\0';
  return 3;
}

static int break_cond(void)
{
  if(PC<0)
    return 1;
  if(bp_a_v){
    if(PC==bp_a){
      printf("%08x %s\n", bp_a,bp_a_msg);
      return 1;
    }
  }
  if(sig_occur){
    sig_occur = 0;
    return 1;
  }
  return 0;
}

int main(void)
{
  int ac;
  unsigned int adr0,adr1;

  version();
#if 0
  help();
#endif
  while(1){
    printf("? "); fflush(stdout);
    if(fgets(lin,1024,stdin)==0)
      break;
    ac = split();
    if(ac==0)
      continue;
    if(strcmp(cmd,"q")==0){/* quit */
      break;
    }
    if(strcmp(cmd,"t")==0){/* trace */
      int addr1,addr0;
      int  i;
      int  n;
      if(ac==1){
	if(disp_inst){
	  printf("(%d) ", trace_num);
	  disasm((unsigned int)PC,(unsigned int)PC);
	}
        instruction();
	if(disp_regs){
	  reg_dump();
	}
	if(disp_inst||disp_regs){
	  printf("-----------------------------\n");
	}
	trace_num++;
      }
      else{
	if(strcmp(av1,"max")==0){
	  n=0x7fffffff;
	}
	else{
	  sscanf(av1,"%d",&n);
	}
	for(i=0;i<n;i++){
	  if(disp_inst){
	    printf("(%d) ", trace_num);
	    disasm((unsigned int)PC,(unsigned int)PC);
	  }
	  instruction();
	  if(disp_regs){
	    reg_dump();
	  }
	  if(disp_inst||disp_regs){
	    printf("-----------------------------\n");
	  }
	  trace_num++;
	  if(break_cond()||mem_ovf){
	    printf("trace num=%d %08x\n",trace_num,PC_BAK);
	    break;
	  }
	}
      }
    }
    if(strcmp(cmd,"u")==0){/* disassemble */
      sscanf(av1,"%x",&adr0);
      sscanf(av2,"%x",&adr1);
      disasm(adr0,adr1);
    }
    if(strcmp(cmd,"li")==0){/* load intel hex */
      loadi(av1,av2);
    }
    if(strcmp(cmd,"ls")==0){/* load s-format hex */
      loads(av1,av2);
    }
    if(strcmp(cmd,"le")==0){/* load elf image */
      loade(av1);
    }
    if(strcmp(cmd,"r")==0){/* register dump */
	reg_dump();
    }
    if(strcmp(cmd,"s")==0){/* register dump */
      if(ac==3){
	sscanf(av2,"%x",&adr1);
	if((strcmp(av1,"pc")==0)||(strcmp(av1,"PC")==0)){
	  PC = adr1;
	}
	else{
	  sscanf(av1,"%d",&adr0);
	  put_reg((int)adr0,(int)adr1);
	}
      }
    }
    if(strcmp(cmd,"ba")==0){/* address break 0 */
      if(ac==1)
	bp_a_v ^= 1;
      else {
	sscanf(av1,"%x",&bp_a);
	strcpy(bp_a_msg,av2);
	bp_a_v = 1;
      }
    }
    if(strcmp(cmd,"m")==0){/* memory change */
      if(ac==3){
	sscanf(av1,"%x",&adr0);
	sscanf(av2,"%x",&adr1);
	put_word(adr0,adr1);
      }
    }
    if(strcmp(cmd,"disp")==0){/* memory change */
      if(ac==2){
	if(strcmp(av1,"all")==0){
	  disp_inst = 1;
	  disp_regs = 1;
	}
	else if(strcmp(av1,"inst")==0){
	  disp_inst = 1;
	}
	else if(strcmp(av1,"regs")==0){
	  disp_regs = 1;
	}
      }
    }
    if(strcmp(cmd,"nodisp")==0){/* memory change */
      if(ac==2){
	if(strcmp(av1,"all")==0){
	  disp_inst = 0;
	  disp_regs = 0;
	}
	else if(strcmp(av1,"inst")==0){
	  disp_inst = 0;
	}
	else if(strcmp(av1,"regs")==0){
	  disp_regs = 0;
	}
      }
    }
    if(strcmp(cmd,"dw")==0){/* memory dump word */
      if(ac==3){
	sscanf(av1,"%x",&da0);
	sscanf(av2,"%x",&da1);
	mem_dump(da0, da1, 2);
      }
      if(ac==2){
	sscanf(av1,"%x",&da0);
	da1 = da0+0x80;
	mem_dump(da0, da1, 2);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 2);
      }
    }
    if(strcmp(cmd,"dh")==0){/* memory dump halfword */
      if(ac==3){
	sscanf(av1,"%x",&da0);
	sscanf(av2,"%x",&da1);
	mem_dump(da0, da1, 1);
      }
      if(ac==2){
	sscanf(av1,"%x",&da0);
	da1 = da0+0x80;
	mem_dump(da0, da1, 1);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 1);
      }
    }
    if(strcmp(cmd,"db")==0){/* memory dump byte */
      if(ac==3){
	sscanf(av1,"%x",&da0);
	sscanf(av2,"%x",&da1);
	mem_dump(da0, da1, 0);
      }
      if(ac==2){
	sscanf(av1,"%x",&da0);
	da1 = da0+0x80;
	mem_dump(da0, da1, 0);
      }
      if(ac==1){
	da0 = da1;
	da1 = da0+0x80;
	mem_dump(da0, da1, 0);
      }
    }
    if(cmd[0]=='#'){/* comment */
    }
    if(strcmp(cmd,"h")==0){/* help */
      help();
    }
  }
  return 0;
}
